2006-12-31  Eric Seidel  <eric@webkit.org>

        Reviewed by weinig.

        Make SVGPathSeg construction take fewer lines of code.

        * WebCore.xcodeproj/project.pbxproj:
        * ksvg2/svg/SVGPathElement.cpp:
        (WebCore::SVGPathElement::createSVGPathSegMovetoAbs):
        (WebCore::SVGPathElement::createSVGPathSegMovetoRel):
        (WebCore::SVGPathElement::createSVGPathSegLinetoAbs):
        (WebCore::SVGPathElement::createSVGPathSegLinetoRel):
        (WebCore::SVGPathElement::createSVGPathSegCurvetoCubicAbs):
        (WebCore::SVGPathElement::createSVGPathSegCurvetoCubicRel):
        (WebCore::SVGPathElement::createSVGPathSegCurvetoQuadraticAbs):
        (WebCore::SVGPathElement::createSVGPathSegCurvetoQuadraticRel):
        (WebCore::SVGPathElement::createSVGPathSegArcAbs):
        (WebCore::SVGPathElement::createSVGPathSegArcRel):
        (WebCore::SVGPathElement::createSVGPathSegLinetoHorizontalAbs):
        (WebCore::SVGPathElement::createSVGPathSegLinetoHorizontalRel):
        (WebCore::SVGPathElement::createSVGPathSegLinetoVerticalAbs):
        (WebCore::SVGPathElement::createSVGPathSegLinetoVerticalRel):
        (WebCore::SVGPathElement::createSVGPathSegCurvetoCubicSmoothAbs):
        (WebCore::SVGPathElement::createSVGPathSegCurvetoCubicSmoothRel):
        (WebCore::SVGPathElement::createSVGPathSegCurvetoQuadraticSmoothAbs):
        (WebCore::SVGPathElement::createSVGPathSegCurvetoQuadraticSmoothRel):
        * ksvg2/svg/SVGPathSegArc.cpp:
        (WebCore::SVGPathSegArcAbs::SVGPathSegArcAbs):
        (WebCore::SVGPathSegArcRel::SVGPathSegArcRel):
        * ksvg2/svg/SVGPathSegArc.h:
        * ksvg2/svg/SVGPathSegCurvetoCubic.cpp:
        (WebCore::SVGPathSegCurvetoCubicAbs::SVGPathSegCurvetoCubicAbs):
        (WebCore::SVGPathSegCurvetoCubicRel::SVGPathSegCurvetoCubicRel):
        * ksvg2/svg/SVGPathSegCurvetoCubic.h:
        * ksvg2/svg/SVGPathSegCurvetoCubicSmooth.cpp:
        (WebCore::SVGPathSegCurvetoCubicSmoothAbs::SVGPathSegCurvetoCubicSmoothAbs):
        (WebCore::SVGPathSegCurvetoCubicSmoothRel::SVGPathSegCurvetoCubicSmoothRel):
        * ksvg2/svg/SVGPathSegCurvetoCubicSmooth.h:
        * ksvg2/svg/SVGPathSegCurvetoQuadratic.cpp:
        (WebCore::SVGPathSegCurvetoQuadraticAbs::SVGPathSegCurvetoQuadraticAbs):
        (WebCore::SVGPathSegCurvetoQuadraticRel::SVGPathSegCurvetoQuadraticRel):
        * ksvg2/svg/SVGPathSegCurvetoQuadratic.h:
        * ksvg2/svg/SVGPathSegCurvetoQuadraticSmooth.cpp:
        (WebCore::SVGPathSegCurvetoQuadraticSmoothAbs::SVGPathSegCurvetoQuadraticSmoothAbs):
        (WebCore::SVGPathSegCurvetoQuadraticSmoothRel::SVGPathSegCurvetoQuadraticSmoothRel):
        * ksvg2/svg/SVGPathSegCurvetoQuadraticSmooth.h:
        * ksvg2/svg/SVGPathSegLineto.cpp:
        (WebCore::SVGPathSegLinetoAbs::SVGPathSegLinetoAbs):
        (WebCore::SVGPathSegLinetoRel::SVGPathSegLinetoRel):
        * ksvg2/svg/SVGPathSegLineto.h:
        * ksvg2/svg/SVGPathSegLinetoHorizontal.cpp:
        (WebCore::SVGPathSegLinetoHorizontalAbs::SVGPathSegLinetoHorizontalAbs):
        (WebCore::SVGPathSegLinetoHorizontalRel::SVGPathSegLinetoHorizontalRel):
        * ksvg2/svg/SVGPathSegLinetoHorizontal.h:
        * ksvg2/svg/SVGPathSegLinetoVertical.cpp:
        (WebCore::SVGPathSegLinetoVerticalAbs::SVGPathSegLinetoVerticalAbs):
        (WebCore::SVGPathSegLinetoVerticalRel::SVGPathSegLinetoVerticalRel):
        * ksvg2/svg/SVGPathSegLinetoVertical.h:
        * ksvg2/svg/SVGPathSegMoveto.cpp:
        (WebCore::SVGPathSegMovetoAbs::SVGPathSegMovetoAbs):
        (WebCore::SVGPathSegMovetoRel::SVGPathSegMovetoRel):
        * ksvg2/svg/SVGPathSegMoveto.h:

2006-12-31  Eric Seidel  <eric@webkit.org>

        Reviewed by weinig.

        Implement path length measuring for SVGPathElement::getTotalLength and friends.
        http://bugs.webkit.org/show_bug.cgi?id=12033

        * WebCore.xcodeproj/project.pbxproj:
        * ksvg2/svg/SVGPathElement.cpp:
        (WebCore::SVGPathElement::getTotalLength):
        (WebCore::SVGPathElement::getPointAtLength):
        * platform/graphics/Path.cpp:
        (WebCore::pathLengthApplierFunction):
        (WebCore::Path::length):
        (WebCore::Path::pointAtLength):
        * platform/graphics/Path.h:
        * platform/graphics/PathTraversalState.cpp: Added.
        (WebCore::midPoint):
        (WebCore::distanceLine):
        (WebCore::QuadraticBezier::QuadraticBezier):
        (WebCore::QuadraticBezier::approximateDistance):
        (WebCore::QuadraticBezier::split):
        (WebCore::CubicBezier::CubicBezier):
        (WebCore::CubicBezier::approximateDistance):
        (WebCore::CubicBezier::split):
        (WebCore::curveLength):
        (WebCore::PathTraversalState::PathTraversalState):
        (WebCore::PathTraversalState::closeSubpath):
        (WebCore::PathTraversalState::moveTo):
        (WebCore::PathTraversalState::lineTo):
        (WebCore::PathTraversalState::quadraticBezierTo):
        (WebCore::PathTraversalState::cubicBezierTo):
        * platform/graphics/PathTraversalState.h: Added.
        (WebCore::PathTraversalState::):

2006-12-31  Sam Weinig  <sam@webkit.org>

        Reviewed by Mitz.

        Move the SVGZoomAndPanType enum out of SVGSVGElement and
        SVGViewElement and into SVGZoomAndPan where it belongs.

        * ksvg2/svg/SVGSVGElement.h:
        * ksvg2/svg/SVGViewElement.h:
        * ksvg2/svg/SVGZoomAndPan.cpp:
        (WebCore::SVGZoomAndPan::SVGZoomAndPan):
        (WebCore::SVGZoomAndPan::parseMappedAttribute):
        * ksvg2/svg/SVGZoomAndPan.h:
        (WebCore::SVGZoomAndPan::):

2006-12-31  Mitz Pettel  <mitz@webkit.org>

        Reviewed by Hyatt.

        - fix http://bugs.webkit.org/show_bug.cgi?id=9659
          Quirksmode: Fixed / Overflow > Positioned objects get hidden when scrolling

        Added a 'fixed' flag to ClipRects, indicating that the cached rects are in
        viewport coordinates. The flag is set (and scrolling is compensated for) for
        fixed objects and their descendants.

        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::calculateClipRects):
        (WebCore::RenderLayer::calculateRects):
        * rendering/RenderLayer.h:
        (WebCore::ClipRects::ClipRects):
        (WebCore::ClipRects::fixed):

2006-12-31  Mitz Pettel  <mitz@webkit.org>

        Reviewed by Sam.

        - fix http://bugs.webkit.org/show_bug.cgi?id=12037
          For relatively positioned boxes in an RTL block, 'right' should win over 'left' if both are not 'auto'

        Test: fast/block/positioning/relative-overconstrained.html

        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::relativePositionOffsetX):

2006-12-30  Rob Buis  <buis@kde.org>

        Reviewed by Eric.

        http://bugs.webkit.org/show_bug.cgi?id=12004
        Webkit doesnt handle omitting M at the start of path syntax well

        Improve path parsing error handling.

        * WebCore.xcodeproj/project.pbxproj:
        * ksvg2/svg/SVGLength.cpp:
        (WebCore::SVGLength::setValueAsString):
        * ksvg2/svg/SVGParserUtilities.cpp:
        (WebCore::SVGPathParser::parseSVG):
        * ksvg2/svg/SVGParserUtilities.h:
        * ksvg2/svg/SVGPathElement.cpp:
        (WebCore::SVGPathElement::SVGPathElement):
        (WebCore::SVGPathElement::parseMappedAttribute):
        * ksvg2/svg/SVGPathElement.h:
        * ksvg2/svg/SVGPolyElement.cpp:
        (WebCore::SVGPolyElement::parseMappedAttribute):
        * ksvg2/svg/SVGPolyElement.h:
        * ksvg2/svg/svgpathparser.cpp: Removed.
        * ksvg2/svg/svgpathparser.h: Removed.

2006-12-30  Rémi Zara  <remi_zara@mac.com>

        Reviewed by Darin.

        The marker is used for start, mid and end.

        * ksvg2/css/SVGCSSParser.cpp:
        (WebCore::CSSParser::parseSVGValue):

2006-12-30  Rob Buis  <buis@kde.org>

        Reviewed by weinig.

        http://bugs.webkit.org/show_bug.cgi?id=12035
        Use SVGParserUtilities in lists of values

        Use SVGParserUtilities in some more places.

        * ksvg2/svg/SVGAnimationElement.cpp:
        (WebCore::SVGAnimationElement::parseMappedAttribute):
        (WebCore::SVGAnimationElement::parseClockValue):
        (WebCore::SVGAnimationElement::detectAnimationMode):
        * ksvg2/svg/SVGFEDiffuseLightingElement.cpp:
        (WebCore::SVGFEDiffuseLightingElement::parseMappedAttribute):
        * ksvg2/svg/SVGFEDiffuseLightingElement.h:
        * ksvg2/svg/SVGFEGaussianBlurElement.cpp:
        (WebCore::SVGFEGaussianBlurElement::parseMappedAttribute):
        * ksvg2/svg/SVGFEGaussianBlurElement.h:
        * ksvg2/svg/SVGFESpecularLightingElement.cpp:
        (WebCore::SVGFESpecularLightingElement::parseMappedAttribute):
        * ksvg2/svg/SVGFESpecularLightingElement.h:
        * ksvg2/svg/SVGFETurbulenceElement.cpp:
        (WebCore::SVGFETurbulenceElement::parseMappedAttribute):
        * ksvg2/svg/SVGFETurbulenceElement.h:
        * ksvg2/svg/SVGLengthList.cpp:
        (WebCore::SVGLengthList::parse):
        * ksvg2/svg/SVGNumberList.cpp:
        (WebCore::SVGNumberList::parse):
        * ksvg2/svg/SVGNumberList.h:
        * ksvg2/svg/SVGStringList.cpp:
        (WebCore::SVGStringList::reset):
        (WebCore::SVGStringList::parse):
        * ksvg2/svg/SVGStringList.h:

2006-12-30  Rob Buis  <buis@kde.org>

        Reviewed by weinig.

        http://bugs.webkit.org/show_bug.cgi?id=12034
        Adapt preserveAspectRatio parsing to SVGParserUtilities

        Use the new SVGParserUtilities methods to parse prserveAspectRatio attribute.

        * ksvg2/svg/SVGParserUtilities.h:
        (WebCore::checkString):
        * ksvg2/svg/SVGPreserveAspectRatio.cpp:
        (WebCore::):
        (WebCore::SVGPreserveAspectRatio::parsePreserveAspectRatio):
        * ksvg2/svg/SVGTransformable.cpp:

2006-12-30  Mitz Pettel  <mitz@webkit.org>

        Reviewed by Alexey.

        - remove unused member variables m_loadingSheet and m_bAllDataReceived

        No test possible (no change to functionality).

        * dom/Document.cpp:
        (WebCore::Document::Document):
        (WebCore::Document::setCSSStyleSheet):
        * dom/Document.h:

2006-12-30  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Mitz.

        http://bugs.webkit.org/show_bug.cgi?id=11998
        Incorrect serialization of quotation marks in XML attributes.

        Test: fast/dom/serialize-attribute.xhtml

        * editing/markup.cpp:
        (WebCore::escapeTextForMarkup): Added an isAttributeValue parameter, as the quotation mark
        only needs to be encoded in attribute values.
        (WebCore::startMarkup): Pass appropriate isAttributeValue to escapeTextForMarkup().

2006-12-29  David Kilzer  <ddkilzer@webkit.org>

        Build fix for no-svg build.

        Change #if SVG_SUPPORT to #ifdef SVG_SUPPORT.

        * bindings/js/kjs_css.cpp:
        (KJS::toJS):
        * loader/CachedImage.cpp:
        (WebCore::CachedImage::createImage):

2006-12-29  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Brian Dash... err... Mark Rowe.

        More cleanup in preparation for fixing <rdar://problem/4608404> 
        WebScriptObject's _executionContext lack of ownership policy causes 
        crashes (e.g., in Dashcode)
        
        The key change here is to RootObject::RootObject().
        
        Layout tests pass.
        
        Renamed "_bindingRoot" => "_bindingRootObject" because "RootObject" is the
        type name.
        
        * bindings/objc/WebScriptObject.mm:
        (_didExecute): Use Interpreter::globalObject(), since RootObject::rootObjectImp() 
        no longer exists.

        * page/mac/FrameMac.mm:
        (WebCore::FrameMac::bindingRootObject): Use the new RootObject constructor.
        Stop lying about who deletes _bindingRoot.

        (WebCore::FrameMac::cleanupPluginObjects): => "destroy". Fixed a bug where
        the RootObject would only free its own memory if there were a ReferencesSet*
        associated with it.

        * page/mac/WebCoreFrameBridge.mm:
        (-[WebCoreFrameBridge rootObjectForView:]): Use new constructor. Changed
        misleading comment.

2006-12-29  Rob Buis  <buis@kde.org>

        Reviewed by Eric.

        http://bugs.webkit.org/show_bug.cgi?id=12007
        SVGColor::setRGBColor color creates/deletes many strings, slowing down parsing

        Refactor code so svg reuses cssparser methods. Also make
        SVGColor and SVGPaint more efficient by avoiding using
        setRGBColor internally.

        * bindings/js/kjs_css.cpp:
        (KJS::toJS):
        * css/cssparser.cpp:
        (WebCore::CSSParser::parseColor):
        (WebCore::CSSParser::parseColorFromValue):
        (WebCore::CSSParser::parseShadow):
        * css/cssparser.h:
        * ksvg2/css/SVGCSSParser.cpp:
        (WebCore::CSSParser::parseSVGPaint):
        (WebCore::CSSParser::parseSVGColor):
        * ksvg2/svg/SVGColor.cpp:
        (WebCore::SVGColor::SVGColor):
        (WebCore::SVGColor::setRGBColor):
        (WebCore::SVGColor::cssText):
        * ksvg2/svg/SVGColor.h:
        * ksvg2/svg/SVGPaint.cpp:
        (WebCore::SVGPaint::SVGPaint):
        * ksvg2/svg/SVGPaint.h:
        * platform/graphics/Color.cpp:
        (WebCore::Color::parseHexColor):
        * platform/graphics/Color.h:

2006-12-29  Rob Buis  <buis@kde.org>

        Reviewed by weinig.

        http://bugs.webkit.org/show_bug.cgi?id=12022
        typo in SVGTransformable.cpp introduce in r18440
     
        Use the helper method proposed by Eric.

        * ksvg2/svg/SVGTransformable.cpp:
        (WebCore::checkString):
        (WebCore::):
        (WebCore::SVGTransformable::parseTransformAttribute):

2006-12-29  Rob Buis  <buis@kde.org>

        Reviewed by Eric.

        http://bugs.webkit.org/show_bug.cgi?id=12028
        Adapt viewBox parsing to SVGParserUtilities

        Use the new parseNumber and add tests for viewBox parsing.

        * ksvg2/svg/SVGFitToViewBox.cpp:
        (WebCore::SVGFitToViewBox::parseViewBox):

2006-12-29  Geoffrey Garen  <ggaren@apple.com>

        Build fix: SVGImage only works on Mac.

        * loader/CachedImage.cpp:
        (WebCore::CachedImage::createImage):

2006-12-29  Sam Weinig  <sam@webkit.org>

        Reviewed by Geoff.

        Patch for http://bugs.webkit.org/show_bug.cgi?id=12018
        Cleanup of CSSRule and its subclasses

        - Make CSSRule::type() virtual instead of using a member variable.
        - General style cleanup.

        * WebCore.xcodeproj/project.pbxproj:
        * css/CSSCharsetRule.cpp:
        (WebCore::CSSCharsetRule::CSSCharsetRule):
        * css/CSSCharsetRule.h:
        (WebCore::CSSCharsetRule::isCharsetRule):
        (WebCore::CSSCharsetRule::type):
        * css/CSSFontFaceRule.cpp:
        (WebCore::CSSFontFaceRule::CSSFontFaceRule):
        (WebCore::CSSFontFaceRule::cssText):
        * css/CSSFontFaceRule.h:
        (WebCore::CSSFontFaceRule::isFontFaceRule):
        (WebCore::CSSFontFaceRule::type):
        * css/CSSImportRule.cpp:
        (WebCore::CSSImportRule::CSSImportRule):
        (WebCore::CSSImportRule::setCSSStyleSheet):
        (WebCore::CSSImportRule::insertedIntoParent):
        * css/CSSImportRule.h:
        (WebCore::CSSImportRule::isImportRule):
        (WebCore::CSSImportRule::type):
        * css/CSSMediaRule.cpp:
        (WebCore::CSSMediaRule::CSSMediaRule):
        (WebCore::CSSMediaRule::insertRule):
        (WebCore::CSSMediaRule::deleteRule):
        (WebCore::CSSMediaRule::cssText):
        * css/CSSMediaRule.h:
        (WebCore::CSSMediaRule::isMediaRule):
        (WebCore::CSSMediaRule::type):
        * css/CSSPageRule.cpp:
        (WebCore::CSSPageRule::CSSPageRule):
        (WebCore::CSSPageRule::selectorText):
        (WebCore::CSSPageRule::setSelectorText):
        (WebCore::CSSPageRule::cssText):
        * css/CSSPageRule.h:
        (WebCore::CSSPageRule::style):
        (WebCore::CSSPageRule::type):
        * css/CSSRule.cpp:
        (WebCore::CSSRule::cssText):
        (WebCore::CSSRule::setCssText):
        * css/CSSRule.h:
        (WebCore::CSSRule::):
        (WebCore::CSSRule::CSSRule):
        * css/CSSStyleRule.cpp:
        (WebCore::CSSStyleRule::CSSStyleRule):
        (WebCore::CSSStyleRule::setSelectorText):
        (WebCore::CSSStyleRule::cssText):
        (WebCore::CSSStyleRule::parseString):
        * css/CSSStyleRule.h:
        (WebCore::CSSStyleRule::isStyleRule):
        (WebCore::CSSStyleRule::style):
        (WebCore::CSSStyleRule::type):
        * css/CSSUnknownRule.h:
        (WebCore::CSSUnknownRule::CSSUnknownRule):
        (WebCore::CSSUnknownRule::type):

2006-12-29  Eric Seidel  <eric@webkit.org>

        Reviewed by ap.

        * platform/graphics/svg/SVGImage.cpp:
        (WebCore::SVGImage::size): explicitly cast to integers to prevent compile error

2006-12-29  George Staikos  <staikos@kde.org>

        Reviewed by Sam.

        Don't crash on sites such as www.apple.com.  Painter was ended incorrectly among other issues.

        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::TransparencyLayer::TransparencyLayer):
        (WebCore::TransparencyLayer::cleanup):
        (WebCore::GraphicsContext::endTransparencyLayer):
        * platform/qt/ScrollViewCanvasQt.cpp:
        (WebCore::ScrollViewCanvasQt::paintEvent):

2006-12-29  Nikolas Zimmermann  <zimmermann@kde.org>

        Build fixed, not reviewed. Noticed by Daniel Molkentin.

        * platform/graphics/svg/SVGImage.h: s/WTF/wtf/ in include.

2006-12-29  Eric Seidel  <eric@webkit.org>

        Reviewed by olliej.

        * platform/graphics/svg/SVGImageEmptyClients.h:
        (WebCore::SVGEmptyCromeClient::scaleFactor):  build fix, use 1.f instead of 1f

2006-12-29  Eric Seidel  <eric@webkit.org>

        Reviewed by hyatt.

        New tests:
        * fast/images/svg-as-image.html
        * fast/images/svg-as-background.html
        * fast/images/svg-as-tiled-background.html
        
        Implement basic SVGImage support.
        http://bugs.webkit.org/show_bug.cgi?id=5971
        
        This implementation depends on (rather ugly) stub Page and Frame clients in SVGImageEmptyClients.h

        * WebCore.xcodeproj/project.pbxproj: add SVGImage.*
        * ksvg2/svg/SVGFEImageElement.cpp:
        (WebCore::SVGFEImageElement::parseMappedAttribute): ignore fragment urls
        * loader/CachedImage.cpp:
        (WebCore::CachedImage::createImage):
        * platform/graphics/Image.h: made setData virtual
        * platform/graphics/cg/PDFDocumentImage.cpp:
        (WebCore::PDFDocumentImage::drawTiled): stub method
        * platform/graphics/cg/PDFDocumentImage.h:
        * platform/graphics/svg/SVGImage.cpp: Added.
        (WebCore::SVGImage::SVGImage):
        (WebCore::SVGImage::~SVGImage):
        (WebCore::SVGImage::size):
        (WebCore::SVGImage::draw):
        (WebCore::SVGImage::drawTiled): stub method
        (WebCore::SVGImage::setData):
        * platform/graphics/svg/SVGImage.h: Added.
        (WebCore::SVGImage::frameAtIndex):
        * platform/graphics/svg/SVGImageEmptyClients.h: Added.
        (WebCore::SVGEmptyCromeClient::~SVGEmptyCromeClient):
        (WebCore::SVGEmptyCromeClient::chromeDestroyed):
        (WebCore::SVGEmptyCromeClient::setWindowRect):
        (WebCore::SVGEmptyCromeClient::windowRect):
        (WebCore::SVGEmptyCromeClient::pageRect):
        (WebCore::SVGEmptyCromeClient::scaleFactor):
        (WebCore::SVGEmptyCromeClient::focus):
        (WebCore::SVGEmptyCromeClient::unfocus):
        (WebCore::SVGEmptyCromeClient::createWindow):
        (WebCore::SVGEmptyCromeClient::createModalDialog):
        (WebCore::SVGEmptyCromeClient::show):
        (WebCore::SVGEmptyCromeClient::canRunModal):
        (WebCore::SVGEmptyCromeClient::runModal):
        (WebCore::SVGEmptyCromeClient::setToolbarsVisible):
        (WebCore::SVGEmptyCromeClient::toolbarsVisible):
        (WebCore::SVGEmptyCromeClient::setStatusbarVisible):
        (WebCore::SVGEmptyCromeClient::statusbarVisible):
        (WebCore::SVGEmptyCromeClient::setScrollbarsVisible):
        (WebCore::SVGEmptyCromeClient::scrollbarsVisible):
        (WebCore::SVGEmptyCromeClient::setMenubarVisible):
        (WebCore::SVGEmptyCromeClient::menubarVisible):
        (WebCore::SVGEmptyCromeClient::setResizable):
        (WebCore::SVGEmptyCromeClient::addMessageToConsole):
        (WebCore::SVGEmptyCromeClient::canRunBeforeUnloadConfirmPanel):
        (WebCore::SVGEmptyCromeClient::runBeforeUnloadConfirmPanel):
        (WebCore::SVGEmptyCromeClient::closeWindowSoon):
        (WebCore::SVGEmptyFrameLoaderClient::~SVGEmptyFrameLoaderClient):
        (WebCore::SVGEmptyFrameLoaderClient::frameLoaderDestroyed):
        (WebCore::SVGEmptyFrameLoaderClient::hasWebView):
        (WebCore::SVGEmptyFrameLoaderClient::hasFrameView):
        (WebCore::SVGEmptyFrameLoaderClient::hasBackForwardList):
        (WebCore::SVGEmptyFrameLoaderClient::resetBackForwardList):
        (WebCore::SVGEmptyFrameLoaderClient::provisionalItemIsTarget):
        (WebCore::SVGEmptyFrameLoaderClient::loadProvisionalItemFromPageCache):
        (WebCore::SVGEmptyFrameLoaderClient::invalidateCurrentItemPageCache):
        (WebCore::SVGEmptyFrameLoaderClient::privateBrowsingEnabled):
        (WebCore::SVGEmptyFrameLoaderClient::makeDocumentView):
        (WebCore::SVGEmptyFrameLoaderClient::makeRepresentation):
        (WebCore::SVGEmptyFrameLoaderClient::setDocumentViewFromPageCache):
        (WebCore::SVGEmptyFrameLoaderClient::forceLayout):
        (WebCore::SVGEmptyFrameLoaderClient::forceLayoutForNonHTML):
        (WebCore::SVGEmptyFrameLoaderClient::updateHistoryForCommit):
        (WebCore::SVGEmptyFrameLoaderClient::updateHistoryForBackForwardNavigation):
        (WebCore::SVGEmptyFrameLoaderClient::updateHistoryForReload):
        (WebCore::SVGEmptyFrameLoaderClient::updateHistoryForStandardLoad):
        (WebCore::SVGEmptyFrameLoaderClient::updateHistoryForInternalLoad):
        (WebCore::SVGEmptyFrameLoaderClient::updateHistoryAfterClientRedirect):
        (WebCore::SVGEmptyFrameLoaderClient::setCopiesOnScroll):
        (WebCore::SVGEmptyFrameLoaderClient::tokenForLoadErrorReset):
        (WebCore::SVGEmptyFrameLoaderClient::resetAfterLoadError):
        (WebCore::SVGEmptyFrameLoaderClient::doNotResetAfterLoadError):
        (WebCore::SVGEmptyFrameLoaderClient::detachedFromParent1):
        (WebCore::SVGEmptyFrameLoaderClient::detachedFromParent2):
        (WebCore::SVGEmptyFrameLoaderClient::detachedFromParent3):
        (WebCore::SVGEmptyFrameLoaderClient::detachedFromParent4):
        (WebCore::SVGEmptyFrameLoaderClient::loadedFromPageCache):
        (WebCore::SVGEmptyFrameLoaderClient::download):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchIdentifierForInitialRequest):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchWillSendRequest):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchDidReceiveAuthenticationChallenge):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchDidCancelAuthenticationChallenge):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchDidReceiveResponse):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchDidReceiveContentLength):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchDidFinishLoading):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchDidFailLoading):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchDidLoadResourceFromMemoryCache):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchDidHandleOnloadEvents):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchDidReceiveServerRedirectForProvisionalLoad):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchDidCancelClientRedirect):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchWillPerformClientRedirect):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchDidChangeLocationWithinPage):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchWillClose):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchDidReceiveIcon):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchDidStartProvisionalLoad):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchDidReceiveTitle):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchDidCommitLoad):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchDidFailProvisionalLoad):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchDidFailLoad):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchDidFinishLoad):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchDidFirstLayout):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchCreatePage):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchShow):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchDecidePolicyForMIMEType):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchDecidePolicyForNewWindowAction):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchDecidePolicyForNavigationAction):
        (WebCore::SVGEmptyFrameLoaderClient::cancelPolicyCheck):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchUnableToImplementPolicy):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchWillSubmitForm):
        (WebCore::SVGEmptyFrameLoaderClient::dispatchDidLoadMainResource):
        (WebCore::SVGEmptyFrameLoaderClient::clearLoadingFromPageCache):
        (WebCore::SVGEmptyFrameLoaderClient::isLoadingFromPageCache):
        (WebCore::SVGEmptyFrameLoaderClient::revertToProvisionalState):
        (WebCore::SVGEmptyFrameLoaderClient::setMainDocumentError):
        (WebCore::SVGEmptyFrameLoaderClient::clearUnarchivingState):
        (WebCore::SVGEmptyFrameLoaderClient::progressStarted):
        (WebCore::SVGEmptyFrameLoaderClient::progressCompleted):
        (WebCore::SVGEmptyFrameLoaderClient::incrementProgress):
        (WebCore::SVGEmptyFrameLoaderClient::completeProgress):
        (WebCore::SVGEmptyFrameLoaderClient::setMainFrameDocumentReady):
        (WebCore::SVGEmptyFrameLoaderClient::startDownload):
        (WebCore::SVGEmptyFrameLoaderClient::willChangeTitle):
        (WebCore::SVGEmptyFrameLoaderClient::didChangeTitle):
        (WebCore::SVGEmptyFrameLoaderClient::committedLoad):
        (WebCore::SVGEmptyFrameLoaderClient::finishedLoading):
        (WebCore::SVGEmptyFrameLoaderClient::finalSetupForReplace):
        (WebCore::SVGEmptyFrameLoaderClient::cancelledError):
        (WebCore::SVGEmptyFrameLoaderClient::cannotShowURLError):
        (WebCore::SVGEmptyFrameLoaderClient::interruptForPolicyChangeError):
        (WebCore::SVGEmptyFrameLoaderClient::cannotShowMIMETypeError):
        (WebCore::SVGEmptyFrameLoaderClient::fileDoesNotExistError):
        (WebCore::SVGEmptyFrameLoaderClient::shouldFallBack):
        (WebCore::SVGEmptyFrameLoaderClient::setDefersLoading):
        (WebCore::SVGEmptyFrameLoaderClient::willUseArchive):
        (WebCore::SVGEmptyFrameLoaderClient::isArchiveLoadPending):
        (WebCore::SVGEmptyFrameLoaderClient::cancelPendingArchiveLoad):
        (WebCore::SVGEmptyFrameLoaderClient::clearArchivedResources):
        (WebCore::SVGEmptyFrameLoaderClient::canHandleRequest):
        (WebCore::SVGEmptyFrameLoaderClient::canShowMIMEType):
        (WebCore::SVGEmptyFrameLoaderClient::representationExistsForURLScheme):
        (WebCore::SVGEmptyFrameLoaderClient::generatedMIMETypeForURLScheme):
        (WebCore::SVGEmptyFrameLoaderClient::frameLoadCompleted):
        (WebCore::SVGEmptyFrameLoaderClient::restoreScrollPositionAndViewState):
        (WebCore::SVGEmptyFrameLoaderClient::provisionalLoadStarted):
        (WebCore::SVGEmptyFrameLoaderClient::shouldTreatURLAsSameAsCurrent):
        (WebCore::SVGEmptyFrameLoaderClient::addHistoryItemForFragmentScroll):
        (WebCore::SVGEmptyFrameLoaderClient::didFinishLoad):
        (WebCore::SVGEmptyFrameLoaderClient::prepareForDataSourceReplacement):
        (WebCore::SVGEmptyFrameLoaderClient::createDocumentLoader):
        (WebCore::SVGEmptyFrameLoaderClient::setTitle):
        (WebCore::SVGEmptyFrameLoaderClient::userAgent):
        (WebCore::SVGEmptyEditorClient::~SVGEmptyEditorClient):
        (WebCore::SVGEmptyEditorClient::pageDestroyed):
        (WebCore::SVGEmptyEditorClient::shouldDeleteRange):
        (WebCore::SVGEmptyEditorClient::shouldShowDeleteInterface):
        (WebCore::SVGEmptyEditorClient::smartInsertDeleteEnabled):
        (WebCore::SVGEmptyEditorClient::isContinuousSpellCheckingEnabled):
        (WebCore::SVGEmptyEditorClient::toggleContinuousSpellChecking):
        (WebCore::SVGEmptyEditorClient::isGrammarCheckingEnabled):
        (WebCore::SVGEmptyEditorClient::toggleGrammarChecking):
        (WebCore::SVGEmptyEditorClient::spellCheckerDocumentTag):
        (WebCore::SVGEmptyEditorClient::selectWordBeforeMenuEvent):
        (WebCore::SVGEmptyEditorClient::isEditable):
        (WebCore::SVGEmptyEditorClient::shouldBeginEditing):
        (WebCore::SVGEmptyEditorClient::shouldEndEditing):
        (WebCore::SVGEmptyEditorClient::shouldInsertNode):
        (WebCore::SVGEmptyEditorClient::shouldInsertText):
        (WebCore::SVGEmptyEditorClient::shouldApplyStyle):
        (WebCore::SVGEmptyEditorClient::didBeginEditing):
        (WebCore::SVGEmptyEditorClient::respondToChangedContents):
        (WebCore::SVGEmptyEditorClient::didEndEditing):
        (WebCore::SVGEmptyEditorClient::registerCommandForUndo):
        (WebCore::SVGEmptyEditorClient::registerCommandForRedo):
        (WebCore::SVGEmptyEditorClient::clearUndoRedoOperations):
        (WebCore::SVGEmptyEditorClient::canUndo):
        (WebCore::SVGEmptyEditorClient::canRedo):
        (WebCore::SVGEmptyEditorClient::undo):
        (WebCore::SVGEmptyEditorClient::redo):
        (WebCore::SVGEmptyEditorClient::dataForArchivedSelection):
        (WebCore::SVGEmptyEditorClient::userVisibleString):
        (WebCore::SVGEmptyContextMenuClient::~SVGEmptyContextMenuClient):
        (WebCore::SVGEmptyContextMenuClient::contextMenuDestroyed):
        (WebCore::SVGEmptyContextMenuClient::addCustomContextMenuItems):
        (WebCore::SVGEmptyContextMenuClient::contextMenuItemSelected):
        (WebCore::SVGEmptyContextMenuClient::downloadURL):
        (WebCore::SVGEmptyContextMenuClient::copyImageToClipboard):
        (WebCore::SVGEmptyContextMenuClient::lookUpInDictionary):
        (WebCore::SVGEmptyContextMenuClient::speak):
        (WebCore::SVGEmptyContextMenuClient::stopSpeaking):
        (WebCore::SVGEmptyContextMenuClient::searchWithSpotlight):

2006-12-29  George Staikos  <staikos@kde.org>

        Reviewed by Olliej.

        Make redirects work properly.  Sites will thank us for this. :-)

        * platform/network/qt/ResourceHandleManagerQt.cpp:
        (WebCore::ResourceHandleManager::receivedResponse):

2006-12-28  George Staikos  <staikos@kde.org>

        Reviewed by Olliej.

        * loader/CachedImage.cpp: build for Qt

2006-12-28  Daniel Molkentin <molkentin@kde.org>

        Reviewed by Eric Seidel <eric@webkit.org>

        - Fix font sizes
        - Make Qt plattform build again:
          - Adjust Qt platform to the Image class split.
          - Introduce BitmapImage class
          - add stub PDFDocumentImage class

        * WebCore.pro:
        * editing/qt/EditorQt.cpp:
        (WebCore::Editor::markMisspellingsAfterTypingToPosition):
        * loader/qt/FrameLoaderQt.cpp:
        (WebCore::FrameLoader::partClearedInBegin):
        * platform/graphics/qt/ImageQt.cpp:
        (WebCore::BitmapImage::initPlatformData):
        (WebCore::BitmapImage::invalidatePlatformData):
        (WebCore::Image::loadPlatformResource):
        (WebCore::BitmapImage::draw):
        (WebCore::BitmapImage::drawTiled):
        (WebCore::BitmapImage::checkForSolidColor):
        * platform/graphics/svg/SVGPaintServerLinearGradient.h:
        * platform/graphics/svg/SVGPaintServerRadialGradient.h:
        * platform/graphics/svg/qt/SVGPaintServerLinearGradientQt.cpp:
        (WebCore::SVGPaintServerLinearGradient::setup):
        * platform/graphics/svg/qt/SVGPaintServerPatternQt.cpp:
        (WebCore::SVGPaintServerPattern::setup):
        * platform/graphics/svg/qt/SVGPaintServerQt.cpp:
        (WebCore::SVGPaintServer::teardown):
        * platform/graphics/svg/qt/SVGPaintServerRadialGradientQt.cpp:
        (WebCore::SVGPaintServerRadialGradient::setup):
        * platform/graphics/svg/qt/SVGPaintServerSolidQt.cpp:
        (WebCore::SVGPaintServerSolid::setup):
        * platform/qt/FrameQt.cpp:
        (WebCore::FrameQt::FrameQt):
        (WebCore::FrameQt::bindingRootObject):

2006-12-28  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Brady Eidson.
        
        Some cleanup in preparation for fixing <rdar://problem/4608404> 
        WebScriptObject's _executionContext lack of ownership policy causes 
        crashes (e.g., in Dashcode)
        
        Layout tests pass.

        Renamed "root" | "execContext" | "executionContext" => rootObject, because
        that's the object's (admittedly vague) type name.
        
        * bindings/js/kjs_binding.cpp:
        * bindings/js/kjs_binding.h: Removed createLanguageInstanceForValue
        and createObjcInstanceForValue because their only purpose was to confuse you.
        
        * bindings/objc/DOMInternal.h: Moved declaration of createDOMWrapper here.
        createDOMWrapper is the new name for createObjcInstanceForValue.
        
        * bindings/objc/DOMInternal.mm: Renamed Interpreter::createObjcInstanceForValue
        to createDOMWrapper because creating DOM wrappers has nothing to do with the interpreter,
        and everything to do with the DOM. Renamed value to object because it is one.
        Removed newObj nil check that is unnecessary in ObjC.

        * bindings/objc/WebScriptObject.mm: Replaced call to createLanguageInstanceForValue
        with explicit code to do the same thing it would have done: (1) try to create 
        a DOM wrapper; (2) if the object is not a wrappable DOM object, create a 
        vanilla WebScriptObject for it instead.

2006-12-28  Mitz Pettel  <mitz@webkit.org>

        Reviewed by Darin.

        - fix http://bugs.webkit.org/show_bug.cgi?id=11729
          REGRESSION: Crash closing page with frames after selection

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::detachFromParent): Added call to pageDestroyed().
        * page/FrameTree.cpp:
        (WebCore::FrameTree::appendChild): Added an assertion that the parent and
        the child are in the same page.
        (WebCore::FrameTree::removeChild): Added calls to decrementFrameCount() and pageDestroyed().

2006-12-28  David Kilzer  <ddkilzer@webkit.org>

        Reviewed by Mitz.

        - fix http://bugs.webkit.org/show_bug.cgi?id=12016
          REGRESSION: fast/text/stroking-decorations.html test fails with bus error in no-svg build

        No test cases (no change in functionality).

        * platform/TextStream.cpp: Properly initialize presicionFormats.
        * rendering/RenderTreeAsText.cpp:
        (WebCore::externalRepresentation): HTML tests now print out the stroke width, which is a float,
        so the precision needs to be set.

2006-12-28  Eric Seidel  <eric@webkit.org>

        Reviewed by rwlbuis.

        Fix for memory smasher when drawing markers.
        http://bugs.webkit.org/show_bug.cgi?id=12015
        
        No test case possible (crashes for some folks but not others, not even under --guard)

        * platform/graphics/cg/PathCG.cpp:
        (WebCore::CGPathApplierToPathApplier): array was too small

2006-12-28  Mitz Pettel  <mitz@webkit.org>

        Reviewed by Darin.

        - fix http://bugs.webkit.org/show_bug.cgi?id=11124
          REGRESSION (r14297): No drag image for partially-selected complex text

        Test: fast/text/atsui-partial-selection.html

        * platform/Font.h: Changed comment.
        * platform/mac/FontMac.mm:
        (WebCore::Font::drawComplexText): Corrected the run length calculation.
        Changed the ATSUI layout parameters to know about the entire text run, rather
        than just the range we are drawing. ATSUI measures the characters before
        the range and positions the range accordingly.

2006-12-28  Mitz Pettel  <mitz@webkit.org>

        Reviewed by Darin.

        - fix http://bugs.webkit.org/show_bug.cgi?id=9202
          CSS3: border-radius not completely implemented, testcase hangs webkit

        Test: fast/borders/borderRadiusAllStylesAllCorners.html

        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::paintBorder): Changed to not draw "arcs" at straight
        corners and to paint half-corners only where the styles mismatch.
        Corrected the condition for matching styles: ridge, groove, inset and outset
        all mismatch in the upper right and lower left corners and match in the other
        two. The incorrect condition for a match was (almost) unnoticeable because of
        the painting of both half-corners on each side that had at least one mismatch.

2006-12-28  Alexey Proskuryakov  <ap@webkit.org>

        Reverting the previous checkin, as it caused an assertion in layout tests.

        * rendering/RenderTableCell.cpp:
        (WebCore::RenderTableCell::borderLeft):
        (WebCore::RenderTableCell::borderRight):
        (WebCore::RenderTableCell::borderTop):
        (WebCore::RenderTableCell::borderBottom):
        * rendering/RenderTableCell.h:

2006-12-28  Mitz Pettel  <mitz@webkit.org>

        Reviewed by Darin.

        - fix http://bugs.webkit.org/show_bug.cgi?id=11359
          Incomplete repaint of table cell's collapsed border when changing only the cell

        Test: fast/repaint/table-cell-collapsed-border.html

        * rendering/RenderTableCell.cpp:
        (WebCore::RenderTableCell::getAbsoluteRepaintRect): Overloaded to add the
        outer half of any collapsed borders. This function checks the cell's borders'
        widths but also the widths of the adjoining cells' borders, since they can
        contribute to the length of this cell's borders perpendicular to them, making
        such a border overflow the cell in both dimensions.
        (WebCore::RenderTableCell::borderLeft): Split the collapsing borders case off to
        borderHalfLeft().
        (WebCore::RenderTableCell::borderRight): Ditto.
        (WebCore::RenderTableCell::borderTop): Ditto.
        (WebCore::RenderTableCell::borderBottom): Ditto.
        (WebCore::RenderTableCell::borderHalfLeft): Added. Takes an 'outer' boolean
        parameter. When true, this function returns the width of the part of the border
        that is outside the cell (different from the inner width when the total width is odd).
        (WebCore::RenderTableCell::borderHalfRight): Ditto.
        (WebCore::RenderTableCell::borderHalfTop): Ditto.
        (WebCore::RenderTableCell::borderHalfBottom): Ditto.
        * rendering/RenderTableCell.h:

2006-12-28  Mitz Pettel  <mitz@webkit.org>

        Reviewed by Alexey.

        - fix http://bugs.webkit.org/show_bug.cgi?id=11671
          REGRESSION (r13702): text-transform: capitalize changes non-breaking spaces to spaces

        Test: fast/text/capitalize-preserve-nbsp.html

        * platform/StringImpl.cpp:
        (WebCore::StringImpl::capitalize): Copy back non-breaking spaces from the
        original string to the capitalized string. Change a 'previous' non-breaking
        space into a space (this improves the fix for <rdar://problem/4502311> from r13702).

2006-12-28  Mitz Pettel  <mitz@webkit.org>

        Reviewed by Darin.

        - fix http://bugs.webkit.org/show_bug.cgi?id=10699
          div with border-radius does not redraw properly if element inside div is resized

        Test: fast/repaint/border-radius-repaint.html

        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::repaintAfterLayoutIfNeeded):

2006-12-28  Darin Adler  <darin@apple.com>

        * loader/CachedImage.cpp: (WebCore::CachedImage::createImage):
        Fixed an #ifdef PLATFORM(CG) that should be #if PLATFORM(CG).
        Might have broken the build on some platforms.

2006-12-27  Geoffrey Garen  <ggaren@apple.com>

        Build fix, plus a few "double &" => "double&" changes.
        
        * ksvg2/svg/SVGParserUtilities.cpp:
        (WebCore::parseNumber):
        (WebCore::SVGPathParser::calculateArc):

2006-12-27  Oliver Hunt <oliver@apple.com> 

        Build fix

        * platform/graphics/BitmapImage.h:
        * platform/graphics/Image.cpp:
        * platform/graphics/Image.h:
        (WebCore::Image::getHBITMAP):
        * platform/graphics/cg/PDFDocumentImage.cpp:
        (WebCore::PDFDocumentImage::PDFDocumentImage):

2006-12-27  Eric Seidel  <eric@webkit.org>

        Reviewed by olliej.

        Add new PDFDocumentImage and BitmapImage classes (subclasses of Image)
        (In preparation for adding SVGImage as part of bug 5971)
        http://bugs.webkit.org/show_bug.cgi?id=11990
        
        Test cases landed separately as part of filing bug 11992.

        * WebCore.xcodeproj/project.pbxproj: add BitmapImage.*
        * loader/CachedImage.cpp:
        (WebCore::nullImage): use BitmapImage directly
        (WebCore::CachedImage::createImage): now create either BitmapImage or PDFDocumentImage directly
        * loader/icon/IconDataCache.cpp:
        (WebCore::IconDataCache::setImageData): use BitmapImage directly
        * platform/graphics/BitmapImage.cpp: Added.
        (WebCore::BitmapImage::BitmapImage):
        (WebCore::BitmapImage::~BitmapImage):
        (WebCore::BitmapImage::invalidateData):
        (WebCore::BitmapImage::cacheFrame):
        (WebCore::BitmapImage::size):
        (WebCore::BitmapImage::setNativeData):
        (WebCore::BitmapImage::frameCount):
        (WebCore::BitmapImage::isSizeAvailable):
        (WebCore::BitmapImage::frameAtIndex):
        (WebCore::BitmapImage::frameDurationAtIndex):
        (WebCore::BitmapImage::frameHasAlphaAtIndex):
        (WebCore::BitmapImage::shouldAnimate):
        (WebCore::BitmapImage::startAnimation):
        (WebCore::BitmapImage::stopAnimation):
        (WebCore::BitmapImage::resetAnimation):
        (WebCore::BitmapImage::advanceAnimation):
        * platform/graphics/BitmapImage.h: Added.
        (WebCore::FrameData::FrameData):
        (WebCore::BitmapImage::nativeImageForCurrentFrame): added.
        (WebCore::BitmapImage::currentFrame):
        (WebCore::BitmapImage::mayFillWithSolidColor): added.
        (WebCore::BitmapImage::solidColor): added.
        * platform/graphics/Image.cpp:
        (WebCore::Image::Image):
        (WebCore::Image::~Image):
        * platform/graphics/Image.h:
        (WebCore::Image::setNativeData): now virtual
        (WebCore::Image::stopAnimation): now virtual
        (WebCore::Image::resetAnimation): now virtual
        (WebCore::Image::getNSImage): now virtual
        (WebCore::Image::getTIFFRepresentation): now virtual
        (WebCore::Image::getCGImageRef): now virtual
        * platform/graphics/cg/ImageCG.cpp:
        (WebCore::BitmapImage::checkForSolidColor):
        (WebCore::BitmapImage::getCGImageRef): use nativeImageForCurrentFrame
        (WebCore::fillWithSolidColor): added
        (WebCore::BitmapImage::draw):
        (WebCore::drawPattern): use fillWithSolidColor, mayFillWithSolidColor() and solidcolor()
        (WebCore::BitmapImage::drawTiled): use fillWithSolidColor, mayFillWithSolidColor() and solidcolor()
        * platform/graphics/cg/PDFDocumentImage.cpp:
        (WebCore::PDFDocumentImage::PDFDocumentImage):
        (WebCore::PDFDocumentImage::size): change to subclass from Image
        (WebCore::PDFDocumentImage::setNativeData):
        (WebCore::PDFDocumentImage::draw):
        * platform/graphics/cg/PDFDocumentImage.h:
        (WebCore::PDFDocumentImage::drawTiled):
        * platform/graphics/mac/ImageMac.mm:
        (WebCore::BitmapImage::initPlatformData):
        (WebCore::BitmapImage::invalidatePlatformData):
        (WebCore::Image::loadPlatformResource):
        (WebCore::BitmapImage::getTIFFRepresentation):
        (WebCore::BitmapImage::getNSImage):
        * platform/graphics/svg/filters/cg/SVGFEImageCg.mm:
        (WebCore::SVGFEImage::getCIFilter): remove soon-to-be unnecessary comment
        * rendering/RenderImage.cpp:
        (WebCore::RenderImage::nullImage): use BitmapImage

2006-12-27  Mitz Pettel  <mitz@webkit.org>

        Reviewed by Hyatt.

        - fix http://bugs.webkit.org/show_bug.cgi?id=11452
          REGRESSION (r16736-r16801): Incorrect repaint of fixed boxes

        Test: fast/repaint/fixed.html

        * rendering/RenderView.cpp:
        (WebCore::RenderView::computeAbsoluteRepaintRect): Re-added.
        * rendering/RenderView.h:

2006-12-27  Mitz Pettel  <mitz@webkit.org>

        Reviewed by Geoff.

        - fix http://bugs.webkit.org/show_bug.cgi?id=11930
          Specifying border-radius makes the outline shrink

        Test: fast/css/border-radius-outline-offset.html

        * css/cssstyleselector.cpp:
        (WebCore::CSSStyleSelector::applyProperty): Added missing return statement.

2006-12-27  Rob Buis  <buis@kde.org>

        Reviewed by Eric.

        http://bugs.webkit.org/show_bug.cgi?id=11108
        Replace usage of split by proper parsers
        http://bugs.webkit.org/show_bug.cgi?id=11908
        WebKit spends 40% of its time displaying "bamboo.svg" executing Regexes

        Get rid of split() when parsing transform attribute.

        * CMakeLists.txt:
        * WebCore.xcodeproj/project.pbxproj:
        * ksvg2/svg/SVGParserUtilities.cpp: Added.
        (WebCore::parseNumber):
        (WebCore::parseNumberOptionalNumber):
        (WebCore::SVGPolyParser::parsePoints):
        (WebCore::SVGPathParser::parseSVG):
        (WebCore::SVGPathParser::calculateArc):
        (WebCore::SVGPathParser::svgLineToHorizontal):
        (WebCore::SVGPathParser::svgLineToVertical):
        (WebCore::SVGPathParser::svgCurveToCubicSmooth):
        (WebCore::SVGPathParser::svgCurveToQuadratic):
        (WebCore::SVGPathParser::svgCurveToQuadraticSmooth):
        (WebCore::SVGPathParser::svgArcTo):
        * ksvg2/svg/SVGParserUtilities.h: Added.
        (WebCore::isWhitespace):
        (WebCore::skipOptionalSpaces):
        (WebCore::skipOptionalSpacesOrDelimiter):
        (WebCore::SVGPolyParser::~SVGPolyParser):
        (WebCore::SVGPathParser::~SVGPathParser):
        * ksvg2/svg/SVGPathElement.cpp:
        (WebCore::SVGPathElement::SVGPathElement):
        * ksvg2/svg/SVGPathElement.h:
        * ksvg2/svg/SVGTransformable.cpp:
        (WebCore::parseTransformParamList):
        (WebCore::SVGTransformable::parseTransformAttribute):
        * ksvg2/svg/svgpathparser.cpp:
        (WebCore::DeprecatedSVGPathParser::parseSVG):
        (WebCore::DeprecatedSVGPathParser::calculateArc):
        (WebCore::DeprecatedSVGPathParser::svgLineToHorizontal):
        (WebCore::DeprecatedSVGPathParser::svgLineToVertical):
        (WebCore::DeprecatedSVGPathParser::svgCurveToCubicSmooth):
        (WebCore::DeprecatedSVGPathParser::svgCurveToQuadratic):
        (WebCore::DeprecatedSVGPathParser::svgCurveToQuadraticSmooth):
        (WebCore::DeprecatedSVGPathParser::svgArcTo):
        * ksvg2/svg/svgpathparser.h:
        (WebCore::DeprecatedSVGPathParser::~DeprecatedSVGPathParser):

2006-12-27  Mitz Pettel  <mitz@webkit.org>

        Reviewed by Geoff.

        - http://bugs.webkit.org/show_bug.cgi?id=11968
          BidiContext's m_basicDir is redundant

        No test possible (no functionality change)

        * rendering/bidi.cpp:
        (WebCore::BidiContext::BidiContext):
        (WebCore::operator==):
        (WebCore::RenderBlock::computeHorizontalPositionsForLine): Use the block's
        direction to resolve 'automatic' text-align.
        * rendering/bidi.h:
        (WebCore::BidiContext::dir):

2006-12-27  Nikolas Zimmermann  <zimmermann@kde.org>

        Build fix, not reviewed.

        Accidently commited an older revision of this file.

        * platform/graphics/svg/SVGPaintServerPattern.h:

2006-12-27  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Mitz & Eric.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=11904

        We need to cache the CGPatternRef (m_pattern) for efficiency
        in SVGPaintServerPatternCg, and keep track wheter the underlying
        ImageBuffer has changed, and only update the pattern in that case.

        * platform/graphics/svg/SVGPaintServerPattern.cpp:
        (WebCore::SVGPaintServerPattern::SVGPaintServerPattern):
        (WebCore::SVGPaintServerPattern::~SVGPaintServerPattern):
        (WebCore::SVGPaintServerPattern::setTile):
        * platform/graphics/svg/SVGPaintServerPattern.h:
        * platform/graphics/svg/cg/SVGPaintServerPatternCg.cpp:
        (WebCore::SVGPaintServerPattern::setup):
        (WebCore::SVGPaintServerPattern::teardown):

2006-12-26  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Eric Seidel.

        Fixed <rdar://problem/4740328> Safari crash on quit in _NPN_ReleaseObject 
        from KJS::Bindings::CInstance::~CInstance
        
        No testcase because we can't open and close windows in DumpRenderTree.
        
        * loader/FrameLoader.cpp: Removed closeDocument helper function because
        its only purpose was to call didCloseDocument, which is gone now.
        (WebCore::FrameLoader::detachFromParent): closeDocument => closeURL, 
        since didCloseDocument is gone now.

        * loader/FrameLoaderClient.h: Removed didCloseDocument because it proved
        unnecessary and harmful.
        
        * loader/mac/FrameLoaderMac.mm:
        (WebCore::FrameLoader::transitionToCommitted): closeDocument => closeURL, 
        since didCloseDocument is gone now.

2006-12-26  Eric Seidel  <eric@webkit.org>

        Reviewed by olliej.

        ASSERT while loading SVG map
        http://bugs.webkit.org/show_bug.cgi?id=11987

        * ksvg2/css/SVGCSSParser.cpp: remove a few .impl() calls previously missed.
        (WebCore::CSSParser::parseSVGValue):
        (WebCore::CSSParser::parseSVGPaint):
        (WebCore::CSSParser::parseSVGColor):
        * ksvg2/misc/KCanvasRenderingStyle.cpp: handle invalid colors
        (WebCore::KSVGPainterFactory::fillPaintServer):
        (WebCore::KSVGPainterFactory::strokePaintServer):

2006-12-26  Eric Seidel  <eric@webkit.org>

        Reviewed by ggaren.

        No test cases changed.
        
        Remove unnecessary (and inefficient) .impl() and .deprecatedString() calls.
        http://bugs.webkit.org/show_bug.cgi?id=11989

        * bindings/js/kjs_dom.cpp:
        (KJS::DOMNodeList::getOwnPropertySlot):
        * dom/Document.cpp:
        (WebCore::Document::createAttributeNS):
        * dom/Element.cpp:
        (WebCore::Element::getAttributeNS):
        (WebCore::Element::setAttribute):
        (WebCore::Element::setAttributeNS):
        (WebCore::Element::removeAttributeNS):
        (WebCore::Element::getAttributeNode):
        (WebCore::Element::getAttributeNodeNS):
        (WebCore::Element::hasAttribute):
        (WebCore::Element::hasAttributeNS):
        * dom/NamedAttrMap.cpp:
        (WebCore::NamedAttrMap::getNamedItemNS):
        (WebCore::NamedAttrMap::removeNamedItemNS):
        * dom/ProcessingInstruction.cpp:
        (WebCore::ProcessingInstruction::checkStyleSheet):
        * html/HTMLBaseElement.cpp:
        (WebCore::HTMLBaseElement::process):
        * html/HTMLEmbedElement.cpp:
        (WebCore::HTMLEmbedElement::parseMappedAttribute):
        * html/HTMLEmbedElement.h:
        * html/HTMLHRElement.cpp:
        (WebCore::HTMLHRElement::parseMappedAttribute):
        * html/HTMLScriptElement.cpp:
        (WebCore::HTMLScriptElement::insertedIntoDocument):
        * html/HTMLStyleElement.cpp:
        (WebCore::HTMLStyleElement::parseMappedAttribute):
        * ksvg2/svg/SVGAnimateElement.cpp:
        (WebCore::SVGAnimateElement::handleTimerEvent):
        * ksvg2/svg/SVGComponentTransferFunctionElement.cpp:
        (WebCore::SVGComponentTransferFunctionElement::parseMappedAttribute):
        * ksvg2/svg/SVGFEColorMatrixElement.cpp:
        (WebCore::SVGFEColorMatrixElement::parseMappedAttribute):
        * ksvg2/svg/SVGFEImageElement.cpp:
        (WebCore::SVGFEImageElement::parseMappedAttribute):
        * ksvg2/svg/SVGFitToViewBox.cpp:
        (WebCore::SVGFitToViewBox::parseMappedAttribute):
        * ksvg2/svg/SVGImageElement.cpp:
        (WebCore::SVGImageElement::parseMappedAttribute):
        * ksvg2/svg/SVGPatternElement.cpp:
        (WebCore::SVGPatternElement::fillAttributesFromReferencePattern):
        (WebCore::SVGPatternElement::notifyAttributeChange):
        * ksvg2/svg/SVGPolyElement.cpp:
        (WebCore::SVGPolyElement::notifyAttributeChange):
        * ksvg2/svg/SVGStopElement.cpp:
        (WebCore::SVGStopElement::parseMappedAttribute):
        * ksvg2/svg/SVGTRefElement.cpp:
        (WebCore::SVGTRefElement::updateReferencedText):
        * ksvg2/svg/SVGTests.cpp:
        (WebCore::SVGTests::parseMappedAttribute):
        * ksvg2/svg/SVGTextPositioningElement.cpp:
        (WebCore::SVGTextPositioningElement::parseMappedAttribute):
        * ksvg2/svg/SVGUseElement.cpp:
        (WebCore::SVGUseElement::closeRenderer):
        * ksvg2/svg/SVGViewElement.cpp:
        (WebCore::SVGViewElement::parseMappedAttribute):
        * page/Frame.cpp:
        (WebCore::Frame::selectionComputedStyle):
        * rendering/RenderPartObject.cpp:
        (WebCore::RenderPartObject::updateWidget):
        * rendering/SVGRenderTreeAsText.cpp:
        (WebCore::writeRenderResources):

2006-12-26  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver.

        Add patternContentUnits support, and cleanup SVGPaintServerGradientCg.cpp
        Fixes coords-units-01-b.svg

        * ksvg2/svg/SVGPatternElement.cpp:
        (WebCore::SVGPatternElement::drawPatternContentIntoTile):
        * platform/graphics/svg/SVGPaintServerPattern.cpp:
        (WebCore::SVGPaintServerPattern::SVGPaintServerPattern):
        (WebCore::SVGPaintServerPattern::contentBoundingBoxMode):
        (WebCore::SVGPaintServerPattern::setContentBoundingBoxMode):
        * platform/graphics/svg/SVGPaintServerPattern.h:
        * platform/graphics/svg/cg/SVGPaintServerGradientCg.cpp:
        (WebCore::SVGPaintServerGradient::renderPath):
        * platform/graphics/svg/cg/SVGPaintServerPatternCg.cpp:
        (WebCore::SVGPaintServerPattern::setup):

2006-12-26  Eric Seidel  <eric@webkit.org>

        Reviewed by ggaren

        No test cases changed.
        
        Remove unneeded isPaintingText() and activeClient() from SVGPaintServer system

        * platform/graphics/svg/SVGPaintServer.cpp:
        (WebCore::SVGPaintServer::SVGPaintServer):
        * platform/graphics/svg/SVGPaintServer.h:
        * platform/graphics/svg/SVGPaintServerGradient.h:
        * platform/graphics/svg/SVGPaintServerPattern.h:
        * platform/graphics/svg/SVGPaintServerSolid.h:
        * platform/graphics/svg/cg/SVGPaintServerCg.cpp:
        (WebCore::SVGPaintServer::teardown):
        * platform/graphics/svg/cg/SVGPaintServerGradientCg.cpp:
        (WebCore::SVGPaintServerGradient::teardown):
        (WebCore::SVGPaintServerGradient::setup):
        * platform/graphics/svg/cg/SVGPaintServerPatternCg.cpp:
        (WebCore::SVGPaintServerPattern::setup):
        (WebCore::SVGPaintServerPattern::teardown):
        * platform/graphics/svg/cg/SVGPaintServerSolidCg.cpp:
        (WebCore::SVGPaintServerSolid::setup):
        * rendering/RenderPath.cpp:
        (WebCore::RenderPath::paint):
        * rendering/SVGInlineFlowBox.cpp:
        (WebCore::paintSVGInlineFlow):

2006-12-25  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Adam Roben.
        
        Fixed <rdar://problem/4778898> REGRESSION: crash in getInstanceForView() 
        when quitting from kcbs.com
        
        No testcase because we can't open and close windows in DRT.
        
        The crash was caused by deallocating plug-ins that were later referenced
        in the unload event handler.

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::closeDocument): Call didCloseDocument after closing
        instead of before, so plugins don't get deallocated until the document
        has been destroyed and all event handlers have fired.
        
        * loader/FrameLoaderClient.h: Renamed "willCloseDocument" to "didCloseDocument",
        since we call it after closing now.

2006-12-26  Eric Seidel  <eric@webkit.org>

        Reviewed by rwlbuis.

        Replace bogus SVGLength::isFraction() method with valueAsPercentage() to fix:
        http://bugs.webkit.org/show_bug.cgi?id=11973
        
        * ksvg2/svg/SVGLength.cpp:
        (WebCore::SVGLength::valueInSpecifiedUnits): remove extra spaces
        (WebCore::SVGLength::valueAsPercentage): new method
        * ksvg2/svg/SVGLength.h:
        * ksvg2/svg/SVGLinearGradientElement.cpp:
        (WebCore::SVGLinearGradientElement::buildGradient): use valueAsPercentage()
        * ksvg2/svg/SVGPatternElement.cpp:
        (WebCore::SVGPatternElement::drawPatternContentIntoTile): return if malloc fails
        * ksvg2/svg/SVGRadialGradientElement.cpp:
        (WebCore::SVGRadialGradientElement::buildGradient): use valueAsPercentage()
        * platform/graphics/cg/GraphicsContextCG.cpp:
        (WebCore::GraphicsContext::createImageBuffer): return 0 if malloc fails
        * platform/graphics/svg/cg/SVGPaintServerGradientCg.cpp:
        (WebCore::SVGPaintServerGradient::setup): return if malloc fails
        * platform/graphics/svg/cg/SVGResourceMaskerCg.mm:
        (WebCore::SVGResourceMasker::applyMask): add comment about possible crash

2006-12-26  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver.

        In the DOMParser class, we have to create content-type specific
        documents, instead of a pure "Document" object. Real-life SVG
        files us this way to convert strings "<svg><rect x=...></svg>
        to a new Document structure. 

        Add new testcase dynamic-svg-document-creation.svg.

        * xml/DOMParser.cpp:
        (WebCore::DOMParser::parseFromString):

2006-12-25  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Oliver Hunt.

        Removed WebCoreSettings, cleaned up WebCore::Settings.

        * WebCore.exp: Exported Settings for use by WebKit, removed WebCoreSettings class.
        
        * WebCore.xcodeproj/project.pbxproj: Removed WebCoreSetttings.h/.mm.
        Added Settings.cpp.

        * page/Frame.cpp: Removed cruft that duplicated Settings data. Callers now call
        through to Settings to get Settings data.

        * page/Page.cpp: Added Settings data member, to replace the one that WebView
        used to hold.

        * page/Settings.cpp: Added.
        * page/Settings.h:
            - Renamed all functions to match WebKit API. Renamed all variables to
            match functions. Favorite old name: "isPluginsEnabled."
            - Moved EditableLinkBehavior outside of the class. Having it inside
            just made it harder to type.
            - Merged in old WebCoreSettings functionality, like guarding against re-setting
            to the same value, and making sure to update page layout.
            - Paired setters and getters, putting setters first.            

2006-12-26  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver.

        Fix some minor style issues.

        * ksvg2/svg/SVGPolygonElement.cpp:
        (WebCore::SVGPolygonElement::toPathData):
        * ksvg2/svg/SVGPolygonElement.h:
        * ksvg2/svg/SVGPolylineElement.cpp:
        (WebCore::SVGPolylineElement::toPathData):
        * ksvg2/svg/SVGPolylineElement.h:

2006-12-26  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=11963
        Fixes: http://bugs.webkit.org/show_bug.cgi?id=11123

        Fix SVGList JS wrappers, which operate on POD types (ie. Point).
        There exists a special JSSVGPODTypeWrapperCreatorForList class now,
        which operators on specialized SVGPODList's. It makes it possible
        to support stuff like "myList.getItem(0).value = 200", for POD lists.

        Adding two new testcases demonstrating the usage of SVG DOM & SVGAnimatedPoints.

        * WebCore.pro:
        * WebCore.xcodeproj/project.pbxproj:
        * bindings/js/JSSVGPODTypeWrapper.h:
        (WebCore::JSSVGPODTypeWrapperCreatorForList::JSSVGPODTypeWrapperCreatorForList):
        (WebCore::JSSVGPODTypeWrapperCreatorForList::~JSSVGPODTypeWrapperCreatorForList):
        (WebCore::JSSVGPODTypeWrapperCreatorForList::commitChange):
        * bindings/js/JSSVGPathSegListCustom.cpp:
        (WebCore::updatePathSegContextMap):
        (WebCore::removeFromPathSegContextMap):
        (WebCore::JSSVGPathSegList::clear):
        (WebCore::JSSVGPathSegList::initialize):
        * bindings/js/JSSVGPointListCustom.cpp: Added.
        (WebCore::JSSVGPointList::clear):
        (WebCore::JSSVGPointList::initialize):
        (WebCore::JSSVGPointList::getItem):
        (WebCore::JSSVGPointList::insertItemBefore):
        (WebCore::JSSVGPointList::replaceItem):
        (WebCore::JSSVGPointList::removeItem):
        (WebCore::JSSVGPointList::appendItem):
        * bindings/scripts/CodeGeneratorJS.pm:
        * ksvg2/misc/SVGDocumentExtensions.h:
        (WebCore::SVGDocumentExtensions::baseValueMap):
        (WebCore::SVGDocumentExtensions::genericContextMap):
        (WebCore::SVGDocumentExtensions::genericContext):
        (WebCore::SVGDocumentExtensions::setGenericContext):
        (WebCore::SVGDocumentExtensions::removeGenericContext):
        (WebCore::SVGDocumentExtensions::hasGenericContext):
        * ksvg2/svg/SVGAnimatedPathData.cpp:
        * ksvg2/svg/SVGAnimatedPathData.h:
        * ksvg2/svg/SVGAnimatedPoints.cpp:
        * ksvg2/svg/SVGAnimatedPoints.h:
        * ksvg2/svg/SVGLengthList.cpp:
        (WebCore::SVGLengthList::SVGLengthList):
        (WebCore::SVGLengthList::parse):
        * ksvg2/svg/SVGLengthList.h:
        * ksvg2/svg/SVGList.h:
        (WebCore::SVGPODListItem::SVGPODListItem):
        (WebCore::SVGPODListItem::operator Item&):
        (WebCore::SVGPODListItem::operator const Item&):
        (WebCore::SVGPODListItem::value):
        (WebCore::SVGPODListItem::setValue):
        (WebCore::SVGPODList::SVGPODList):
        (WebCore::SVGPODList::initialize):
        (WebCore::SVGPODList::getFirst):
        (WebCore::SVGPODList::getLast):
        (WebCore::SVGPODList::getItem):
        (WebCore::SVGPODList::insertItemBefore):
        (WebCore::SVGPODList::replaceItem):
        (WebCore::SVGPODList::removeItem):
        (WebCore::SVGPODList::appendItem):
        * ksvg2/svg/SVGPathSegList.idl:
        * ksvg2/svg/SVGPointList.cpp:
        (SVGPointList::SVGPointList):
        (SVGPointList::context):
        * ksvg2/svg/SVGPointList.h:
        * ksvg2/svg/SVGPointList.idl:
        * ksvg2/svg/SVGPolyElement.cpp:
        (WebCore::SVGPolyElement::SVGPolyElement):
        (WebCore::SVGPolyElement::points):
        (WebCore::SVGPolyElement::animatedPoints):
        (WebCore::SVGPolyElement::parseMappedAttribute):
        (WebCore::SVGPolyElement::notifyAttributeChange):
        * ksvg2/svg/SVGPolyElement.h:
        * rendering/RenderSVGText.cpp:

2006-12-25  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Maciej.

        http://bugs.webkit.org/show_bug.cgi?id=10313
        Reproducible crash when doing importStylesheet in javascript with 
        xsl files that use xsl:import

        This doesn't fully address the bug, but makes a couple of steps
        in that direction.

        * xml/XSLTProcessor.cpp:
        (WebCore::transformToString): Set m_stylesheet even if it's created implicitly,
        rather than passed from outside. Always reset it in the end (this doesn't affect
        Document::applyXSLTransform(), which was the only user of setXSLStylesheet()).

        * xml/xmlhttprequest.cpp:
        (WebCore::XMLHttpRequest::getResponseXML): Set the loaded document's URL.

2006-12-24  Mitz Pettel  <mitz@webkit.org>

        Reviewed by Maciej and Geoff.

        - remove unused member variable m_styleSelectorDirty

        No test possible (no functionality change)

        * dom/Document.cpp:
        (WebCore::Document::Document):
        (WebCore::Document::recalcStyleSelector):
        * dom/Document.h:

2006-12-24  Sam Weinig  <sam@webkit.org>

        Reviewed by Geoff.

        Patch for http://bugs.webkit.org/show_bug.cgi?id=11952
        style changes made through CSSMediaRule functions insertRule() 
        and deleteRule do not show up on the screen 

        Tests added:
        * fast/dom/css-mediarule-deleteRule-update.html
        * fast/dom/css-mediarule-insertRule-update.html

        * css/CSSMediaRule.cpp:
        (WebCore::CSSMediaRule::insertRule):
        (WebCore::CSSMediaRule::deleteRule):

2006-12-24  Rob Buis  <buis@kde.org>

        Reviewed by Alexey.

        Get rid of unused variable.

        * ksvg2/svg/SVGURIReference.cpp:
        (WebCore::SVGURIReference::getTarget):

2006-12-23  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Geoff.

        http://bugs.webkit.org/show_bug.cgi?id=11933
        REGRESSION: trying to change a property in a computed style declaration results in a crash

        Test: fast/dom/computed-style-set-property.html

        * bindings/js/kjs_css.cpp:
        (KJS::DOMCSSStyleDeclaration::put): Added a check for null m_impl->stylesheet(). Also, fixed
        incorrect logic in Dashboard branch - it didn't return in time if removeProperty() raised
        an exception (credit for noticing this bug goes to Geoff).

2006-12-23  Lars Naesbye Christensen  <lars@naesbye.dk>

        Reviewed by Geoff.

        Patch for http://bugs.webkit.org/show_bug.cgi?id=11940
        Bad transparency in some cursor pointer images

        * Resources/northEastResizeCursor.png:
        * Resources/northEastSouthWestResizeCursor.png:
        * Resources/northWestResizeCursor.png:
        * Resources/northWestSouthEastResizeCursor.png:
        * Resources/southEastResizeCursor.png:
        * Resources/southWestResizeCursor.png:

2006-12-23  Sam Weinig  <sam@webkit.org>

        Reviewed by Geoff.

        Patch for http://bugs.webkit.org/show_bug.cgi?id=11876
        CSSMediaRule functions insertRule and deleteRule don't raise exceptions

        Test added:
        * fast/dom/css-mediarule-functions.html

        * bindings/js/kjs_css.cpp:
        (KJS::DOMCSSRuleFunc::callAsFunction):
        * css/CSSMediaRule.cpp: add exception handling
        (WebCore::CSSMediaRule::insertRule):
        (WebCore::CSSMediaRule::deleteRule):
        * css/CSSMediaRule.h: add ExceptionCode arguments
        * css/CSSMediaRule.idl: un-comment exceptions

2006-12-23  David Hyatt  <hyatt@apple.com>

        Fix 11942.  The inheritable properties array is duplicated (lame).  Make
        sure to keep both in sync.

        Reviewed by mitz

        * css/CSSComputedStyleDeclaration.cpp:
        * css/CSSMutableStyleDeclaration.cpp:
        (WebCore::):

2006-12-22  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Brady Eidson.
        
        Fixed <rdar://problem/4871518> Leopard9A321: Crash visiting www.audible.com 
        (WebCore::FrameLoader::loadSubframe)

        * loader/mac/FrameLoaderMac.mm:
        (WebCore::FrameLoader::createFrame): Updated to reflect the fact that
        createChildFrameNamed: now returns a WebCore::Frame* instead of a 
        WebCoreFrameBridge *.
        * page/mac/WebCoreFrameBridge.h:

2006-12-22  David Hyatt  <hyatt@apple.com>

        Make sure to actually set the stroke thickness for text decorations.
        Covered by bugzilla bug 11921.

        Reviewed by mitz

        * rendering/InlineFlowBox.cpp:
        (WebCore::InlineFlowBox::paintDecorations):
        * rendering/InlineTextBox.cpp:
        (WebCore::InlineTextBox::paintDecoration):

2006-12-22  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Rob.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=11934

        Adding/removing SVGPathSeg* items to a SVGPathElement (through SVGPathSegList
        interface) has live update problems, as the notifyAttributeChange() function
        isn't called anywhere. The context param is currently stored per SVGPathSeg,
        which is not needed - as it can be done using SVGPathSegList completely. It
        wastes memory, that is fixed. In order to get rid of the context param in
        SVGPathSeg, we need a way to map SVGPathSeg* objects to SVGStyledElement*
        objects ("context element"). That is done using a new HashMap in the
        SVGDocumentExtensions class.

        * WebCore.pro:
        * WebCore.xcodeproj/project.pbxproj:
        * bindings/js/JSSVGPathSegListCustom.cpp: Added.
        (WebCore::updatePathSegContextMap):
        (WebCore::removeFromPathSegContextMap):
        (WebCore::JSSVGPathSegList::getItem):
        (WebCore::JSSVGPathSegList::insertItemBefore):
        (WebCore::JSSVGPathSegList::replaceItem):
        (WebCore::JSSVGPathSegList::removeItem):
        (WebCore::JSSVGPathSegList::appendItem):
        * bindings/scripts/CodeGeneratorJS.pm:
        * ksvg2/misc/SVGDocumentExtensions.h:
        (WebCore::SVGDocumentExtensions::pathSegContextMap):
        (WebCore::SVGDocumentExtensions::pathSegContext):
        (WebCore::SVGDocumentExtensions::setPathSegContext):
        (WebCore::SVGDocumentExtensions::removePathSegContext):
        (WebCore::SVGDocumentExtensions::hasPathSegContext):
        * ksvg2/svg/SVGList.h:
        (WebCore::SVGList::getFirst):
        (WebCore::SVGList::getLast):
        * ksvg2/svg/SVGPathElement.cpp:
        (WebCore::SVGPathElement::createSVGPathSegMovetoAbs):
        (WebCore::SVGPathElement::createSVGPathSegMovetoRel):
        (WebCore::SVGPathElement::createSVGPathSegLinetoAbs):
        (WebCore::SVGPathElement::createSVGPathSegLinetoRel):
        (WebCore::SVGPathElement::createSVGPathSegCurvetoCubicAbs):
        (WebCore::SVGPathElement::createSVGPathSegCurvetoCubicRel):
        (WebCore::SVGPathElement::createSVGPathSegCurvetoQuadraticAbs):
        (WebCore::SVGPathElement::createSVGPathSegCurvetoQuadraticRel):
        (WebCore::SVGPathElement::createSVGPathSegArcAbs):
        (WebCore::SVGPathElement::createSVGPathSegArcRel):
        (WebCore::SVGPathElement::createSVGPathSegLinetoHorizontalAbs):
        (WebCore::SVGPathElement::createSVGPathSegLinetoHorizontalRel):
        (WebCore::SVGPathElement::createSVGPathSegLinetoVerticalAbs):
        (WebCore::SVGPathElement::createSVGPathSegLinetoVerticalRel):
        (WebCore::SVGPathElement::createSVGPathSegCurvetoCubicSmoothAbs):
        (WebCore::SVGPathElement::createSVGPathSegCurvetoCubicSmoothRel):
        (WebCore::SVGPathElement::createSVGPathSegCurvetoQuadraticSmoothAbs):
        (WebCore::SVGPathElement::createSVGPathSegCurvetoQuadraticSmoothRel):
        (WebCore::SVGPathElement::svgMoveTo):
        (WebCore::SVGPathElement::svgLineTo):
        (WebCore::SVGPathElement::svgLineToHorizontal):
        (WebCore::SVGPathElement::svgLineToVertical):
        (WebCore::SVGPathElement::svgCurveToCubic):
        (WebCore::SVGPathElement::svgCurveToCubicSmooth):
        (WebCore::SVGPathElement::svgCurveToQuadratic):
        (WebCore::SVGPathElement::svgCurveToQuadraticSmooth):
        (WebCore::SVGPathElement::svgArcTo):
        (WebCore::SVGPathElement::pathSegList):
        * ksvg2/svg/SVGPathElement.h:
        * ksvg2/svg/SVGPathSeg.cpp: Removed.
        * ksvg2/svg/SVGPathSeg.h:
        (WebCore::SVGPathSeg::SVGPathSeg):
        (WebCore::SVGPathSeg::~SVGPathSeg):
        (WebCore::SVGPathSeg::toString):
        * ksvg2/svg/SVGPathSegArc.cpp:
        (WebCore::SVGPathSegArcAbs::SVGPathSegArcAbs):
        (WebCore::SVGPathSegArcAbs::setX):
        (WebCore::SVGPathSegArcAbs::setY):
        (WebCore::SVGPathSegArcAbs::setR1):
        (WebCore::SVGPathSegArcAbs::setR2):
        (WebCore::SVGPathSegArcAbs::setAngle):
        (WebCore::SVGPathSegArcAbs::setLargeArcFlag):
        (WebCore::SVGPathSegArcAbs::setSweepFlag):
        (WebCore::SVGPathSegArcRel::SVGPathSegArcRel):
        (WebCore::SVGPathSegArcRel::setX):
        (WebCore::SVGPathSegArcRel::setY):
        (WebCore::SVGPathSegArcRel::setR1):
        (WebCore::SVGPathSegArcRel::setR2):
        (WebCore::SVGPathSegArcRel::setAngle):
        (WebCore::SVGPathSegArcRel::setLargeArcFlag):
        (WebCore::SVGPathSegArcRel::setSweepFlag):
        * ksvg2/svg/SVGPathSegArc.h:
        * ksvg2/svg/SVGPathSegClosePath.cpp:
        * ksvg2/svg/SVGPathSegClosePath.h:
        * ksvg2/svg/SVGPathSegCurvetoCubic.cpp:
        (WebCore::SVGPathSegCurvetoCubicAbs::SVGPathSegCurvetoCubicAbs):
        (WebCore::SVGPathSegCurvetoCubicAbs::setX):
        (WebCore::SVGPathSegCurvetoCubicAbs::setY):
        (WebCore::SVGPathSegCurvetoCubicAbs::setX1):
        (WebCore::SVGPathSegCurvetoCubicAbs::setY1):
        (WebCore::SVGPathSegCurvetoCubicAbs::setX2):
        (WebCore::SVGPathSegCurvetoCubicAbs::setY2):
        (WebCore::SVGPathSegCurvetoCubicRel::SVGPathSegCurvetoCubicRel):
        (WebCore::SVGPathSegCurvetoCubicRel::setX):
        (WebCore::SVGPathSegCurvetoCubicRel::setY):
        (WebCore::SVGPathSegCurvetoCubicRel::setX1):
        (WebCore::SVGPathSegCurvetoCubicRel::setY1):
        (WebCore::SVGPathSegCurvetoCubicRel::setX2):
        (WebCore::SVGPathSegCurvetoCubicRel::setY2):
        * ksvg2/svg/SVGPathSegCurvetoCubic.h:
        * ksvg2/svg/SVGPathSegCurvetoCubicSmooth.cpp:
        (WebCore::SVGPathSegCurvetoCubicSmoothAbs::SVGPathSegCurvetoCubicSmoothAbs):
        (WebCore::SVGPathSegCurvetoCubicSmoothAbs::setX):
        (WebCore::SVGPathSegCurvetoCubicSmoothAbs::setY):
        (WebCore::SVGPathSegCurvetoCubicSmoothAbs::setX2):
        (WebCore::SVGPathSegCurvetoCubicSmoothAbs::setY2):
        (WebCore::SVGPathSegCurvetoCubicSmoothRel::SVGPathSegCurvetoCubicSmoothRel):
        (WebCore::SVGPathSegCurvetoCubicSmoothRel::setX):
        (WebCore::SVGPathSegCurvetoCubicSmoothRel::setY):
        (WebCore::SVGPathSegCurvetoCubicSmoothRel::setX2):
        (WebCore::SVGPathSegCurvetoCubicSmoothRel::setY2):
        * ksvg2/svg/SVGPathSegCurvetoCubicSmooth.h:
        * ksvg2/svg/SVGPathSegCurvetoQuadratic.cpp:
        (WebCore::SVGPathSegCurvetoQuadraticAbs::SVGPathSegCurvetoQuadraticAbs):
        (WebCore::SVGPathSegCurvetoQuadraticAbs::setX):
        (WebCore::SVGPathSegCurvetoQuadraticAbs::setY):
        (WebCore::SVGPathSegCurvetoQuadraticAbs::setX1):
        (WebCore::SVGPathSegCurvetoQuadraticAbs::setY1):
        (WebCore::SVGPathSegCurvetoQuadraticRel::SVGPathSegCurvetoQuadraticRel):
        (WebCore::SVGPathSegCurvetoQuadraticRel::setX):
        (WebCore::SVGPathSegCurvetoQuadraticRel::setY):
        (WebCore::SVGPathSegCurvetoQuadraticRel::setX1):
        (WebCore::SVGPathSegCurvetoQuadraticRel::setY1):
        * ksvg2/svg/SVGPathSegCurvetoQuadratic.h:
        * ksvg2/svg/SVGPathSegCurvetoQuadraticSmooth.cpp:
        (WebCore::SVGPathSegCurvetoQuadraticSmoothAbs::SVGPathSegCurvetoQuadraticSmoothAbs):
        (WebCore::SVGPathSegCurvetoQuadraticSmoothAbs::setX):
        (WebCore::SVGPathSegCurvetoQuadraticSmoothAbs::setY):
        (WebCore::SVGPathSegCurvetoQuadraticSmoothRel::SVGPathSegCurvetoQuadraticSmoothRel):
        (WebCore::SVGPathSegCurvetoQuadraticSmoothRel::setX):
        (WebCore::SVGPathSegCurvetoQuadraticSmoothRel::setY):
        * ksvg2/svg/SVGPathSegCurvetoQuadraticSmooth.h:
        * ksvg2/svg/SVGPathSegLineto.cpp:
        (WebCore::SVGPathSegLinetoAbs::SVGPathSegLinetoAbs):
        (WebCore::SVGPathSegLinetoAbs::setX):
        (WebCore::SVGPathSegLinetoAbs::setY):
        (WebCore::SVGPathSegLinetoRel::SVGPathSegLinetoRel):
        (WebCore::SVGPathSegLinetoRel::setX):
        (WebCore::SVGPathSegLinetoRel::setY):
        * ksvg2/svg/SVGPathSegLineto.h:
        * ksvg2/svg/SVGPathSegLinetoHorizontal.cpp:
        (WebCore::SVGPathSegLinetoHorizontalAbs::SVGPathSegLinetoHorizontalAbs):
        (WebCore::SVGPathSegLinetoHorizontalAbs::setX):
        (WebCore::SVGPathSegLinetoHorizontalRel::SVGPathSegLinetoHorizontalRel):
        (WebCore::SVGPathSegLinetoHorizontalRel::setX):
        * ksvg2/svg/SVGPathSegLinetoHorizontal.h:
        * ksvg2/svg/SVGPathSegLinetoVertical.cpp:
        (WebCore::SVGPathSegLinetoVerticalAbs::SVGPathSegLinetoVerticalAbs):
        (WebCore::SVGPathSegLinetoVerticalAbs::setY):
        (WebCore::SVGPathSegLinetoVerticalRel::SVGPathSegLinetoVerticalRel):
        (WebCore::SVGPathSegLinetoVerticalRel::setY):
        * ksvg2/svg/SVGPathSegLinetoVertical.h:
        * ksvg2/svg/SVGPathSegList.cpp:
        (WebCore::SVGPathSegList::SVGPathSegList):
        (WebCore::SVGPathSegList::context):
        * ksvg2/svg/SVGPathSegList.h:
        * ksvg2/svg/SVGPathSegList.idl:
        * ksvg2/svg/SVGPathSegMoveto.cpp:
        (WebCore::SVGPathSegMovetoAbs::SVGPathSegMovetoAbs):
        (WebCore::SVGPathSegMovetoAbs::setX):
        (WebCore::SVGPathSegMovetoAbs::setY):
        (WebCore::SVGPathSegMovetoRel::SVGPathSegMovetoRel):
        (WebCore::SVGPathSegMovetoRel::setX):
        (WebCore::SVGPathSegMovetoRel::setY):
        * ksvg2/svg/SVGPathSegMoveto.h:

2006-12-22  Mitz Pettel  <mitz@webkit.org>

        Reviewed by Beth.

        - fix http://bugs.webkit.org/show_bug.cgi?id=11903
          REGRESSION: outline not drawn if line style is dashed.

        This fixes a bunch of existing pixel tests.

        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::drawBorder):

2006-12-22  John Sullivan  <sullivan@apple.com>

        Reviewed by Kevin Decker

        - renamed markMisspellingsInAdjacentWords to markMisspellingsAfterTypingToPosition
          in anticipation of fixing it to work more correctly with grammar checking, where
          only checking adjacent words isn't good enough.

        * editing/Editor.h:
        renamed markMisspellingsInAdjacentWords to markMisspellingsAfterTypingToPosition 

        * editing/TypingCommand.cpp:
        (WebCore::TypingCommand::markMisspellingsAfterTyping):
        updated for name change

        * editing/mac/EditorMac.mm:
        (WebCore::Editor::markMisspellingsAfterTypingToPosition):
        renamed from markMisspellingsInAdjacentWords and added FIXME comment

2006-12-22  Eric Seidel  <eric@webkit.org>

        Reviewed by aroben.

        http://bugs.webkit.org/show_bug.cgi?id=11912
        Overriding visibility does not behave as expected.

        * rendering/RenderSVGContainer.cpp:
        (WebCore::RenderSVGContainer::paint): allow children to draw when container is visibility='hidden'

2006-12-22  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Rob.

        Fix SVGPathSeg JS object creation. SVGPathSegList has to return
        the actual SVGPathSegLineToAbs/MoveToRel... object instead of a pure
        SVGPathSeg JS object.

        * WebCore.xcodeproj/project.pbxproj:
        * WebCore/bindings/js/JSSVGPathSegCustom.cpp: Added.
        * bindings/scripts/CodeGeneratorJS.pm:

2006-12-21  Beth Dakin  <bdakin@apple.com>

        Reviewed by Geoff.

        Fix for <rdar://problem/4897162> REGRESSION: Attempting to create a 
        new message in .Mac web mail causes Safari to crash 
        ( KJS::DOMCSSStyleDeclaration::put() + 368 )

        This was a regression from my clone-node change. This fix is very 
        simple.

        * dom/StyledElement.cpp:
        (WebCore::StyledElement::copyNonAttributeProperties): Must set the 
        data that getInlineStyleDecl() points to instead of setting 
        m_inlineStyleDecl directly. I also changed some variable names.
        * dom/StyledElement.h: Don't need parameter name here.

2006-12-21  Adele Peterson  <adele@apple.com>

        Reviewed by Geoff.

        - Fix for <rdar://problem/4895716> REGRESSION: Pressing return key in search field doesn't begin search

        Test: fast/events/onsearch-enter.html

        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::defaultEventHandler): Calls onSearch when handling "Enter".  Also removed
         special case for AppKit search fields, so now the enter event is considered handled here.
        (WebCore::HTMLInputElement::onSearch): Added. Dispatches search event.
        * html/HTMLInputElement.h: Added onSearch.
        * rendering/RenderTextControl.cpp: (WebCore::RenderTextControl::onSearch): Calls onSearch on the node.

2006-12-21  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Brady Eidson.
        
        Fixed <rdar://problem/4897205> ASSERTION FAILURE in ContainerNode::queuePostAttachCallback 
        when creating an iframe from an iframe onload handler

        I added that assertion to try to "keep things simple," but I've found a 
        testcase that demonstrates why things need to be complicated.

        * dom/ContainerNode.cpp:
        (WebCore::ContainerNode::queuePostAttachCallback):

2006-12-21  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin.

        http://bugs.webkit.org/show_bug.cgi?id=11919
        Allow setting CSS values to null.

        * bindings/js/kjs_css.cpp:
        (KJS::DOMCSSStyleDeclaration::put):
        (KJS::DOMCSSStyleDeclarationProtoFunc::callAsFunction):
        Convert null values to null strings.

2006-12-21  Rob Buis  <buis@kde.org>

        Reviewed by Anders.

        http://bugs.webkit.org/show_bug.cgi?id=11898
        CSSMediaRule functions insertRule and deleteRule assert when called from js in debug builds

        Test explicitly for the two media rule functions so it ends up calling callAsFunction.

        * bindings/js/kjs_css.cpp:
        (KJS::DOMCSSRule::getOwnPropertySlot):

2006-12-21  Lars Knoll <lars@trolltech.com>

        Reviewed by Zack

        * loader/FrameLoaderClient.h:
        * loader/qt/FrameLoaderQt.cpp:
        (WebCore::FrameLoader::checkLoadCompleteForThisFrame):
        (WebCore::FrameLoader::partClearedInBegin):
        (WebCore::FrameLoader::restoreDocumentState):
                comment out a few notImplemented() warnings
        * platform/qt/FrameQt.cpp:
        (WebCore::FrameQt::bindingRootObject):
        (WebCore::FrameQt::addPluginRootObject):
        * platform/qt/FrameQt.h:
                 implement these

2006-12-20  David Hyatt  <hyatt@apple.com>

        Make sure the execrable match-nearest-mail-blockquote-color CSS property is actually initialized (amazingly
        it started off with the value "match", since it wasn't even initialized).  Now that it is actually being
        initialized and properly copied and assigned to, tests have failed.  It seems that we were getting the
        behavior of "match" by default, when the initial value was supposed to be "normal."

        Because this property really should not exist at all, it's unclear to me what the right solution is here.
        
        * rendering/RenderStyle.cpp:
        (WebCore::StyleCSS3NonInheritedData::StyleCSS3NonInheritedData):
        (WebCore::StyleCSS3NonInheritedData::operator==):
        * rendering/RenderStyle.h:

2006-12-20  Brady Eidson  <beidson@apple.com>

        Reviewed by Adam's rubberstamp

        Accidentally left a logging channel on in my checkin

        * platform/Logging.cpp:
        (WebCore::):

2006-12-21  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver.

        Fix removeItem recursively calling itself (!). It was meant to call m_vector.remove(index)
        not removeItem(index, ec). This bug is in SVN for quite some time now :-)

        * ksvg2/svg/SVGList.h:
        (WebCore::SVGList::removeItem):

2006-12-20  David Harrison  <harrison@apple.com>

        Reviewed by John Sullivan.

        <rdar://problem/4893376> REGRESSION: Crash occurs at WebCoreFrameBridge fontForSelection: when drag selecting from a line break
        
        No layout test added because crash only happens in path where editing window is key,
        which is never the case for the automated tests.

        * page/mac/WebCoreFrameBridge.mm:
        (-[WebCoreFrameBridge fontForSelection:]):
        Add nil check of fontForSelection() result.

2006-12-21  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Maciej.

        Fix dynamic gradient changes, via JS. It actually worked before, but it
        wasn't repainted. Behave just like the pattern notifyAttributeChange() code now.

        * ksvg2/svg/SVGGradientElement.cpp:
        (WebCore::SVGGradientElement::notifyAttributeChange):

2006-12-20  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Darin Adler.

        Fixed <rdar://problem/4809825>. We need to check isSafeScript when converting
        a Location to string. 
        
        It's really a bug, and poor design, for objects to override toString.
        Subclasses that want custom toString implementations should add a toString 
        function to their prototypes instead of overriding the JavaScript ToString 
        operation. Following this design pattern would have avoided this bug in the
        first place.
        
        * bindings/js/kjs_window.cpp:
        (KJS::Location::toString):

2006-12-20  David Hyatt  <hyatt@apple.com>

        Fix SVG stroking.  Make strokeThickness() get pushed into CG immediately
        when set in the GraphicsContext.  Remove setLineWidth since it is
        redundant with setStrokeThickness now.

        Reviewed by mitz

        * html/CanvasRenderingContext2D.cpp:
        (WebCore::CanvasRenderingContext2D::setLineWidth):
        * platform/graphics/GraphicsContext.cpp:
        (WebCore::GraphicsContext::setPlatformStrokeThickness):
        (WebCore::GraphicsContext::setPlatformStrokeStyle):
        * platform/graphics/GraphicsContext.h:
        * platform/graphics/cg/GraphicsContextCG.cpp:
        (WebCore::GraphicsContext::drawLine):
        (WebCore::GraphicsContext::drawEllipse):
        (WebCore::GraphicsContext::strokeArc):
        (WebCore::GraphicsContext::drawConvexPolygon):
        (WebCore::GraphicsContext::setPlatformStrokeThickness):
        * platform/graphics/qt/GraphicsContextQt.cpp:
        * platform/mac/FontMac.mm:
        (WebCore::Font::drawComplexText):
        (WebCore::Font::drawGlyphs):

2006-12-20  David Hyatt  <hyatt@apple.com>

        Fix for bug 11893, white text on form controls.  Just make sure that
        all form control drawing in RenderTheme is bracketed by save/restore
        calls.

        Reviewed by adele

        * platform/mac/LocalCurrentGraphicsContext.h:
        * platform/mac/LocalCurrentGraphicsContext.mm:
        (WebCore::LocalCurrentGraphicsContext::LocalCurrentGraphicsContext):
        (WebCore::LocalCurrentGraphicsContext::~LocalCurrentGraphicsContext):
        * rendering/RenderThemeMac.mm:
        (WebCore::RenderThemeMac::paintTextField):
        (WebCore::RenderThemeMac::paintTextArea):

2006-12-20  Mark Rowe  <bdash@webkit.org>

        Reviewed by Anders.

        Fix leak of CGContextRef from GraphicsContext::createImageBuffer.

        * platform/graphics/cg/GraphicsContextCG.cpp:
        (WebCore::GraphicsContext::createImageBuffer): Release newly-created CGContextRef after passing it to GraphicsContext.

2006-12-20  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Mark Rowe.

        <rdar://problem/4871993> WebCore-421.31 build fails with "Public API change" error when gcc 3.3 is the default compiler

        * bindings/scripts/CodeGeneratorObjC.pm: ignore blank lines in the public API check

2006-12-20  David Harrison  <harrison@apple.com>

        Reviewed by John Sullivan.

        <rdar://problem/4570218> REGRESSION (?-10.4.7): cntl-K only works the first time

        Test:
        * editing/deleting/delete-to-end-of-paragraph.html
        
        * editing/TypingCommand.cpp:
        (WebCore::TypingCommand::forwardDeleteKeyPressed):
        If the selection was a caret at the end of the paragraph, extend selection so it wraps to the start of next paragraph (if any),

2006-12-20  Nikolas Zimmermann  <zimmermann@kde.org>

        Build fix, reviewed by Mitz.

        Fix mac build, by using proper float -> int conversion.

        * rendering/InlineFlowBox.cpp:
        (WebCore::InlineFlowBox::placeBoxesHorizontally):

2006-12-20  David Hyatt  <hyatt@apple.com>

        Make sure text decoration colors prefer stroke over fill (and honor both of the new CSS properties added
        for these values over color).

        Reviewed by mitz

        Added fast/text/stroking-decorations.html

        * rendering/InlineFlowBox.cpp:
        (WebCore::InlineFlowBox::paintDecorations):
        * rendering/RenderObject.cpp:
        (WebCore::decorationColor):
        (WebCore::RenderObject::getTextDecorationColors):

2006-12-20  David Kilzer  <ddkilzer@kilzer.net>

        Reviewed by Darin.

        http://bugs.webkit.org/show_bug.cgi?id=11746
        REGRESSION(r14931): Outlook Web Access incorrectly positions the insertion point when replying to e-mail

        Set caret at beginning of text on initial focus.

        Test: fast/forms/textarea-initial-caret-position.html

        * html/HTMLTextAreaElement.cpp:
        (WebCore::HTMLTextAreaElement::updateFocusAppearance):

2006-12-20  David Hyatt  <hyatt@apple.com>

        Fix for bug 11889, support stroking and filling of HTML text from CSS.  This patch adds four new CSS properties:
        text-fill-color, text-stroke-color, text-stroke-width and text-stroke (a shorthand for the other two).  Text
        is filled and not stroked by default and does so using the text-fill-color.  If this property is not set, then
        color is used.

        Stroking is accomplished by setting a stroke width.  Stroke color, if omitted, will be picked up from the color
        property.  You can set either color to be transparent or partially transparent.  A fully transparent fill color is
        the way to achieve an "outline" effect where only stroking happens.

        Stroking and filling are both customizable inside the ::selection pseudo-element, and so when selecting you can
        vary colors and widths.

        text-shadow applies to both the stroke and the fill.

        text-decorations do not yet respect the stroke/fill colors.  This will follow in a later patch.

        Reviewed by mitz

        Added fast/text/stroking.html as a layout test.  Enhanced RenderTreeAsText.cpp to dump fill and stroke information.

        * css/CSSComputedStyleDeclaration.cpp:
        (WebCore::):
        (WebCore::CSSComputedStyleDeclaration::getPropertyCSSValue):
        * css/CSSPropertyNames.in:
        * css/cssparser.cpp:
        (WebCore::CSSParser::parseValue):
        * css/cssstyleselector.cpp:
        (WebCore::CSSStyleSelector::applyProperty):
        * platform/mac/FontMac.mm:
        (WebCore::Font::drawComplexText):
        (WebCore::Font::drawGlyphs):
        * rendering/InlineFlowBox.cpp:
        (WebCore::InlineFlowBox::placeBoxesHorizontally):
        * rendering/InlineFlowBox.h:
        (WebCore::InlineFlowBox::InlineFlowBox):
        (WebCore::InlineFlowBox::maxHorizontalVisualOverflow):
        * rendering/InlineTextBox.cpp:
        (WebCore::updateGraphicsContext):
        (WebCore::InlineTextBox::paint):
        (WebCore::InlineTextBox::paintSelection):
        (WebCore::InlineTextBox::paintMarkedTextBackground):
        (WebCore::InlineTextBox::paintTextMatchMarker):
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::selectionForegroundColor):
        * rendering/RenderStyle.cpp:
        (WebCore::StyleCSS3InheritedData::StyleCSS3InheritedData):
        (WebCore::StyleCSS3InheritedData::operator==):
        (WebCore::RenderStyle::diff):
        * rendering/RenderStyle.h:
        (WebCore::RenderStyle::textStrokeColor):
        (WebCore::RenderStyle::textStrokeWidth):
        (WebCore::RenderStyle::textFillColor):
        (WebCore::RenderStyle::setTextStrokeColor):
        (WebCore::RenderStyle::setTextStrokeWidth):
        (WebCore::RenderStyle::setTextFillColor):
        (WebCore::RenderStyle::initialTextStrokeWidth):
        * rendering/RenderTreeAsText.cpp:
        (WebCore::operator<<):

2006-12-19  Adele Peterson  <adele@apple.com>

        Reviewed by Anders.

        - Fix for <rdar://problem/3824247> Select All works even if -khtml-user-select:none; style is set

        Also made user-select:none work on new list boxes, and cleaned up the list box defaultEventHandler.

        Test: editing/selection/select-all-user-select-none.html

        * editing/SelectionController.cpp: (WebCore::SelectionController::selectAll): Make sure canSelect is true on the root renderer.
        * html/HTMLSelectElement.cpp:
        (WebCore::HTMLSelectElement::canSelectAll): Check canSelect here.
        (WebCore::HTMLSelectElement::selectAll): Added nil check for renderer.
        (WebCore::HTMLSelectElement::defaultEventHandler): Return early if the event has been handled.
        (WebCore::HTMLSelectElement::listBoxDefaultEventHandler): Check canSelect here.
        * html/HTMLSelectElement.h:

2006-12-19  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Adele.

        <rdar://problem/4701860> 
        http://bugs.webkit.org/show_bug.cgi?id=11010
        [9A255] Crash in WebCore::EventTargetNode::dispatchEvent
        
        * html/HTMLScriptElement.cpp:
        (WebCore::HTMLScriptElement::notifyFinished):
        Ref the script element while running the script since it can be freed
        when executing the script.

2006-12-19  Darin Adler  <darin@apple.com>

        Reviewed by Geoff.

        - <rdar://problem/4885227>
          frame resizing is now live and no longer does direct drawing

        * html/HTMLFrameSetElement.h: Made frameBorder() and noResize() const.
        Added rowLengths() and colLengths() getters so that we don't have to
        have RenderFrameSet as a friend. Stopped using bit fields.

        * html/HTMLFrameSetElement.cpp:
        (WebCore::HTMLFrameSetElement::defaultEventHandler): Removed now-uneeded
        check for contextmenu events. Look at return value from userResize to
        decide whether to mark the event as "default handled". In the case where
        the event is handled, don't call through to the base class.

        * rendering/RenderFrameSet.h: No longer mark HTMLFrameSetElement as a
        friend. Made positionFrames and canResize private, and changed canResize
        to take an IntPoint. Added isResizingRow, isResizingColumn, canResizeRow,
        and canResizeColumn functions to be used soon for cursor feedback.
        Removed override of non-virtual element() function and replaced it with
        a private frameSet() inline function. Grouped all the data members for
        each axis into a GridAxis class, and made one called m_cols and one called
        m_rows. Used vectors for the resizable bits of this instead of new/delete
        arrays. Added a constant named "noSplit" so we don't have to use -1
        everywhere explicitly for this purpose. Renamed setResizing to
        setIsResizing and made it private. Eliminated resizing() function.
        Added new private helper functions, layOutAxis, findNonResizableSplits,
        splitPosition, hitTestSplit, startResizing, and continueResizing.
        Renamed m_resizing to m_isResizing, and m_clientResizing to
        m_isChildResizing.

        * rendering/RenderFrameSet.cpp:
        (WebCore::RenderFrameSet::RenderFrameSet): Removed now-unneeded initialization
        that is handled by the GridAxis and Vector constructors.
        (WebCore::RenderFrameSet::~RenderFrameSet): Ditto (for destructors).
        (WebCore::RenderFrameSet::GridAxis::GridAxis): Added.
        (WebCore::RenderFrameSet::frameSet): Added. Inline function so we don't have
        to cast the result of node() or element() everywhere.
        (WebCore::RenderFrameSet::nodeAtPoint): Updated for name changes.
        (WebCore::RenderFrameSet::GridAxis::resize): Added. Helper function to be used
        in the layout function.
        (WebCore::RenderFrameSet::layOutAxis): Added. Factored out the part of the
        layout function that used to be inside a for loop for the two axes.
        The algorithm is otherwise unchanged.
        (WebCore::RenderFrameSet::findNonResizableSplits): Added. Factored out the
        code that set up the "split variable" arrays from the layout function.
        (WebCore::RenderFrameSet::layout): Moved the bulk of this function into the
        new helpers. This allowed me to remove the use of goto.
        (WebCore::RenderFrameSet::positionFrames): Updated for change to data structures.
        Also added some more local variables for clarity.
        (WebCore::RenderFrameSet::startResizing): Added. Code factored out of the
        userResize function that handles mousedown events that might begin a resize.
        (WebCore::RenderFrameSet::continueResizing): Added. Code factored out of the
        userResize function that handles mouse events that continue a resize already
        in progress, including mouseup events that end the resizing. Uses the new
        splitPosition function so it can be used over and over again while resizing.
        (WebCore::RenderFrameSet::userResize): Restructured to use the new helper
        functions. Removed the direct drawing of a gray bar during mouse movement;
        instead we do the resizing live.
        (WebCore::RenderFrameSet::setIsResizing): Updated for name changes.
        (WebCore::RenderFrameSet::isResizingRow): Added.
        (WebCore::RenderFrameSet::isResizingColumn): Added.
        (WebCore::RenderFrameSet::canResize): Changed to use hitTestSplit for clarity.
        (WebCore::RenderFrameSet::canResizeRow): Added.
        (WebCore::RenderFrameSet::canResizeColumn): Added.
        (WebCore::RenderFrameSet::splitPosition): Added.
        (WebCore::RenderFrameSet::hitTestSplit): Added. Contains the guts of the code
        that was used both in canResize and userResize before -- now it's shared.
        (WebCore::RenderFrameSet::dump): Updated for name changes.

2006-12-19  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by harrison
        
        Added Selection::removeAllRanges() and ::addRange()

        * bindings/js/kjs_window.cpp:
        (KJS::SelectionFunc::callAsFunction): Added the bindings for
        the two new functions.
        * bindings/js/kjs_window.h:
        (KJS::Selection::):
        * editing/SelectionController.cpp:
        (WebCore::SelectionController::removeAllRanges): Equivalent
        to clear().
        (WebCore::SelectionController::addRange): Until we support
        discontiguous selections, the new selected range is the 
        union of the old selected range and the passed range if
        the two intersect, and the old range if they don't.
        * editing/SelectionController.h:

2006-12-19  Beth Dakin  <bdakin@apple.com>

        Reviewed by Hyatt.

        Fix for <rdar://problem/4860924> outerHTML gives an out-of-date 
        result when applied to a clone

        We were only copying the m_inlineStyleDecl over to clones, but we 
        need to copy m_isStyleAttributeValid and 
        m_synchronizingStyleAttribute as well to know when we have to 
        update style, etc.

        * dom/StyledElement.cpp:
        (WebCore::StyledElement::copyNonAttributeProperties): Copy over all 
        three member variables.
        * dom/StyledElement.h:
        * html/HTMLElement.cpp:
        (WebCore::HTMLElement::cloneNode): No longer need to copy the 
        inline style decl explicitly because copyNonAttributeProperties() 
        will take care of it.
        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::copyNonAttributeProperties): Call into 
        parent class implementation. This is important now that there is 
        more than one implementation of this function.

2006-12-19  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Darin Adler.

        Fixed http://bugs.webkit.org/show_bug.cgi?id=11880
        REGRESSION (r18304): Assertion failure in -[WebHTMLView _canProcessDragWithDraggingInfo:] 
        when dragging over the window's a scroll bar (innerFrame)
        
        RenderLayer needs to check 'active,' when deciding what to do if hit testing 
        hasn't hit anything, because we want the default hit testing mechanism to return the 
        document when we hit a scrollbar.
        
        This problem shows that the idea of 'capturing' was a little too ambitious
        in hit testing, at least given the current state of things. So, I've replaced
        'capturing' with 'mouseUp,' the condition that provided the immediate need
        for the capturing flag in the first place.

        * page/EventHandler.cpp:
        (WebCore::EventHandler::handleMouseMoveEvent):
        * rendering/HitTestRequest.h: Removed 'capturing' 
        (WebCore::HitTestRequest::HitTestRequest):
        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::hitTestLayer):

2006-12-19  Brady Eidson  <beidson@apple.com>

        Reviewed by Ada

        Added a logging channel for network activity for loader work

        * platform/Logging.cpp:
        (WebCore::):
        * platform/Logging.h:
        * platform/mac/LoggingMac.mm:
        (WebCore::InitializeLoggingChannelsIfNecessary):

2006-12-19  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by hyatt
        
        <rdar://problem/4888891>
        Docs & Spreadsheets: Comment fails to insert if text is selected in the document
        
        * dom/Range.cpp:
        (WebCore::Range::surroundContents): If startContainer is a text node,
        it will be split when the range is extracted, and it will be its parent
        that will have to accept newParent.  Also cleaned up some code with 
        isDescendantOf.

2006-12-19  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.

        <rdar://problem/4891774> Local WebCore/WebBrowser builds fail in 9A328 due to warning about ObjC-2.0 language features

        * WebCore.xcodeproj/project.pbxproj:

2006-12-19  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver.

        Fix SVGList index validation (off-by-one error).

        Adding new testcase js-font-test.svg, which uses SVGLengthList interface.
        (This is a very old ksvg1 testcase, adopted for SVG1.1)

        * ksvg2/svg/SVGList.h:
        (WebCore::SVGList::getItem):
        (WebCore::SVGList::replaceItem):
        (WebCore::SVGList::removeItem):

2006-12-19  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=11879

        Fix pattern on stroke/fill of text.

        * ksvg2/svg/SVGPatternElement.cpp:
        (WebCore::SVGPatternElement::notifyAttributeChange):
        * platform/graphics/svg/SVGPaintServerGradient.cpp:
        (WebCore::SVGPaintServerGradient::SVGPaintServerGradient):
        * platform/graphics/svg/cg/SVGPaintServerGradientCg.cpp:
        (WebCore::SVGPaintServerGradient::teardown):
        (WebCore::SVGPaintServerGradient::setup):
        * platform/graphics/svg/cg/SVGPaintServerPatternCg.cpp:
        (WebCore::SVGPaintServerPattern::setup):

2006-12-19  Alice Liu  <alice.liu@apple.com>

        Build fix

        * platform/graphics/ImageBuffer.cpp:

2006-12-19  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin.

        http://bugs.webkit.org/show_bug.cgi?id=7296
        JavaScript error not thrown when trying to set a CSS property to an invalid value

        * bindings/js/kjs_css.cpp:
        (KJS::DOMCSSStyleDeclaration::put): When not in Dashboard compatibility mode,
        raise exception for invalid values. Also removed an unnecessary call to
        removeProperty(), which prevented the property value from being preserved in 
        error case.

        * css/CSSMutableStyleDeclaration.cpp:
        (WebCore::CSSMutableStyleDeclaration::setProperty): Moved the handling of
        empty property values here. Also removed an unnecessary call to removeProperty().

2006-12-19  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Adam.

        * dom/Document.h:
        * page/EventHandler.h:
        Use correct forward declarations for HitTestRequest.
        
2006-12-19  Nikolas Zimmermann  <zimmermann@kde.org>

        Build fix, not reviewed.

        Fix Qt/Linux build. Missing GraphicsContext.h include.
        Fix Mac build, by adding lroundf() (I swear this compiled w/o that, locally :-)

        * platform/graphics/qt/ImageBufferQt.cpp:
        * ksvg2/svg/SVGPatternElement.cpp:

2006-12-19  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Sam. Previous attempts reviewed by Oliver & Eric.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=11867

        Bring back masking, by adding off-screen rendering functionality in GraphicsContext.
        Add new "static GraphicsContext* createImageContext(const IntSize& size, bool grayScale)"
        function, and implement it with CGBitmapContext in the GraphicsContextCG (stubs for Qt.)

        Mask image sizes are dynamically calculated using the passed bounding box in applyMask,
        as it was orignally planned. Gradient stroke mask image sizes aren't hardcoded to 2048x2048
        anymore, but are as well dynamically calculated using getAbsoluteRepaintRect().

        Add new ImageBuffer class encapsulating the size of the image, a platform-specific
        handle (ie. CGImageRef for CG platform) plus the GraphicsContext pointer, obtained
        via GraphicsContext::createImageBuffer. Offer a generic logic for rendering subtrees
        of the rendering tree into a ImageBuffer (see renderSubtreeToImage function)
        ImageBufferCG is completly implemented, ImageBufferQt is stubbed.

        Also add correct default values for x/y/width/height of <mask>.
        Fixes masking related LayoutTests, and speeds up gradient-on-stroke a lot.

        * CMakeLists.txt:
        * WebCore.pro:
        * WebCore.xcodeproj/project.pbxproj:
        * ksvg2/svg/SVGFEImageElement.cpp:
        * ksvg2/svg/SVGImageElement.cpp:
        * ksvg2/svg/SVGMaskElement.cpp:
        (WebCore::SVGMaskElement::SVGMaskElement):
        (WebCore::SVGMaskElement::attributeChanged):
        (WebCore::SVGMaskElement::parseMappedAttribute):
        (WebCore::SVGMaskElement::drawMaskerContent):
        (WebCore::SVGMaskElement::canvasResource):
        * ksvg2/svg/SVGMaskElement.h:
        * ksvg2/svg/SVGPatternElement.cpp:
        (WebCore::SVGPatternElement::drawPatternContentIntoTile):
        (WebCore::SVGPatternElement::notifyAttributeChange):
        * ksvg2/svg/SVGPatternElement.h:
        * platform/graphics/GraphicsContext.h:
        * platform/graphics/ImageBuffer.cpp: Added.
        (WebCore::ImageBuffer::renderSubtreeToImage):
        * platform/graphics/ImageBuffer.h: Added.
        * platform/graphics/cg/GraphicsContextCG.cpp:
        (WebCore::GraphicsContext::createImageBuffer):
        * platform/graphics/cg/ImageBufferCG.cpp: Added.
        (WebCore::ImageBuffer::ImageBuffer):
        (WebCore::ImageBuffer::~ImageBuffer):
        (WebCore::ImageBuffer::size):
        (WebCore::ImageBuffer::context):
        (WebCore::ImageBuffer::cgImage):
        * platform/graphics/mac/GraphicsContextMac.mm:
        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::GraphicsContext::createImageBuffer):
        * platform/graphics/qt/ImageBufferQt.cpp: Added.
        (WebCore::ImageBuffer::ImageBuffer):
        (WebCore::ImageBuffer::~ImageBuffer):
        (WebCore::ImageBuffer::size):
        (WebCore::ImageBuffer::context):
        * platform/graphics/svg/SVGPaintServerGradient.h:
        * platform/graphics/svg/SVGPaintServerPattern.cpp:
        (WebCore::SVGPaintServerPattern::tile):
        (WebCore::SVGPaintServerPattern::setTile):
        * platform/graphics/svg/SVGPaintServerPattern.h:
        * platform/graphics/svg/SVGResourceImage.h: Removed.
        * platform/graphics/svg/SVGResourceMasker.cpp:
        (WebCore::SVGResourceMasker::setMask):
        (WebCore::SVGResourceMasker::mask):
        * platform/graphics/svg/SVGResourceMasker.h:
        * platform/graphics/svg/cg/SVGPaintServerGradientCg.cpp:
        (WebCore::SVGPaintServerGradient::teardown):
        (WebCore::SVGPaintServerGradient::renderPath):
        (WebCore::SVGPaintServerGradient::setup):
        * platform/graphics/svg/cg/SVGPaintServerPatternCg.cpp:
        (WebCore::patternCallback):
        (WebCore::SVGPaintServerPattern::setup):
        * platform/graphics/svg/cg/SVGResourceImageCg.cpp: Removed.
        * platform/graphics/svg/cg/SVGResourceMaskerCg.mm:
        (WebCore::SVGResourceMasker::applyMask):
        * platform/graphics/svg/qt/SVGResourceImageQt.cpp: Removed.

2006-12-19  David Hyatt  <hyatt@apple.com>

        Make sure to initialize the CG fill and stroke colors to our initial fill/stroke colors when first
        constructing a GraphicsContextCG.  Because Safari actually draws text in the bookmarks bar using GraphicsContext
        and sets a fill color, this could only really be seen in another WebKit app.

        Patched GraphicsContextQt as well, since it has the same pattern.

        Reviewed by bdash

        * platform/graphics/cg/GraphicsContextCG.cpp:
        (WebCore::setCGFillColor):
        (WebCore::setCGStrokeColor):
        (WebCore::GraphicsContext::GraphicsContext):

2006-12-19  Lars Knoll <lars@trolltech.com>

        Reviewed by Rob.

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::URL):\
                Fix a crash, because of the incompletely ported loader
        * platform/qt/FontQt.cpp:
        (WebCore::Font::drawGlyphs):
                Adapt to the changes in GraphicsContext

2006-12-19  David Hyatt  <hyatt@apple.com>

        Convert stroke thickness to a float.  This allows the thickness argument to strokeArc to be eliminated.
       
        Reviewed by olliej

        * platform/graphics/GraphicsContext.cpp:
        (WebCore::GraphicsContext::setStrokeThickness):
        (WebCore::GraphicsContext::strokeThickness):
        (WebCore::GraphicsContext::setPlatformStrokeThickness):
        * platform/graphics/GraphicsContext.h:
        * platform/graphics/cg/GraphicsContextCG.cpp:
        (WebCore::GraphicsContext::drawEllipse):
        (WebCore::GraphicsContext::strokeArc):
        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::GraphicsContext::strokeArc):
        (WebCore::GraphicsContext::setPlatformStrokeThickness):
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::drawBorderArc):

2006-12-19  David Hyatt  <hyatt@apple.com>

        Rename drawArc to strokeArc and remove its strange behavior of trying to "fill" by stroking using the passed in
        thickness.  Now the method is purely about stroking an arc and always uses the passed in thickness.   Fix the
        border-radius code that calls the method so that it makes more sense now.  If stroke thickness is converted
        to a float, then even the extra argument can go away, and this method can be a clean stroke of an arc.

        Make sure to get square list markers right by setting both stroke and fill color properly.

        Reviewed by mitz, olliej

        * platform/graphics/GraphicsContext.h:
        * platform/graphics/cg/GraphicsContextCG.cpp:
        (WebCore::GraphicsContext::strokeArc):
        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::GraphicsContext::strokeArc):
        * rendering/RenderListMarker.cpp:
        (WebCore::RenderListMarker::paint):
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::drawBorderArc):

2006-12-18  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Beth Dakin.

        Fixed <rdar://problem/4549745> REGRESSION: scrolling on Google maps 
        continues after the mouse is released outside the window (8137)
        
        The RenderLayer hit testing code assumed that, when the mouse was outside
        the WebView, we only needed to capture mouse events while the mouse was
        down (in other words, mouse move events). We actually need to capture mouse 
        up events, as well.

        * dom/Document.cpp:
        (WebCore::Document::prepareMouseEvent): To match EventHandler::prepareMouseEvent, 
        I changed this function to take a HitTestRequest instead of the broken-out values of one.
        For clarity, I moved an assert to top of function.
        (WebCore::Document::addMarker): Removed stray character.
        * dom/Document.h:

        * page/EventHandler.cpp: Changed prepareMouseEvent to take a HitTestRequest,
        instead of the broken-out values of one. This simplified the code, and made
        the task of adding an extra, optional parameter to hit testing much easier.
        (WebCore::EventHandler::handleMousePressEvent):
        (WebCore::EventHandler::handleMouseDoubleClickEvent):
        (WebCore::EventHandler::handleMouseMoveEvent): Set the 'capturing' flag
        if the move occurs while the mouse is down. This replaces RenderLayer's
        heavy-handed assumption that we should always capture if the mouse is down.
        (WebCore::EventHandler::handleMouseReleaseEvent): Set the 'capturing'
        flag, since we assume every mouse up follows a mouse down inside the WebView.
        (We'd like to ASSERT as much, but DRT's event sending mechanism is crazy, and
        violates this axiom.)
        (WebCore::EventHandler::updateDragAndDrop):
        (WebCore::EventHandler::prepareMouseEvent):
        (WebCore::EventHandler::handleWheelEvent):
        (WebCore::EventHandler::sendContextMenuEvent):
        (WebCore::EventHandler::hoverTimerFired):
        * page/EventHandler.h:

        * rendering/HitTestRequest.h:
        (WebCore::HitTestRequest::HitTestRequest): Added 'capturing' data member,
        which specifies whether the hit test should capture mouse events that occur
        outside the WebView.

        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::hitTestLayer): Moved misleading comment to where
        it actually applies. Changed 'active' test to new 'capturing' test, so
        the hit test requester can decide whether we need to capture mouse events
        that don't intersect any layer.

2006-12-18  David Hyatt  <hyatt@apple.com>

        Make sure a stroke style is set for list bullets.

        Reviewed by mitz

        * rendering/RenderListMarker.cpp:
        (WebCore::RenderListMarker::paint):

2006-12-18  Ada Chan  <adachan@apple.com>

        Reviewed by Adam.

        Moved implementation of Frame::scheduleClose to Frame.cpp.
        Added canRunBeforeUnloadConfirmPanel, runBeforeUnloadConfirmPanel, and closeWindowSoon
        in Chrome and ChromeClient.

        * WebCore.exp:
        * bridge/win/FrameWin.h:
        * page/Chrome.cpp:
        (WebCore::Chrome::canRunBeforeUnloadConfirmPanel):
        (WebCore::Chrome::runBeforeUnloadConfirmPanel):
        (WebCore::Chrome::closeWindowSoon):
        * page/Chrome.h:
        * page/ChromeClient.h:
        * page/Frame.cpp:
        (WebCore::Frame::shouldClose):
        (WebCore::Frame::scheduleClose):
        * page/Frame.h:
        * page/mac/FrameMac.h:
        * page/mac/FrameMac.mm:
        * page/mac/WebCoreFrameBridge.h:
        * platform/gdk/FrameGdk.h:
        * platform/gdk/TemporaryLinkStubs.cpp:
        (FrameGdk::issuePasteCommand):
        * platform/qt/FrameQt.cpp:
        * platform/qt/FrameQt.h:
        * platform/win/TemporaryLinkStubs.cpp:
        (WebCore::FrameWin::issuePasteCommand):

2006-12-18  Alice Liu  <alice.liu@apple.com>

        Reviewed by Adam.

        Fixed <rdar://problem/4766174> REGRESSION(r16081): Aspect eWFM: Unable to log in

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::didExplicitOpen):

2006-12-18  David Hyatt  <hyatt@apple.com>

        Add save/restore calls around the painting of text areas on Mac, since the methods in question
        alter the current fill color in CG destructively.

        Reviewed by olliej

        * rendering/RenderThemeMac.mm:
        (WebCore::RenderThemeMac::paintButton):
        (WebCore::RenderThemeMac::paintTextField):
        (WebCore::RenderThemeMac::paintTextArea):
        (WebCore::RenderThemeMac::paintSliderTrack):
        (WebCore::RenderThemeMac::paintSliderThumb):

2006-12-18  David Hyatt  <hyatt@apple.com>

        Fix list markers to properly stroke and fill.  I screwed this up when changing how text draws.

        Reviewed by olliej

        * rendering/RenderListMarker.cpp:
        (WebCore::RenderListMarker::paint):

2006-12-18  David Hyatt  <hyatt@apple.com>

        Eliminate the Pen object in favor of separate stroke variables, since most code just wants to set the
        stroke color.  This also makes it easier for us to push only stroke color through into CG synchronously
        while leaving the others alone.

        Reviewed by olliej

        * platform/graphics/GraphicsContext.cpp:
        (WebCore::GraphicsContextState::GraphicsContextState):
        (WebCore::GraphicsContext::setStrokeThickness):
        (WebCore::GraphicsContext::setStrokeStyle):
        (WebCore::GraphicsContext::setStrokeColor):
        (WebCore::GraphicsContext::strokeThickness):
        (WebCore::GraphicsContext::strokeStyle):
        (WebCore::GraphicsContext::strokeColor):
        (WebCore::GraphicsContext::setPlatformStrokeStyle):
        (WebCore::GraphicsContext::setPlatformStrokeThickness):
        * platform/graphics/GraphicsContext.h:
        (WebCore::):
        * platform/graphics/cg/GraphicsContextCG.cpp:
        (WebCore::GraphicsContext::drawRect):
        (WebCore::GraphicsContext::drawLine):
        (WebCore::GraphicsContext::drawEllipse):
        (WebCore::GraphicsContext::drawArc):
        (WebCore::GraphicsContext::drawConvexPolygon):
        (WebCore::GraphicsContext::drawLineForText):
        (WebCore::GraphicsContext::setPlatformStrokeColor):
        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::toQPenStyle):
        (WebCore::GraphicsContext::setPlatformStrokeColor):
        (WebCore::GraphicsContext::setPlatformStrokeStyle):
        (WebCore::GraphicsContext::setPlatformStrokeThickness):
        * platform/mac/FontMac.mm:
        (WebCore::Font::drawComplexText):
        (WebCore::Font::drawGlyphs):
        * rendering/InlineFlowBox.cpp:
        (WebCore::InlineFlowBox::paintDecorations):
        * rendering/InlineTextBox.cpp:
        (WebCore::updateTextColor):
        (WebCore::InlineTextBox::paint):
        (WebCore::InlineTextBox::paintDecoration):
        (WebCore::InlineTextBox::paintMarkedTextUnderline):
        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::paintObject):
        * rendering/RenderBox.cpp:
        * rendering/RenderBox.h:
        * rendering/RenderFrameSet.cpp:
        (WebCore::RenderFrameSet::userResize):
        * rendering/RenderImage.cpp:
        (WebCore::RenderImage::paint):
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::drawBorderArc):
        (WebCore::RenderObject::drawBorder):
        * rendering/RenderTable.cpp:
        (WebCore::RenderTable::paint):
        * rendering/RenderTableCell.cpp:
        (WebCore::RenderTableCell::paint):
        * rendering/RenderText.cpp:
        * rendering/RenderThemeMac.mm:
        (WebCore::RenderThemeMac::paintMenuListButton):

2006-12-18  Darin Adler  <darin@apple.com>

        Reviewed by Adele.

        - fix <rdar://problem/4889565> REGRESSION (r17597): Command-clicking a submit
          button does not submit in a new tab/window
          http://bugs.webkit.org/show_bug.cgi?id=11858

        - change DOMActivate events to be created as a part of default handling of
          click events instead of having the sender of the click event also send
          a DOMActivate event

        - fixed some edge cases in the slider thumb element handler; since this is
          inside a shadow DOM, it's likely none of these can arise in practice

        No easy way to test the command-click part since the behavior is in Safari.
        To make a test we'd have to provide JavaScript access to the modifiers passed
        to the policy delegate or have some way to query the underlying event from
        JavaScript.

        * dom/EventTargetNode.cpp: Change all assert to ASSERT.
        (WebCore::EventTargetNode::dispatchMouseEvent): Renamed some local variables
        for clarity. Added a RefPtr for relatedTarget since it might be deallocated
        by the handlers for the click event and is used in the code that creates the
        dblclick event. Removed the code to create a DOMActivate event, since that's
        now done in the default event handler for the click event.
        (WebCore::EventTargetNode::defaultEventHandler): Added code to check for a
        click event and dispatch a DOMActivate event using the click event as the
        underlying event. The part of this that fixes the bug is that we use the
        click event as the underlying event; the old code used the same underlying
        event as for the click event, not the click event itself. The underlying event
        for the click event is usually 0, since we propagate the key state to the click
        event instead of using an underlying event in the common case.

        * dom/Document.cpp: (WebCore::Document::defaultEventHandler): Added call
        to the base class's defaultEventHandler function, except in the case where
        the event is already handled.

        * html/HTMLInputElement.h: Removed clickX() and clickY().
        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::appendFormData): Use xPos and yPos directly,
        so we can remove clickX() and clickY().
        (WebCore::HTMLInputElement::defaultEventHandler): Removed code that calls
        setDefaultHandled for click events since we are just recording the x and y
        coordinates of the events; that's not "handling" an event, and setting
        the flag prevents us from calling the base class's default event handler,
        which is now needed to submmit the form.

        * rendering/RenderSlider.cpp:
        (WebCore::HTMLSliderThumbElement::defaultEventHandler):
        Added some missing isMouseEvent checks in code that casts to a MouseEvent.
        Added check document()->frame() in code that manipulates the frame so that
        fake events, which might happen when there's no frame, can't cause a crash.
        Added an m_inDragMode check so we don't try to handle mouseup events when
        we are not handling a drag. Remove the setDefaultHandled call from the
        mousemove case, because mousemove events are observed, and not "handled"
        in the "nobody else should look at this event" sense. Added a call to the
        base class's default event handler, and some return statements so that we
        won't call it when the event has been handled.

        * html/HTMLLabelElement.cpp: (WebCore::HTMLLabelElement::defaultEventHandler):
        Removed an unneeded "return" for a function that has no return value.

2006-12-18  Beth Dakin  <bdakin@apple.com>

        Reviewed by Adele.

        Fix for <rdar://problem/4749770> WebCore crashes on a blog website 
        in WebCore::InlineBox::root() + 6

        We null-check inlineBoxWrapper everywhere else in the code except 
        for these 3 spots. This patch adds them in. Only one of the checks 
        is required to fix the crash. What we render for the test case now 
        matches shipping Safari, but still seems wrong because we do not 
        match Firefox. I will file a follow-up about the rendering problem.

        * rendering/RenderListItem.cpp:
        (WebCore::RenderListItem::positionListMarker): This is the required 
        null-check. 
        * rendering/RenderListMarker.cpp:
        (WebCore::RenderListMarker::setSelectionState): Null-check for 
        safety. 
        (WebCore::RenderListMarker::selectionRect): Same.

2006-12-18  David Hyatt  <hyatt@apple.com>

        Fix performance regression caused by adding setting of stroke colors as well as fill colors to every font drawing
        call on Mac.  Fix is rather involved:

        (1) Fill color is now updated in CG synchronously.  There is no more delay in the push.  I used the model that
        Qt added for this, setPlatformFillColor, so we're the same now.

        (2) Text was being drawn using the pen color, which is tantamount to using the stroke color.  Since text in HTML
        is really a fill and not a stroke, all cross-platform code that draws text has been patched to use fill instead
        of the pen.

        (3) Added a new API to GraphicsContext to set the text drawing mode to any combination of fill/stroke/clip.
        Ports should implement setPlatformTextDrawingMode or just query the mode in their drawGlyphs/drawComplexText
        method on their Font class to get the new functionality.

        (4) InlineTextBox will set the fill and stroke colors appropriately now rather than always assuming fill.

        (5) Fixed a bug in GraphicsContextCG where fillRectWithColor was updating the CG fill color in the state object
        as a side effect, creating a mismatch between CG's fill color and the stored cross-platform fill color.

        Reviewed by olliej

        * platform/graphics/GraphicsContext.cpp:
        (WebCore::GraphicsContextState::GraphicsContextState):
        (WebCore::GraphicsContext::textDrawingMode):
        (WebCore::GraphicsContext::setTextDrawingMode):
        (WebCore::GraphicsContext::setPlatformTextDrawingMode):
        (WebCore::GraphicsContext::setPlatformPen):
        * platform/graphics/GraphicsContext.h:
        * platform/graphics/cg/GraphicsContextCG.cpp:
        (WebCore::GraphicsContext::fillRect):
        (WebCore::GraphicsContext::setPlatformTextDrawingMode):
        (WebCore::GraphicsContext::setPlatformFillColor):
        * platform/graphics/svg/cg/SVGPaintServerGradientCg.cpp:
        (WebCore::SVGPaintServerGradient::teardown):
        (WebCore::SVGPaintServerGradient::setup):
        * platform/graphics/svg/cg/SVGPaintServerPatternCg.cpp:
        (WebCore::SVGPaintServerPattern::setup):
        (WebCore::SVGPaintServerPattern::teardown):
        * platform/graphics/svg/cg/SVGPaintServerSolidCg.cpp:
        (WebCore::SVGPaintServerSolid::setup):
        * platform/mac/FontMac.mm:
        (WebCore::Font::drawComplexText):
        (WebCore::Font::drawGlyphs):
        * platform/mac/WebCoreTextRenderer.mm:
        (WebCoreDrawTextAtPoint):
        * rendering/EllipsisBox.cpp:
        (WebCore::EllipsisBox::paint):
        * rendering/InlineTextBox.cpp:
        (WebCore::correctedTextColor):
        (WebCore::updateTextColor):
        (WebCore::InlineTextBox::paint):
        (WebCore::InlineTextBox::paintSelection):
        (WebCore::InlineTextBox::paintMarkedTextBackground):
        (WebCore::InlineTextBox::paintTextMatchMarker):
        * rendering/RenderFileUploadControl.cpp:
        (WebCore::RenderFileUploadControl::paintObject):
        * rendering/RenderListBox.cpp:
        (WebCore::RenderListBox::paintItemForeground):
        * rendering/RenderListMarker.cpp:
        (WebCore::RenderListMarker::paint):

2006-12-18  Dex Deacon  <occupant4@gmail.com>

        Reviewed by Maciej.

        Bug 11760: Animated GIFs with offsets crash WebKit
        http://bugs.webkit.org/show_bug.cgi?id=11760

        * platform/image-decoders/gif/GIFImageDecoder.cpp:
        ensure we don't write past the end of the image buffer when the offset
        is nonzero.  also fix the way we composite frames when animating.
        (WebCore::GIFImageDecoder::initFrameBuffer):
        (WebCore::GIFImageDecoder::haveDecodedRow):

2006-12-18  Kirby White  <KWhiteRight@gmail.com>

        Reviewed by Darin.

        Changed hidden input controls to reset to their initial values
        when the form is reset.  Also added layout tests for resetting
        other input controls.

        Fixes http://bugs.webkit.org/show_bug.cgi?id=11866

        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::setValue):
        (WebCore::HTMLInputElement::storesValueSeparateFromAttribute):

2006-12-18  Alice Liu  <alice.liu@apple.com>

        Oops forgot a file. 

        * editing/EditorDeleteAction.h: Added.
        (WebCore::):

2006-12-18  Alice Liu  <alice.liu@apple.com>

        Reviewed by Adam.

        Have the Editor handle deletion instead of WebHTMLView

        * WebCore.exp:
        Exposed Editor::deleteWithDirection and ::deleteRange()

        * WebCore.xcodeproj/project.pbxproj:
        Added EditorDeleteAction.h

        * editing/Editor.cpp:
        (WebCore::Editor::deleteRange):
        (WebCore::Editor::deleteWithDirection):
        Implemented

        (WebCore::Editor::deleteSelectionWithSmartDelete):
        Overloaded to take no params, in which case canSmartCopyOrDelete is called

        (WebCore::execCopy):
        (WebCore::execCut):
        (WebCore::execDelete):
        (WebCore::execPaste):
        Call the editor instead of asking frame to cut/copy/paste/delete

        (WebCore::execBackwardDelete):
        (WebCore::execForwardDelete):
        Call deleteWithDirection instead of just executing a TypingCommand

        (WebCore::CommandEntry::):
        distinguished delete (which deletes selection) from backwards delete (single character, no selection)

        (WebCore::Editor::cut):
        (WebCore::Editor::performDelete):
        Trivial changes

        * editing/Editor.h:
        Added some functons.
        (WebCore::Editor::setStartNewKillRingSequence):
        (WebCore::Editor::propogateDOMException):
        (WebCore::Editor::addToKillRing):
        * editing/mac/EditorMac.mm:
        Factored out support for Kill Rings to this file

        * platform/mac/PasteboardMac.mm:
        Trivial change

2006-12-18  Kevin McCullough  <KMcCullough@apple.com>

        Reviewed by Oliver.

        - Removed CG header include

        * platform/graphics/ImageSource.h:

2006-12-18  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim Hatcher

        - fixed <rdar://problem/4887764> GMAIL: Crash occurs at WebCore::Range::cloneRange() 
          when I ctrl-click in a empty list item

        * editing/mac/EditorMac.mm:
        (WebCore::isRangeUngrammatical):
        bail out immediately for nil range (which selectionController()->toRange().get()
        can return). Also save some work by bailing out immediately for collapsed ranges.

2006-12-18  Alice Liu  <alice.liu@apple.com>

        Leopard build fix.

        * platform/ContextMenu.cpp:
        (WebCore::ContextMenu::checkOrEnableIfNeeded):

2006-12-17  Zack Rusin  <zack@kde.org>

        Fix compilation after the const changes.

        * platform/qt/ContextMenuItemQt.cpp:
        (WebCore::ContextMenuItem::type):
        (WebCore::ContextMenuItem::setTitle):
        (WebCore::ContextMenuItem::setChecked):
        (WebCore::ContextMenuItem::setEnabled):

2006-12-17  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Eric.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=10956

        Long standing regression. The old code in FontMac.mm, used set the fill/stroke
        color "[nsColor(graphicsContext->pen().color()) set];", and current code only
        sets the fill color. Reverting to old behaviour fixes gradient-on-stroke-of-text.

        * platform/graphics/svg/cg/SVGPaintServerGradientCg.cpp:
        (WebCore::SVGPaintServerGradient::setup):
        * platform/mac/FontMac.mm:
        (WebCore::Font::drawComplexText):
        (WebCore::Font::drawGlyphs):

2006-12-17  Lars Naesbye Christensen  <lars@naesbye.dk>

        Reviewed, tweaked and landed by Alexey.

        http://bugs.webkit.org/show_bug.cgi?id=11798
        [CSS 3] missing cursor support for 'none'

        * Resources/noneCursor.png: Added.
        * WebCore.xcodeproj/project.pbxproj:
        * css/CSSComputedStyleDeclaration.cpp:
        (WebCore::CSSComputedStyleDeclaration::getPropertyCSSValue):
        * css/CSSValueKeywords.in:
        * css/cssparser.cpp: Also fixed previously broken -webkit-background-composite: copy.
        * manual-tests/cursor.html:
        * page/EventHandler.cpp:
        (WebCore::selectCursor):
        * platform/Cursor.h:
        * platform/gdk/CursorGdk.cpp:
        (WebCore::noneCursor):
        * platform/mac/CursorMac.mm:
        (WebCore::noneCursor):
        * platform/qt/CursorQt.cpp:
        (WebCore::noneCursor):
        * platform/win/CursorWin.cpp:
        (WebCore::noneCursor):
        * rendering/RenderStyle.h:
        (WebCore::):

2006-12-17  Nikolas Zimmermann  <zimmermann@kde.org>

        Build fix, not reviewed.

        This should hopefully fix Qt build.

        * ksvg2/svg/SVGLength.cpp: Include math.h for Qt/Linux build.

2006-12-17  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Rob.

        Remove SVGHelper class. Move the last static function "parseSeparatedList"
        to the only place using it: SVGAnimationElement. Update all build files.

        Remove any lazy_create macro usage, by what it does - cleaner.

        * CMakeLists.txt:
        * WebCore.pro:
        * WebCore.xcodeproj/project.pbxproj:
        * ksvg2/misc/KCanvasRenderingStyle.cpp:
        * ksvg2/svg/SVGAElement.cpp:
        * ksvg2/svg/SVGAnimationElement.cpp:
        (WebCore::parseSeparatedList):
        (WebCore::SVGAnimationElement::parseMappedAttribute):
        * ksvg2/svg/SVGCircleElement.cpp:
        * ksvg2/svg/SVGClipPathElement.cpp:
        * ksvg2/svg/SVGComponentTransferFunctionElement.cpp:
        * ksvg2/svg/SVGCursorElement.cpp:
        * ksvg2/svg/SVGEllipseElement.cpp:
        * ksvg2/svg/SVGExternalResourcesRequired.cpp:
        * ksvg2/svg/SVGFEBlendElement.cpp:
        * ksvg2/svg/SVGFEColorMatrixElement.cpp:
        * ksvg2/svg/SVGFEComponentTransferElement.cpp:
        * ksvg2/svg/SVGFECompositeElement.cpp:
        * ksvg2/svg/SVGFEDiffuseLightingElement.cpp:
        * ksvg2/svg/SVGFEDisplacementMapElement.cpp:
        * ksvg2/svg/SVGFEFloodElement.cpp:
        * ksvg2/svg/SVGFEGaussianBlurElement.cpp:
        * ksvg2/svg/SVGFEImageElement.cpp:
        * ksvg2/svg/SVGFELightElement.cpp:
        * ksvg2/svg/SVGFEMergeElement.cpp:
        * ksvg2/svg/SVGFEMergeNodeElement.cpp:
        * ksvg2/svg/SVGFEOffsetElement.cpp:
        * ksvg2/svg/SVGFESpecularLightingElement.cpp:
        * ksvg2/svg/SVGFETileElement.cpp:
        * ksvg2/svg/SVGFilterElement.cpp:
        * ksvg2/svg/SVGForeignObjectElement.cpp:
        * ksvg2/svg/SVGGradientElement.cpp:
        * ksvg2/svg/SVGHelper.cpp: Removed.
        * ksvg2/svg/SVGHelper.h: Removed.
        * ksvg2/svg/SVGImageElement.cpp:
        * ksvg2/svg/SVGLength.cpp:
        * ksvg2/svg/SVGLineElement.cpp:
        * ksvg2/svg/SVGLinearGradientElement.cpp:
        * ksvg2/svg/SVGMarkerElement.cpp:
        * ksvg2/svg/SVGMaskElement.cpp:
        * ksvg2/svg/SVGPathElement.cpp:
        * ksvg2/svg/SVGPatternElement.cpp:
        * ksvg2/svg/SVGPolyElement.cpp:
        * ksvg2/svg/SVGRadialGradientElement.cpp:
        * ksvg2/svg/SVGRectElement.cpp:
        * ksvg2/svg/SVGStopElement.cpp:
        * ksvg2/svg/SVGStyledElement.cpp:
        * ksvg2/svg/SVGStyledTransformableElement.cpp:
        * ksvg2/svg/SVGSymbolElement.cpp:
        * ksvg2/svg/SVGTests.cpp:
        * ksvg2/svg/SVGTextContentElement.cpp:
        * ksvg2/svg/SVGTextElement.cpp:
        * ksvg2/svg/SVGTextPositioningElement.cpp:
        * ksvg2/svg/SVGTransformable.cpp:
        * ksvg2/svg/SVGURIReference.cpp:
        * ksvg2/svg/SVGUseElement.cpp:
        * ksvg2/svg/SVGViewElement.cpp:
        * ksvg2/svg/SVGZoomAndPan.cpp:

2006-12-17  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Rob.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=11813

        Pass SVGLength around by value, remove any SVGLength* usage.
        Bindings work fine, as the SVG POD JS Wrapper stuff is already in svn.

        No new regressions, none fixed. But the code itself is much cleaner.
        And some problems with width-full-percentage.svg have been fixed, viewport
        clipping works in any case now, also for percentual width/height values set on <svg>.

        * bindings/scripts/CodeGenerator.pm:
        * bindings/scripts/CodeGeneratorJS.pm:
        * ksvg2/misc/KCanvasRenderingStyle.cpp:
        (WebCore::KSVGPainterFactory::cssPrimitiveToLength):
        * ksvg2/svg/SVGAnimatedTemplate.h:
        * ksvg2/svg/SVGCircleElement.cpp:
        (WebCore::SVGCircleElement::SVGCircleElement):
        (WebCore::SVGCircleElement::parseMappedAttribute):
        (WebCore::SVGCircleElement::toPathData):
        * ksvg2/svg/SVGCircleElement.h:
        * ksvg2/svg/SVGCursorElement.cpp:
        (WebCore::SVGCursorElement::SVGCursorElement):
        (WebCore::SVGCursorElement::parseMappedAttribute):
        * ksvg2/svg/SVGCursorElement.h:
        * ksvg2/svg/SVGElement.cpp:
        * ksvg2/svg/SVGEllipseElement.cpp:
        (WebCore::SVGEllipseElement::SVGEllipseElement):
        (WebCore::SVGEllipseElement::parseMappedAttribute):
        (WebCore::SVGEllipseElement::toPathData):
        * ksvg2/svg/SVGEllipseElement.h:
        * ksvg2/svg/SVGFilterElement.cpp:
        (WebCore::SVGFilterElement::SVGFilterElement):
        (WebCore::SVGFilterElement::parseMappedAttribute):
        (WebCore::SVGFilterElement::canvasResource):
        * ksvg2/svg/SVGFilterElement.h:
        * ksvg2/svg/SVGFilterPrimitiveStandardAttributes.cpp:
        (WebCore::SVGFilterPrimitiveStandardAttributes::SVGFilterPrimitiveStandardAttributes):
        (WebCore::SVGFilterPrimitiveStandardAttributes::parseMappedAttribute):
        (WebCore::SVGFilterPrimitiveStandardAttributes::setStandardAttributes):
        * ksvg2/svg/SVGFilterPrimitiveStandardAttributes.h:
        * ksvg2/svg/SVGFitToViewBox.cpp:
        (WebCore::SVGFitToViewBox::parseViewBox):
        * ksvg2/svg/SVGForeignObjectElement.cpp:
        (WebCore::SVGForeignObjectElement::SVGForeignObjectElement):
        (WebCore::SVGForeignObjectElement::parseMappedAttribute):
        (WebCore::SVGForeignObjectElement::createRenderer):
        (WebCore::SVGForeignObjectElement::childShouldCreateRenderer):
        * ksvg2/svg/SVGForeignObjectElement.h:
        * ksvg2/svg/SVGHelper.cpp:
        (WebCore::SVGHelper::parseSeparatedList):
        * ksvg2/svg/SVGHelper.h:
        * ksvg2/svg/SVGImageElement.cpp:
        (WebCore::SVGImageElement::SVGImageElement):
        (WebCore::SVGImageElement::parseMappedAttribute):
        * ksvg2/svg/SVGImageElement.h:
        * ksvg2/svg/SVGLength.cpp:
        (WebCore::storeUnit):
        (WebCore::extractMode):
        (WebCore::extractType):
        (WebCore::lengthTypeToString):
        (WebCore::stringToLengthType):
        (WebCore::SVGLength::SVGLength):
        (WebCore::SVGLength::unitType):
        (WebCore::SVGLength::value):
        (WebCore::SVGLength::setValue):
        (WebCore::SVGLength::setValueInSpecifiedUnits):
        (WebCore::SVGLength::setValueAsString):
        (WebCore::SVGLength::valueAsString):
        (WebCore::SVGLength::newValueSpecifiedUnits):
        (WebCore::SVGLength::convertToSpecifiedUnits):
        (WebCore::SVGLength::isFraction):
        (WebCore::SVGLength::dpi):
        (WebCore::SVGLength::PercentageOfViewport):
        * ksvg2/svg/SVGLength.h:
        (WebCore::):
        (WebCore::SVGLength::):
        * ksvg2/svg/SVGLength.idl:
        * ksvg2/svg/SVGLengthList.cpp:
        (WebCore::SVGLengthList::SVGLengthList):
        (WebCore::SVGLengthList::parse):
        * ksvg2/svg/SVGLengthList.h:
        * ksvg2/svg/SVGLineElement.cpp:
        (WebCore::SVGLineElement::SVGLineElement):
        (WebCore::SVGLineElement::parseMappedAttribute):
        (WebCore::SVGLineElement::toPathData):
        * ksvg2/svg/SVGLineElement.h:
        * ksvg2/svg/SVGLinearGradientElement.cpp:
        (WebCore::SVGLinearGradientElement::SVGLinearGradientElement):
        (WebCore::SVGLinearGradientElement::parseMappedAttribute):
        (WebCore::SVGLinearGradientElement::buildGradient):
        * ksvg2/svg/SVGLinearGradientElement.h:
        * ksvg2/svg/SVGMarkerElement.cpp:
        (WebCore::SVGMarkerElement::SVGMarkerElement):
        (WebCore::SVGMarkerElement::parseMappedAttribute):
        (WebCore::SVGMarkerElement::canvasResource):
        * ksvg2/svg/SVGMarkerElement.h:
        * ksvg2/svg/SVGMaskElement.cpp:
        (WebCore::SVGMaskElement::SVGMaskElement):
        (WebCore::SVGMaskElement::attributeChanged):
        (WebCore::SVGMaskElement::parseMappedAttribute):
        (WebCore::SVGMaskElement::drawMaskerContent):
        * ksvg2/svg/SVGMaskElement.h:
        * ksvg2/svg/SVGPatternElement.cpp:
        (WebCore::SVGPatternElement::SVGPatternElement):
        (WebCore::SVGPatternElement::parseMappedAttribute):
        (WebCore::SVGPatternElement::drawPatternContentIntoTile):
        (WebCore::SVGPatternElement::notifyAttributeChange):
        (WebCore::SVGPatternElement::getCTM):
        * ksvg2/svg/SVGPatternElement.h:
        * ksvg2/svg/SVGRadialGradientElement.cpp:
        (WebCore::SVGRadialGradientElement::SVGRadialGradientElement):
        (WebCore::SVGRadialGradientElement::parseMappedAttribute):
        (WebCore::SVGRadialGradientElement::buildGradient):
        * ksvg2/svg/SVGRadialGradientElement.h:
        * ksvg2/svg/SVGRectElement.cpp:
        (WebCore::SVGRectElement::SVGRectElement):
        (WebCore::SVGRectElement::parseMappedAttribute):
        (WebCore::SVGRectElement::toPathData):
        * ksvg2/svg/SVGRectElement.h:
        * ksvg2/svg/SVGSVGElement.cpp:
        (WebCore::SVGSVGElement::SVGSVGElement):
        (WebCore::SVGSVGElement::viewport):
        (WebCore::SVGSVGElement::parseMappedAttribute):
        (WebCore::SVGSVGElement::createSVGLength):
        (WebCore::SVGSVGElement::getCTM):
        (WebCore::SVGSVGElement::getScreenCTM):
        * ksvg2/svg/SVGSVGElement.h:
        * ksvg2/svg/SVGStyledElement.cpp:
        * ksvg2/svg/SVGStyledElement.h:
        * ksvg2/svg/SVGTextContentElement.cpp:
        (WebCore::SVGTextContentElement::SVGTextContentElement):
        (WebCore::SVGTextContentElement::parseMappedAttribute):
        * ksvg2/svg/SVGTextContentElement.h:
        * ksvg2/svg/SVGTextElement.cpp:
        * ksvg2/svg/SVGTextPositioningElement.cpp:
        (WebCore::SVGTextPositioningElement::parseMappedAttribute):
        * ksvg2/svg/SVGUseElement.cpp:
        (WebCore::SVGUseElement::SVGUseElement):
        (WebCore::SVGUseElement::parseMappedAttribute):
        (WebCore::SVGUseElement::closeRenderer):
        * ksvg2/svg/SVGUseElement.h:
        * page/EventHandler.cpp:
        (WebCore::selectCursor):
        * rendering/RenderForeignObject.cpp:
        (WebCore::RenderForeignObject::translationForAttributes):
        * rendering/RenderPath.cpp:
        * rendering/RenderPath.h:
        * rendering/RenderSVGContainer.cpp:
        (WebCore::RenderSVGContainer::layout):
        (WebCore::RenderSVGContainer::calcViewport):
        * rendering/RenderSVGImage.cpp:
        (WebCore::RenderSVGImage::relativeBBox):
        (WebCore::RenderSVGImage::getAbsoluteRepaintRect):
        (WebCore::RenderSVGImage::translationForAttributes):
        * rendering/RenderSVGText.cpp:
        (WebCore::RenderSVGText::layout):
        * rendering/SVGInlineFlowBox.cpp:
        (WebCore::translateBox):
        (WebCore::placePositionedBoxesHorizontally):
        (WebCore::placeBoxesVerticallyWithAbsBaseline):

2006-12-16  Sam Weinig  <sam@webkit.org>

        Reviewed by Maciej.

        Patch for http://bugs.webkit.org/show_bug.cgi?id=11856
        Update renderName() methods to return current class names.

        * rendering/RenderPath.h:
        (WebCore::RenderPath::renderName): Returns "RenderPath" instead of "KCanvasItem".
        * rendering/RenderSVGContainer.h:
        (WebCore::RenderSVGContainer::renderName): Returns "RenderSVGContainer" instead of "KCanvasContainer".
        * rendering/RenderTextControl.h:
        (WebCore::RenderTextControl::renderName): Returns "RenderTextControl" instead of "RenderTextField".

2006-12-16  Sam Weinig  <sam@webkit.org>

        Reviewed by Mitz.

        Patch for http://bugs.webkit.org/show_bug.cgi?id=11844
        Code Cleanup for more of the rendering code

        * WebCore.xcodeproj/project.pbxproj:
        * rendering/RenderCounter.cpp:
        (WebCore::RenderCounter::calcMinMaxWidth):
        * rendering/RenderText.cpp:
        (WebCore::RenderText::RenderText):
        (WebCore::RenderText::setStyle):
        (WebCore::RenderText::destroy):
        (WebCore::RenderText::attachTextBox):
        (WebCore::RenderText::findNextInlineTextBox):
        (WebCore::RenderText::positionForCoordinates):
        (WebCore::firstRendererOnNextLine):
        (WebCore::lastRendererOnPrevLine):
        (WebCore::RenderText::caretRect):
        (WebCore::RenderText::posOfChar):
        (WebCore::RenderText::allAscii):
        (WebCore::RenderText::shouldUseMonospaceCache):
        (WebCore::RenderText::cacheWidths):
        (WebCore::RenderText::widthFromCache):
        (WebCore::RenderText::trimmedMinMaxWidth):
        (WebCore::RenderText::calcMinMaxWidth):
        (WebCore::isSpaceAccordingToStyle):
        (WebCore::RenderText::containsOnlyWhitespace):
        (WebCore::RenderText::minXPos):
        (WebCore::RenderText::setSelectionState):
        (WebCore::RenderText::setTextWithOffset):
        (WebCore::RenderText::setText):
        (WebCore::RenderText::position):
        (WebCore::RenderText::width):
        (WebCore::RenderText::getAbsoluteRepaintRect):
        (WebCore::RenderText::selectionRect):
        (WebCore::RenderText::verticalPositionHint):
        (WebCore::RenderText::font):
        (WebCore::RenderText::caretMinOffset):
        (WebCore::RenderText::caretMaxOffset):
        (WebCore::RenderText::previousOffset):
        (WebCore::RenderText::nextOffset):
        (WebCore::RenderText::inlineBox):
        * rendering/RenderText.h:
        (WebCore::RenderText::isTextFragment):
        (WebCore::RenderText::data):
        (WebCore::RenderText::string):
        (WebCore::RenderText::paint):
        (WebCore::RenderText::layout):
        (WebCore::RenderText::nodeAtPoint):
        (WebCore::RenderText::length):
        (WebCore::RenderText::text):
        (WebCore::RenderText::stringLength):
        * rendering/RenderTextControl.cpp:
        (WebCore::RenderTextControl::setStyle):
        (WebCore::disabledTextColor):
        (WebCore::RenderTextControl::createInnerBlockStyle):
        (WebCore::RenderTextControl::createInnerTextStyle):
        (WebCore::RenderTextControl::createResultsButtonStyle):
        (WebCore::RenderTextControl::createCancelButtonStyle):
        (WebCore::RenderTextControl::showPlaceholderIfNeeded):
        (WebCore::RenderTextControl::hidePlaceholderIfNeeded):
        (WebCore::RenderTextControl::createSubtreeIfNeeded):
        (WebCore::RenderTextControl::updateFromElement):
        (WebCore::RenderTextControl::selectionStart):
        (WebCore::RenderTextControl::setSelectionRange):
        (WebCore::RenderTextControl::visiblePositionForIndex):
        (WebCore::RenderTextControl::subtreeHasChanged):
        (WebCore::RenderTextControl::textWithHardLineBreaks):
        (WebCore::RenderTextControl::calcHeight):
        (WebCore::RenderTextControl::nodeAtPoint):
        (WebCore::RenderTextControl::layout):
        (WebCore::RenderTextControl::calcMinMaxWidth):
        (WebCore::RenderTextControl::addSearchResult):
        (WebCore::RenderTextControl::showPopup):
        (WebCore::RenderTextControl::itemText):
        (WebCore::RenderTextControl::itemIsEnabled):
        (WebCore::RenderTextControl::listSize):
        (WebCore::RenderTextControl::scroll):
        * rendering/RenderTextControl.h:
        (WebCore::RenderTextControl::renderName):
        (WebCore::RenderTextControl::removeLeftoverAnonymousBoxes):
        * rendering/RenderTextFragment.cpp:
        (WebCore::RenderTextFragment::RenderTextFragment):
        (WebCore::RenderTextFragment::originalString):
        * rendering/RenderTextFragment.h:
        (WebCore::RenderTextFragment::isTextFragment):
        * rendering/RenderTheme.cpp:
        (WebCore::RenderTheme::adjustStyle):
        (WebCore::RenderTheme::isControlStyled):
        (WebCore::RenderTheme::stateChanged):
        (WebCore::RenderTheme::adjustCheckboxStyle):
        (WebCore::RenderTheme::adjustRadioStyle):
        * rendering/RenderTheme.h:
        (WebCore::):
        * rendering/RenderThemeMac.h:
        * rendering/RenderThemeMac.mm:
        (WebCore::RenderThemeMac::RenderThemeMac):
        (WebCore::RenderThemeMac::platformActiveSelectionBackgroundColor):
        (WebCore::RenderThemeMac::platformInactiveSelectionBackgroundColor):
        (WebCore::RenderThemeMac::activeListBoxSelectionBackgroundColor):
        (WebCore::RenderThemeMac::systemFont):
        (WebCore::RenderThemeMac::isControlStyled):
        (WebCore::RenderThemeMac::adjustRepaintRect):
        (WebCore::RenderThemeMac::updateCheckedState):
        (WebCore::RenderThemeMac::controlSupportsTints):
        (WebCore::RenderThemeMac::setFontFromControlSize):
        (WebCore::RenderThemeMac::paintCheckbox):
        (WebCore::RenderThemeMac::checkboxMargins):
        (WebCore::RenderThemeMac::setCheckboxCellState):
        (WebCore::RenderThemeMac::setCheckboxSize):
        (WebCore::RenderThemeMac::paintRadio):
        (WebCore::RenderThemeMac::radioMargins):
        (WebCore::RenderThemeMac::setRadioCellState):
        (WebCore::RenderThemeMac::setRadioSize):
        (WebCore::RenderThemeMac::adjustButtonStyle):
        (WebCore::RenderThemeMac::buttonMargins):
        (WebCore::RenderThemeMac::setButtonSize):
        (WebCore::RenderThemeMac::setButtonCellState):
        (WebCore::RenderThemeMac::adjustTextFieldStyle):
        (WebCore::RenderThemeMac::adjustTextAreaStyle):
        (WebCore::RenderThemeMac::popupButtonMargins):
        (WebCore::RenderThemeMac::popupButtonPadding):
        (WebCore::TopGradientInterpolate):
        (WebCore::BottomGradientInterpolate):
        (WebCore::MainGradientInterpolate):
        (WebCore::TrackGradientInterpolate):
        (WebCore::RenderThemeMac::paintMenuListButtonGradients):
        (WebCore::RenderThemeMac::paintMenuListButton):
        (WebCore::RenderThemeMac::adjustMenuListStyle):
        (WebCore::RenderThemeMac::adjustMenuListButtonStyle):
        (WebCore::RenderThemeMac::paintSliderTrack):
        (WebCore::RenderThemeMac::paintSliderThumb):
        (WebCore::RenderThemeMac::paintSearchField):
        (WebCore::RenderThemeMac::setSearchCellState):
        (WebCore::RenderThemeMac::adjustSearchFieldStyle):
        (WebCore::RenderThemeMac::paintSearchFieldCancelButton):
        (WebCore::RenderThemeMac::paintSearchFieldResultsDecoration):
        * rendering/RenderTreeAsText.cpp:
        (WebCore::operator<<):
        (WebCore::writeIndent):
        (WebCore::printBorderStyle):
        (WebCore::getTagName):
        (WebCore::isEmptyOrUnstyledAppleStyleSpan):
        (WebCore::writeTextRun):
        (WebCore::write):
        (WebCore::writeLayers):
        (WebCore::nodePosition):
        (WebCore::writeSelection):
        * rendering/RenderTreeAsText.h:
        * rendering/RenderView.cpp:
        (WebCore::RenderView::RenderView):
        (WebCore::RenderView::calcMinMaxWidth):
        (WebCore::RenderView::layout):
        (WebCore::RenderView::absolutePosition):
        (WebCore::RenderView::paint):
        (WebCore::RenderView::repaintViewRectangle):
        (WebCore::rendererAfterPosition):
        (WebCore::RenderView::selectionRect):
        (WebCore::RenderView::setSelection):
        (WebCore::RenderView::selectionStartEnd):
        (WebCore::RenderView::updateWidgetPositions):
        (WebCore::RenderView::addWidget):
        (WebCore::RenderView::removeWidget):
        (WebCore::RenderView::viewRect):
        (WebCore::RenderView::docHeight):
        (WebCore::RenderView::docWidth):
        (WebCore::RenderView::setBestTruncatedAt):
        * rendering/RenderView.h:
        (WebCore::RenderView::renderName):
        (WebCore::RenderView::selectionStart):
        (WebCore::RenderView::selectionEnd):
        * rendering/RenderWidget.cpp:
        (WebCore::RenderWidget::destroy):
        (WebCore::RenderWidget::resizeWidget):
        (WebCore::RenderWidget::setStyle):
        (WebCore::RenderWidget::paint):
        (WebCore::RenderWidget::updateWidgetPosition):
        (WebCore::RenderWidget::setSelectionState):
        * rendering/RootInlineBox.cpp:
        (WebCore::RootInlineBox::placeEllipsis):
        (WebCore::RootInlineBox::fillLineSelectionGap):
        (WebCore::RootInlineBox::selectionState):
        (WebCore::RootInlineBox::firstSelectedBox):
        (WebCore::RootInlineBox::lastSelectedBox):
        (WebCore::RootInlineBox::selectionTop):
        (WebCore::RootInlineBox::closestLeafChildForXPos):
        * rendering/RootInlineBox.h:
        (WebCore::RootInlineBox::isRootInlineBox):
        (WebCore::RootInlineBox::setVerticalOverflowPositions):
        (WebCore::RootInlineBox::setHorizontalOverflowPositions):
        (WebCore::RootInlineBox::setVerticalSelectionPositions):
        (WebCore::RootInlineBox::lineBreakObj):
        (WebCore::RootInlineBox::lineBreakPos):
        (WebCore::RootInlineBox::setLineBreakPos):
        (WebCore::RootInlineBox::blockHeight):
        (WebCore::RootInlineBox::setBlockHeight):
        (WebCore::RootInlineBox::endsWithBreak):
        (WebCore::RootInlineBox::setEndsWithBreak):
        * rendering/SVGInlineFlowBox.cpp:
        (WebCore::SVGInlineFlowBox::paint):
        (WebCore::paintSVGInlineFlow):
        (WebCore::translateBox):
        (WebCore::placePositionedBoxesHorizontally):
        (WebCore::placeBoxesVerticallyWithAbsBaseline):
        (WebCore::placeSVGFlowVertically):
        * rendering/SVGInlineFlowBox.h:
        * rendering/SVGRenderTreeAsText.cpp:
        (WebCore::TextStreamSeparator::TextStreamSeparator):
        (WebCore::operator<<):
        (WebCore::hasFractions):
        (WebCore::writeIndent):
        (WebCore::writeStyle):
        (WebCore::getTagName):
        (WebCore::write):
        (WebCore::writeRenderResources):
        * rendering/SVGRenderTreeAsText.h:
        (WebCore::operator<<):
        * rendering/SVGRootInlineBox.cpp:
        (WebCore::SVGRootInlineBox::paint):
        (WebCore::SVGRootInlineBox::placeBoxesHorizontally):
        * rendering/SVGRootInlineBox.h:
        * rendering/TableLayout.h:

2006-12-16  Adam Roben  <aroben@apple.com>

        Build fixes.

        * platform/ContextMenuItem.h: Fixed const declarations.
        * platform/mac/ContextMenuItemMac.mm: Dito.
        (WebCore::ContextMenuItem::type):
        (WebCore::ContextMenuItem::setTitle):
        (WebCore::ContextMenuItem::setChecked):
        (WebCore::ContextMenuItem::setEnabled):

2006-12-16  Adele Peterson  <adele@apple.com>

        Reviewed by Maciej.

        Fix for http://bugs.webkit.org/show_bug.cgi?id=11189
        <rdar://problem/4770249> REGRESSION (NativeListBox): When a list box has focus, pressing command- A (select all) doesn't selected all items in list

        Test: fast/forms/listbox-select-all.html

        * dom/Node.h: We should try to find a more appropriate place to put these methods.
        (WebCore::Node::canSelectAll): Added.
        (WebCore::Node::selectAll): Added.
        * editing/SelectionController.cpp: (WebCore::SelectionController::selectAll): Before selecting editable content, give the focused node
          a chance to select its content.
        * html/HTMLSelectElement.cpp: (WebCore::HTMLSelectElement::selectAll): Selects all items in a multi-select list box.  Single-select
          list boxes will just do nothing, but we still want the select to handle this case when it has focus, rather than selecting other content.
        * html/HTMLSelectElement.h: (WebCore::HTMLSelectElement::canSelectAll): Returns true for list boxes.

2006-12-16  Zack Rusin  <zack@kde.org>

        Add a stub for SearchPopupMenu for Qt code.

        * platform/qt/SearchPopupMenuQt.cpp: Added.
        (WebCore::SearchPopupMenu::SearchPopupMenu):
        (WebCore::SearchPopupMenu::saveRecentSearches):
        (WebCore::SearchPopupMenu::loadRecentSearches):

2006-12-16  Zack Rusin  <zack@kde.org>

        Make it compile after last nights changes.

        * WebCore.pro:
        * loader/qt/DocumentLoaderQt.cpp:
        (WebCore::DocumentLoader::stopLoading):
        (WebCore::DocumentLoader::prepareForLoadStart):
        * platform/qt/ContextMenuItemQt.cpp:
        (WebCore::ContextMenuItem::ContextMenuItem):
        (WebCore::ContextMenuItem::releasePlatformDescription):
        (WebCore::ContextMenuItem::type):
        (WebCore::ContextMenuItem::setType):
        (WebCore::ContextMenuItem::action):
        (WebCore::ContextMenuItem::setAction):
        (WebCore::ContextMenuItem::setTitle):
        (WebCore::ContextMenuItem::platformSubMenu):
        (WebCore::ContextMenuItem::setSubMenu):
        (WebCore::ContextMenuItem::setChecked):
        (WebCore::ContextMenuItem::setEnabled):
        * platform/qt/ContextMenuQt.cpp:
        (WebCore::ContextMenu::appendItem):
        (WebCore::ContextMenu::insertItem):
        * platform/qt/TemporaryLinkStubs.cpp:

2006-12-16  Adele Peterson  <adele@apple.com>

        One more...

        * editing/ReplaceSelectionCommand.cpp:
        (WebCore::ReplacementFragment::ReplacementFragment):

2006-12-16  Adele Peterson  <adele@apple.com>

        Missed one instance of isNonWidgetTextField.

        * editing/DeleteSelectionCommand.cpp:
        (WebCore::DeleteSelectionCommand::doApply):

2006-12-16  Hunter L. Williams <hlwebkit@gmail.com>

        Reviewed by Adele.

        Fix mouse wheel scrolling in <textarea> controls.

        * rendering/RenderTextControl.cpp:
        * rendering/RenderTextControl.h:
        Override |scroll| on RenderTextControl to forward the call to the RenderObject of the 
        inner m_innerText, which has a layer that can be scrolled.

2006-12-16  Adele Peterson  <adele@apple.com>

        RS by Adam.

        Removed RenderLineEdit, TextField, WebCoreTextField classes, and use of isNonWidgetTextField,

        * WebCore.xcodeproj/project.pbxproj:
        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::isKeyboardFocusable):
        (WebCore::HTMLInputElement::isMouseFocusable):
        (WebCore::HTMLInputElement::focus):
        (WebCore::HTMLInputElement::updateFocusAppearance):
        (WebCore::HTMLInputElement::aboutToUnload):
        (WebCore::HTMLInputElement::dispatchFocusEvent):
        (WebCore::HTMLInputElement::dispatchBlurEvent):
        (WebCore::HTMLInputElement::setValue):
        (WebCore::HTMLInputElement::defaultEventHandler):
        * html/HTMLInputElement.h:
        (WebCore::HTMLInputElement::isTextField):
        * html/HTMLTextFieldInnerElement.cpp:
        (WebCore::HTMLTextFieldInnerTextElement::defaultEventHandler):
        * platform/TextField.h: Removed.
        * platform/mac/TextFieldMac.mm: Removed.
        * platform/mac/WebCoreTextField.h: Removed.
        * platform/mac/WebCoreTextField.mm: Removed.
        * rendering/RenderLineEdit.cpp: Removed.
        * rendering/RenderLineEdit.h: Removed.

2006-12-16  Adele Peterson  <adele@apple.com>

        Two more files I forgot to svn add for search fields.

        * platform/SearchPopupMenu.h: Added.
        (WebCore::SearchPopupMenu::create):
        * platform/mac/SearchPopupMenuMac.mm: Added.
        (WebCore::SearchPopupMenu::SearchPopupMenu):
        (WebCore::autosaveKey):
        (WebCore::SearchPopupMenu::saveRecentSearches):
        (WebCore::SearchPopupMenu::loadRecentSearches):

2006-12-16  Adele Peterson  <adele@apple.com>

        Reviewed by Adam.

        * platform/PopupMenuClient.h: Added. Broken out of PopupMenu class.
        (WebCore::PopupMenuClient::~PopupMenuClient):

2006-12-16  Adele Peterson  <adele@apple.com>

        Reviewed by Adam.

        WebCore part of fix for:
        <rdar://problem/4463829> Switch to use new search field implementation for <input type="search">

        * WebCore.xcodeproj/project.pbxproj: Added SearchPopupMenu.h, SearchPopupMenuMac.mm, and PopupMenuClient.h.

        Added pseudo classes and corresponding values for -webkit appearance for the cancel button and for the three types of "decoration" that 
        correspond to the different functions of the magnifier glass in the search field.  One for the button that will show and hide the
        recent searches menu.  One for decoration when the results attribute is set, but no results are saved.  And one for decoration
        when no results attribute is set.  We added these different pseudo elements so that RenderTextControl can decide which pseudo class
        is appropriate, and each theme can decide for itself which kind of image is appropriate for each function.
        
        * css/CSSSelector.cpp: (WebCore::CSSSelector::extractPseudoType):
        * css/CSSSelector.h: (WebCore::CSSSelector::): Added to PseudoType enum.
        * css/CSSValueKeywords.in: Added searchfield-decoration, searchfield-results-decoration, searchfield-results-button, searchfield-cancel-button values.
        * css/cssstyleselector.cpp: (WebCore::CSSStyleSelector::checkOneSelector): Added cases for -webkit-search-cancel-button, 
          -webkit-search-decoration, -webkit-search-results-decoration, -webkit-search-results-button
        * rendering/RenderStyle.cpp: Addes new pseudoBits for matching pseudoIds.
        (WebCore::):
        (WebCore::pseudoBit):
        * rendering/RenderStyle.h: Added new appearance values and pseudoIds.
        (WebCore::):
        (WebCore::RenderStyle::):
        * css/html4.css: Added style for input[type=search], and the new pseudo elements.

        The structure of the shadow DOM for new search field adds an intermediate block that contains 3 inline-blocks for the magnifier, text element, and cancel button.
        Since the tree has become deeper, some editing and event code that used to check for a shadowParent, really needs to check the shadowAncestorNode.

        * editing/Editor.cpp: (WebCore::Editor::dispatchCPPEvent): Check shadowAncestorNode instead of shadowParentNode.
        * editing/Selection.cpp: (WebCore::Selection::adjustForEditableContent): ditto.
        * editing/htmlediting.cpp:
        (WebCore::firstEditablePositionAfterPositionInRoot): ditto.
        (WebCore::lastEditablePositionBeforePositionInRoot): ditto.
        * editing/ReplaceSelectionCommand.cpp:
        (WebCore::ReplacementFragment::ReplacementFragment): ditto.
        (WebCore::ReplaceSelectionCommand::shouldMerge): Nil check enclosingBlock call.  I ran into this while testing search fields in mixed editability.
        (WebCore::ReplaceSelectionCommand::doApply): ditto.

        * html/HTMLFormElement.cpp: (WebCore::HTMLFormElement::submit): Remove use of RenderLineEdit.
        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::selectionStart): ditto.
        (WebCore::HTMLInputElement::selectionEnd): ditto.
        (WebCore::HTMLInputElement::setSelectionStart): ditto.
        (WebCore::HTMLInputElement::setSelectionEnd): ditto.
        (WebCore::HTMLInputElement::select): ditto.
        (WebCore::HTMLInputElement::setSelectionRange): ditto.
        (WebCore::HTMLInputElement::parseMappedAttribute): ditto.
        (WebCore::HTMLInputElement::createRenderer): ditto.
        (WebCore::HTMLInputElement::defaultEventHandler): ditto.
        (WebCore::HTMLInputElement::addSearchResult): Added. Calls addSearchResult on the renderer.
        * html/HTMLInputElement.h:
        (WebCore::HTMLInputElement::isNonWidgetTextField): Added case for search field.
        (WebCore::HTMLInputElement::isSearchField): Added.

        * platform/PopupMenu.h: Broke PopupMenuClient out into a separate file.
        * platform/PopupMenuClient.h: Added.
        (WebCore::PopupMenuClient::~PopupMenuClient):
        * platform/graphics/Icon.h:

        * platform/SearchPopupMenu.h: Added. Saves and loads recent search vector.
        (WebCore::SearchPopupMenu::create):
        * platform/mac/SearchPopupMenuMac.mm: Added.
        (WebCore::SearchPopupMenu::SearchPopupMenu):
        (WebCore::autosaveKey):
        (WebCore::SearchPopupMenu::saveRecentSearches):
        (WebCore::SearchPopupMenu::loadRecentSearches):

        * html/HTMLTextFieldInnerElement.h: Reorganized this class.
          Added subclasses HTMLTextFieldInnerTextElement, HTMLSearchFieldResultsButtonElement, HTMLSearchFieldCancelButtonElement
        (WebCore::HTMLTextFieldInnerElement::isMouseFocusable): Added.  Returns false so setFocusNodeIfNeeded 
         will try to focus the input element instead of nodes in the shadow tree.
        (WebCore::HTMLTextFieldInnerElement::isShadowNode): Now returns whether or not a shadowParent has been specified.
         * html/HTMLTextFieldInnerElement.cpp:
        (WebCore::HTMLTextFieldInnerTextElement::HTMLTextFieldInnerTextElement):
        (WebCore::HTMLTextFieldInnerTextElement::defaultEventHandler): Moved this from the old HTMLTextFieldInnerElement class.
        (WebCore::HTMLSearchFieldResultsButtonElement::HTMLSearchFieldResultsButtonElement):
        (WebCore::HTMLSearchFieldResultsButtonElement::defaultEventHandler): Shows and hides recent searches menu.
        (WebCore::HTMLSearchFieldCancelButtonElement::HTMLSearchFieldCancelButtonElement):
        (WebCore::HTMLSearchFieldCancelButtonElement::defaultEventHandler): On mouse up, clears the value from the text field.

       * rendering/RenderMenuList.cpp: (WebCore::RenderMenuList::listSize): Changed return type to unsigned.
        * rendering/RenderMenuList.h: (WebCore::RenderMenuList::valueShouldChangeOnHotTrack): Added.
        
        * WebCore.exp: Export _wkDrawTextFieldCellFocusRing.
        * platform/mac/WebCoreSystemInterface.h: Added wkDrawTextFieldCellFocusRing
        * platform/mac/WebCoreSystemInterface.mm: ditto.

        * rendering/RenderTextControl.h:
        (WebCore::RenderTextControl::popupIsVisible): Added so HTMLSearchFieldResultsButtonElement knows whether or not the menu is already up.
        (WebCore::RenderTextControl::shouldPopOver): Added as a PopupClient method so the results menu shows up under the control instead of over.
        (WebCore::RenderTextControl::valueShouldChangeOnHotTrack):
        * rendering/RenderTextControl.cpp:
        (WebCore::RenderTextControl::RenderTextControl): Initialize m_placeholderIsVisible, m_searchPopup, and m_searchPopupIsVisible.
        (WebCore::RenderTextControl::~RenderTextControl): Detach the node at the top of the shadow tree (m_innerBlock for search fields, and m_innerText for other text controls).
        (WebCore::RenderTextControl::setStyle): Sets style on new elements.
        (WebCore::disabledTextColor): Added so this can be used in setPlaceholder.
        (WebCore::RenderTextControl::createInnerBlockStyle): Added.
        (WebCore::RenderTextControl::createInnerTextStyle): Added.
        (WebCore::RenderTextControl::createResultsButtonStyle): Added.
        (WebCore::RenderTextControl::createCancelButtonStyle): Added.
        (WebCore::RenderTextControl::showPlaceholderIfNeeded): Added. Shows the placeholder if there's no value and the field doesn't have focus.
        (WebCore::RenderTextControl::hidePlaceholderIfNeeded): Added. Clears the placeholder if there's a value or the field has focus. 
        (WebCore::RenderTextControl::createSubtreeIfNeeded): Added. Creates all of the shadow tree elements.
        (WebCore::RenderTextControl::updateFromElement): Calls showPlaceholderIfNeeded.
        (WebCore::RenderTextControl::visiblePositionForIndex): Renaming (m_div to m_innerText).
        (WebCore::RenderTextControl::indexForVisiblePosition): ditto.
        (WebCore::RenderTextControl::updateCancelButtonVisibility): Shows and hides cancel button based on the value of the control.
        (WebCore::RenderTextControl::subtreeHasChanged): Fires onSearch if the incremental attribute is set.
        (WebCore::RenderTextControl::text): Renaming.
        (WebCore::RenderTextControl::textWithHardLineBreaks): ditto.
        (WebCore::RenderTextControl::calcHeight): Take the size of the results button and cancel button into account when calculating height.
        (WebCore::RenderTextControl::nodeAtPoint): Act as if we've hit the shadow tree elements based on the x coordinate of the mouse event.
        (WebCore::RenderTextControl::layout): Set the height and width of the text block taking the other shadow tree elements into account.
        (WebCore::RenderTextControl::calcMinMaxWidth): Take new shadow tree elements into account when calculating width.
        (WebCore::RenderTextControl::forwardEvent): Forward events to appropriate shadow nodes.
        (WebCore::RenderTextControl::scrollWidth): Renaming.
        (WebCore::RenderTextControl::scrollHeight): ditto.
        (WebCore::RenderTextControl::scrollLeft): ditto.
        (WebCore::RenderTextControl::scrollTop): ditto.
        (WebCore::RenderTextControl::setScrollLeft): ditto.
        (WebCore::RenderTextControl::setScrollTop): ditto.
        (WebCore::RenderTextControl::autosaveName): ditto.
        (WebCore::RenderTextControl::addSearchResult): Added. Saves value to search result list.
        (WebCore::RenderTextControl::onSearch): Added. Dispatches search event.
        (WebCore::RenderTextControl::showPopup): Added. Loads searches, and displays menu.
        (WebCore::RenderTextControl::hidePopup): Added PopupClient method.
        (WebCore::RenderTextControl::valueChanged): Added PopupClient method. Interprets the selected menu item index, and either sets the value and 
         fires onSearch, or clears all recent searches for this autosave name.
        (WebCore::RenderTextControl::itemText): Added PopupClient method.
        (WebCore::RenderTextControl::itemIsEnabled): Added PopupClient method.
        (WebCore::RenderTextControl::itemStyle): ditto.
        (WebCore::RenderTextControl::clientStyle): ditto.
        (WebCore::RenderTextControl::clientDocument): ditto.
        (WebCore::RenderTextControl::clientPaddingLeft): ditto.
        (WebCore::RenderTextControl::clientPaddingRight): ditto.
        (WebCore::RenderTextControl::listSize): ditto.
        (WebCore::RenderTextControl::selectedIndex): ditto.
        (WebCore::RenderTextControl::itemIsSeparator): ditto.
        (WebCore::RenderTextControl::itemIsLabel): ditto.
        (WebCore::RenderTextControl::itemIsSelected): ditto.
        (WebCore::RenderTextControl::setTextFromItem): ditto.

        * rendering/RenderTheme.cpp: Added search field theme.
        (WebCore::RenderTheme::adjustStyle):
        (WebCore::RenderTheme::paint):
        (WebCore::RenderTheme::paintBorderOnly):
        (WebCore::RenderTheme::paintDecorations):
        (WebCore::RenderTheme::isControlStyled): Returns false for search fields, until we've worked out the kinks.
        (WebCore::RenderTheme::adjustSearchFieldStyle):
        (WebCore::RenderTheme::adjustSearchFieldCancelButtonStyle):
        (WebCore::RenderTheme::adjustSearchFieldDecorationStyle):
        (WebCore::RenderTheme::adjustSearchFieldResultsDecorationStyle):
        (WebCore::RenderTheme::adjustSearchFieldResultsButtonStyle):
        * rendering/RenderTheme.h:
        (WebCore::RenderTheme::paintSearchField):
        (WebCore::RenderTheme::paintSearchFieldCancelButton):
        (WebCore::RenderTheme::paintSearchFieldDecoration):
        (WebCore::RenderTheme::paintSearchFieldResultsDecoration):
        (WebCore::RenderTheme::paintSearchFieldResultsButton):
        * rendering/RenderThemeMac.h:
        * rendering/RenderThemeMac.mm:
        (WebCore::RenderThemeMac::RenderThemeMac):
        (WebCore::RenderThemeMac::sizeForSystemFont): Added.  Compares style's font to systemFontSizeForControlSize to determine
         what controlSize to use after a style's font has already been initially adjusted.
        (WebCore::RenderThemeMac::controlSizeForSystemFont): Added. ditto.
        (WebCore::RenderThemeMac::paintCheckbox):
        (WebCore::RenderThemeMac::paintRadio):
        (WebCore::RenderThemeMac::menuListSizes): 
        (WebCore::RenderThemeMac::minimumMenuListSize): Uses sizeForSystemFont instead of hardcoded adjusted font sizes.
        (WebCore::RenderThemeMac::paintSearchField):
        (WebCore::RenderThemeMac::setSearchCellState):
        (WebCore::RenderThemeMac::adjustSearchFieldStyle):
        (WebCore::RenderThemeMac::paintSearchFieldCancelButton):
        (WebCore::RenderThemeMac::cancelButtonSizes):
        (WebCore::RenderThemeMac::adjustSearchFieldCancelButtonStyle):
        (WebCore::RenderThemeMac::resultsButtonSizes):
        (WebCore::RenderThemeMac::adjustSearchFieldDecorationStyle):
        (WebCore::RenderThemeMac::paintSearchFieldDecoration):
        (WebCore::RenderThemeMac::adjustSearchFieldResultsDecorationStyle):
        (WebCore::RenderThemeMac::paintSearchFieldResultsDecoration):
        (WebCore::RenderThemeMac::adjustSearchFieldResultsButtonStyle):
        (WebCore::RenderThemeMac::paintSearchFieldResultsButton):

2006-12-16  Beth Dakin  <bdakin@apple.com>

        Reviewed by Adam (and partially Geoff).

        Primarily, this patch gives WebCore context menus the ability to
        enable/disable and set state. It does a few other things along the
        way, though. Some of the more noticeable things:
               -Re-architects the ContextMenuItem class a bit so that the
                ownership model is a bit less confusing. ContextMenuItem is
                now *purely* a wrapper for the platformDescription. There
                are no other member variables. If you ever need the
                platformDescription outside of the MenuItem class, you have
                to call releasePlatformDescription(), which transfers
                ownership of the platformDescription to the caller.
               -Moves fontForSelection() from FrameMac into Editor.cpp.
                Turns out I don't need to use this function for my patch
                after all, but it doesn't seem like a terrible idea to move
                it anyway since we seem to be moving things from FrameMac
                into Editor these days anyway.

        * WebCore.exp:
        * editing/Editor.cpp:
        (WebCore::Editor::fontForSelection): Moved in from FrameMac.
        * editing/Editor.h: Same, and name change.
        * editing/mac/EditorMac.mm: Name change.
        * page/ContextMenuClient.h: contextMenuItemSelected() has to take a
        pointer to the parent context menu since ContextMenuItem no longer
        holds on to it.
        * page/ContextMenuController.cpp: Same.
        (WebCore::ContextMenuController::contextMenuItemSelected): Same.
        * page/mac/FrameMac.h: Move fontForSelection to Editor
        * page/mac/FrameMac.mm: Same.
        * page/mac/WebCoreFrameBridge.mm:
        (-[WebCoreFrameBridge fontForSelection:]): Account for above.
        * platform/ContextMenu.cpp:
        (WebCore::separatorItem): Can't be const because appendItem now
        expects a non-const menu item.
        (WebCore::createAndAppendFontSubMenu): Change name for clarity.
        (WebCore::createAndAppendSpellingAndGrammarSubMenu): Same.
        (WebCore::createAndAppendSpellingSubMenu): Same.
        (WebCore::createAndAppendSpeechSubMenu): Same.
        (WebCore::createAndAppendWritingDirectionSubMenu): Same.
        (WebCore::ContextMenu::populate): Account for above.
        (WebCore::triStateToBool): New helper.
        (WebCore::ContextMenu::checkOrEnableIfNeeded): Transfers
        logic from WebHTMLView into WebCore to determine if menu items are
        enabled or disabled and to determine if they require a check.
        * platform/ContextMenu.h:
        * platform/ContextMenuItem.h: Re-factored stuff so that our only
        member variable is the platform description.
        (WebCore::): Get rid of if-def.
        * platform/cf/RetainPtr.h: Add releaseRef like in PassRefPtr.
        (WebCore::RetainPtr::releaseRef):
        * platform/mac/ContextMenuItemMac.mm: Same as .h
        (WebCore::ContextMenuItem::ContextMenuItem): Same.
        (WebCore::ContextMenuItem::releasePlatformDescription): Same.
        (WebCore::ContextMenuItem::type): Same.
        (WebCore::ContextMenuItem::platformSubMenu): Same.
        (WebCore::ContextMenuItem::setType): Same.
        (WebCore::ContextMenuItem::setTitle): Same.
        (WebCore::ContextMenuItem::setSubMenu): Same.
        (WebCore::ContextMenuItem::setChecked): Same.
        (WebCore::ContextMenuItem::setEnabled): Same.
        * platform/mac/ContextMenuMac.mm:
        (-[WebCoreMenuTarget forwardContextMenuAction:]): Don't set the
        parent menu.
        (WebCore::setMenuItemTarget):
        (WebCore::ContextMenu::appendItem): Call releasePlatformDescription
        (WebCore::ContextMenu::insertItem): Same.

2006-12-15  MorganL  <morganl.webkit@yahoo.com>

        Reviewed by Oliver.

        Allow images to load into frames again.  Tidy up code a bit and
        add some much needed documentation.

        * platform/MimeTypeRegistry.cpp:
        (WebCore::initialiseSupportedImageMIMETypes):
        (WebCore::initialiseSupportedNonImageMimeTypes):
        * platform/MimeTypeRegistry.h:

2006-12-15  Anders Carlsson  <acarlsson@apple.com>

        Fix build.

        * loader/DocumentLoader.cpp:
        (WebCore::DocumentLoader::response):
        (WebCore::DocumentLoader::setResponse):
        (WebCore::DocumentLoader::isStopping):
        (WebCore::DocumentLoader::mainDocumentError):
        * loader/DocumentLoader.h:

2006-12-15  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Geoff.

        More loader cleanup.

        * loader/DocumentLoader.h:
        (WebCore::DocumentLoader::isStopping):
        (WebCore::DocumentLoader::response):
        (WebCore::DocumentLoader::mainDocumentError):
        (WebCore::DocumentLoader::setResponse):
        * loader/FrameLoader.h:
        * loader/FrameLoaderClient.h:
        * loader/mac/DocumentLoaderMac.mm:
        (WebCore::DocumentLoader::DocumentLoader):
        (WebCore::DocumentLoader::stopLoading):
        (WebCore::DocumentLoader::receivedData):
        (WebCore::DocumentLoader::setupForReplaceByMIMEType):
        (WebCore::DocumentLoader::prepareForLoadStart):
        * loader/mac/FrameLoaderMac.mm:
        (WebCore::FrameLoader::commitProvisionalLoad):
        (WebCore::FrameLoader::setResponse):
        * loader/mac/ImageDocumentMac.mm:
        (WebCore::finishImageLoad):

2006-12-15  Anders Carlsson  <acarlsson@apple.com>

        * loader/DocumentLoader.h:
        Whoops, didn't mean to commit this.
        
2006-12-15  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Darin and Brady (in no particular order).
        
        More loader cleanup.
        
        * loader/FrameLoader.h:
        * loader/mac/FrameLoaderMac.mm:
        (WebCore::FrameLoader::cancelledError):
        (WebCore::FrameLoader::fileDoesNotExistError):
        (WebCore::FrameLoader::cannotShowMIMEType):
        (WebCore::FrameLoader::interruptionForPolicyChangeError):
        * loader/mac/MainResourceLoaderMac.mm:
        * loader/mac/NetscapePlugInStreamLoaderMac.mm:

2006-12-16  Alexey Proskuryakov  <ap@webkit.org>

        Try to fix Windows buid.

        * WebCore.vcproj/WebCore/WebCore.vcproj: Added EventTarget.{h,cpp}

2006-12-15  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin.

        http://bugs.webkit.org/show_bug.cgi?id=11610
        XMLHttpRequest.onreadystatechange doesn't provide access to the request object

        Created a separate EventTarget class, now that EventTargetNode isn't the only kind.

        Test: http/tests/xmlhttprequest/event-target.html

        * WebCore.xcodeproj/project.pbxproj: Added EventTarget.{h,cpp}

        * bindings/js/kjs_dom.cpp:
        (KJS::toJS): Added an EventTarget variant.
        * bindings/js/kjs_dom.h: Added toJS() for EventTarget; some minor style fixes.

        * bindings/objc/DOM.mm:
        (+[DOMNode _eventTargetWith:WebCore::]):
        * bindings/scripts/CodeGeneratorObjC.pm:
        Added an EventTarget->DOMEventTarget converter in DOMNode (WebCoreInternal). 
        It only works for nodes, since we don't have an ObjC binding for XMLHttpRequest.
        Corrected spelling of internalHeaderContent.

        * dom/Event.cpp:
        (WebCore::Event::setTarget):
        * dom/Event.h:
        (WebCore::Event::target):
        (WebCore::Event::currentTarget):
        (WebCore::Event::setCurrentTarget):
        These methods now work with EventTargets instead of Nodes.

        * dom/EventTarget.cpp: Added.
        (WebCore::EventTarget::~EventTarget):
        (WebCore::EventTarget::toNode):
        (WebCore::EventTarget::toXMLHttpRequest):
        * dom/EventTarget.h: Added.
        (WebCore::EventTarget::ref):
        (WebCore::EventTarget::deref):
        Originally, my intention was to share much of the implementation between 
        EventTargetNode and XHR, but now I don't see anything substantial worth sharing.

        * dom/EventTargetNode.cpp:
        (WebCore::EventTargetNode::dispatchGenericEvent): Cast Node to EventTargetNode.

        * dom/EventTargetNode.h: Made EventTarget methods virtual.
        (WebCore::EventTargetNode::toNode): Added poor man's RTTI to upcast from EventTarget.
        (WebCore::EventTargetNode::refEventTarget):
        (WebCore::EventTargetNode::derefEventTarget):

        * dom/MouseEvent.cpp:
        (WebCore::MouseEvent::toElement):
        (WebCore::MouseEvent::fromElement):
        * dom/MouseRelatedEvent.cpp:
        (WebCore::MouseRelatedEvent::receivedTarget):
        * html/HTMLAnchorElement.cpp:
        (WebCore::HTMLAnchorElement::defaultEventHandler):
        * html/HTMLLabelElement.cpp:
        (WebCore::HTMLLabelElement::defaultEventHandler):
        * page/ContextMenuController.cpp:
        (WebCore::ContextMenuController::handleContextMenuEvent):
        * rendering/RenderSlider.cpp:
        (WebCore::RenderSlider::mouseEventIsInThumb):
        Cast from EventTarget to Node as appropriate.

        * xml/xmlhttprequest.cpp:
        (WebCore::XMLHttpRequest::dispatchEvent):
        (WebCore::XMLHttpRequest::callReadyStateChangeListener):
        Set target and currentTarget before dispatching.

        * xml/xmlhttprequest.h: Made EventTarget methods virtual, added a bool tempEvent parameter
        to match EventTargetNode.
        (WebCore::XMLHttpRequest::toXMLHttpRequest): Added poor man's RTTI to upcast from EventTarget.
        (WebCore::XMLHttpRequest::refEventTarget):
        (WebCore::XMLHttpRequest::derefEventTarget):

2006-12-15  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Darin.

        More loader cleanup, use KURL instead of NSURL in a couple of places.

        * loader/DocumentLoader.h:
        * loader/FrameLoader.h:
        * loader/FrameLoaderClient.h:
        * loader/ResourceLoader.h:
        * loader/mac/DocumentLoaderMac.mm:
        (WebCore::DocumentLoader::DocumentLoader):
        (WebCore::DocumentLoader::prepareForLoadStart):
        * loader/mac/FrameLoaderMac.mm:
        (WebCore::FrameLoader::willUseArchive):
        * loader/mac/ResourceLoaderMac.mm:
        (WebCore::ResourceLoader::load):

2006-12-15  Marvin Decker  <marv.decker@gmail.com>

        Reviewed by Darin and Alexey.

        Fix the Windows build, move various Client implementations out of
        WebCore and into WebKit.

        * WebCore.vcproj/WebCore/WebCore.vcproj:
        * bridge/win/ChromeClientWin.h: Removed.
        * bridge/win/ContextMenuClientWin.h: Removed.
        * bridge/win/EditorClientWin.h: Removed.
        * bridge/win/FrameWin.cpp:
        (WebCore::FrameWin::FrameWin):
        * bridge/win/FrameWin.h:
        * loader/win/FrameLoaderClientWin.cpp: Removed.
        * loader/win/FrameLoaderClientWin.h: Removed.
        * platform/network/win/ResourceHandleWin.cpp:
        (WebCore::ResourceHandle::start):
        * platform/win/TemporaryLinkStubs.cpp:
        (WebCore::DocumentLoader::URL):
        (WebCore::FrameLoader::load):
        (WebCore::FrameLoader::createFrame):
        (WebCore::FrameLoader::loadResourceSynchronously):
        (WebCore::Pasteboard::writeSelection):
        (WebCore::Pasteboard::writeURL):
        (WebCore::Pasteboard::clear):
        (WebCore::Pasteboard::~Pasteboard):
        (WebCore::PolicyCheck::call):
        (WebCore::PopupMenu::PopupMenu):
        (WebCore::ResourceHandle::loadsBlocked):
        (WebCore::ResourceLoader::cancel):

2006-12-15  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Maciej.

        http://bugs.webkit.org/show_bug.cgi?id=11842
        REGRESSION: Using Safari's snippet editor leaves applewebdata: URLs in history
        
        * loader/mac/DocumentLoaderMac.mm:
        (WebCore::DocumentLoader::URLForHistory):
        Don't return appleweburls without an unreachable url.

2006-12-15  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Darin.

        Replace more instances of NSError with ResourceError.
        
        Also remove a check for a selector that was added pre-Tiger.
        
        * WebCore.exp:
        * loader/DocumentLoader.h:
        * loader/FrameLoader.h:
        * loader/ResourceLoader.h:
        * loader/mac/DocumentLoaderMac.mm:
        (WebCore::DocumentLoader::setMainDocumentError):
        (WebCore::DocumentLoader::mainDocumentError):
        (WebCore::DocumentLoader::clearErrors):
        (WebCore::DocumentLoader::mainReceivedError):
        * loader/mac/FrameLoaderMac.mm:
        (WebCore::FrameLoader::cancelMainResourceLoad):
        (WebCore::FrameLoader::opened):
        (WebCore::FrameLoader::mainReceivedError):
        (WebCore::FrameLoader::cancelledError):
        (WebCore::FrameLoader::fileDoesNotExistError):
        (WebCore::FrameLoader::handleUnimplementablePolicy):
        (WebCore::FrameLoader::setMainDocumentError):
        (WebCore::FrameLoader::mainReceivedCompleteError):
        (WebCore::FrameLoader::sendRemainingDelegateMessages):
        (WebCore::FrameLoader::requestFromDelegate):
        (WebCore::FrameLoader::loadedResourceFromMemoryCache):
        (WebCore::FrameLoader::loadResourceSynchronously):
        * loader/mac/ResourceLoaderMac.mm:
        (WebCore::ResourceLoader::willSendRequest):
        (WebCore::ResourceLoader::didCancel):
        (WebCore::ResourceLoader::cancel):
        (WebCore::ResourceLoader::cancelledError):
        * loader/mac/SubresourceLoaderMac.mm:
        (WebCore::SubresourceLoader::didCancel):

2006-12-15  Rob Buis  <buis@kde.org>

        Reviewed by Darin.

        http://bugs.webkit.org/show_bug.cgi?id=11824
        CSSStyleSheet.title property is always null

        Set title on the stylesheet just after creating it, for the HTML
        elements <link> and <style>.

        * css/StyleSheet.h:
        (WebCore::StyleSheet::setTitle):
        * dom/Element.cpp:
        (WebCore::Element::title):
        * dom/Element.h:
        * dom/StyleElement.cpp:
        (WebCore::StyleElement::childrenChanged):
        * dom/StyleElement.h:
        * html/HTMLElement.cpp:
        * html/HTMLElement.h:
        * html/HTMLLinkElement.cpp:
        (WebCore::HTMLLinkElement::parseMappedAttribute):
        (WebCore::HTMLLinkElement::setCSSStyleSheet):
        * html/HTMLStyleElement.cpp:
        (WebCore::HTMLStyleElement::parseMappedAttribute):
        * ksvg2/svg/SVGStyleElement.cpp:
        (WebCore::SVGStyleElement::setTitle):
        (WebCore::SVGStyleElement::parseMappedAttribute):
        * ksvg2/svg/SVGStyleElement.h:

2006-12-15  Lars Knoll  <lars@trolltech.com>

        Reviewed by Zack

        Fix compilation.

        * loader/SubresourceLoader.h:
        * platform/qt/PopupMenuQt.cpp:
        (WebCore::PopupMenu::PopupMenu):

2006-12-14  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Maciej.

        Use char* pointer + length instead of NSData in a bunch of places.

        * loader/DocumentLoader.h:
        * loader/FrameLoader.h:
        * loader/FrameLoaderClient.h:
        * loader/MainResourceLoader.h:
        * loader/NetscapePlugInStreamLoader.h:
        * loader/ResourceLoader.h:
        (WebCore::ResourceLoader::willStopBufferingData):
        * loader/SubresourceLoader.h:
        * loader/mac/DocumentLoaderMac.mm:
        (WebCore::DocumentLoader::commitLoad):
        (WebCore::DocumentLoader::receivedData):
        (WebCore::DocumentLoader::setupForReplaceByMIMEType):
        * loader/mac/FrameLoaderMac.mm:
        (WebCore::FrameLoader::didReceiveData):
        (WebCore::FrameLoader::receivedData):
        (WebCore::FrameLoader::committedLoad):
        * loader/mac/MainResourceLoaderMac.mm:
        (WebCore::MainResourceLoader::addData):
        (WebCore::MainResourceLoader::didReceiveData):
        * loader/mac/NetscapePlugInStreamLoaderMac.mm:
        (WebCore::NetscapePlugInStreamLoader::didReceiveData):
        * loader/mac/ResourceLoaderMac.mm:
        (WebCore::ResourceLoader::addData):
        (WebCore::ResourceLoader::didReceiveData):
        (WebCore::ResourceLoader::willStopBufferingData):
        * loader/mac/SubresourceLoaderMac.mm:
        (WebCore::SubresourceLoader::didReceiveData):
        * platform/network/ResourceHandleClient.h:
        (WebCore::ResourceHandleClient::willStopBufferingData):
        * platform/network/mac/ResourceHandleMac.mm:
        (-[WebCoreResourceHandleAsDelegate connection:willStopBufferingData:]):

2006-12-14  Adele Peterson  <adele@apple.com>

        Reviewed by Adam. 

        Added PopupMenuClient class so the PopupMenu class no longer needs to know
        about the RenderMenuList or the DOM.

        * platform/PopupMenu.h:
        (WebCore::PopupMenuClient::~PopupMenuClient):
        (WebCore::PopupMenu::create): Made this protected so PopupMenu can be subclassed.
        (WebCore::PopupMenu::disconnectClient): Renamed from disconnectMenuList.
        (WebCore::PopupMenu::client): Added.
        * platform/mac/PopupMenuMac.mm:
        (WebCore::PopupMenu::PopupMenu): Created using PopupMenuClient instead of RenderMenuList.
        (WebCore::PopupMenu::populate): Asks the client for info about the list items instead of looking at the DOM or the renderer. 
        (WebCore::PopupMenu::show): ditto.
        (WebCore::PopupMenu::hide): ditto.
        * rendering/RenderMenuList.h: Now also inherits from PopupMenuClient.
        (WebCore::RenderMenuList::shouldPopOver): Added.  Tells the popup whether the menu should pop over the client, or under.
        * rendering/RenderMenuList.cpp:
        (WebCore::RenderMenuList::~RenderMenuList): Calls disconnectClient().
        (WebCore::RenderMenuList::calcMinMaxWidth): Removed unnecessary (and harmful) call to updateFromElement. updateFromElmeent
         can add children, and you don't want to do that in the middle of calculating width.
        (WebCore::RenderMenuList::itemText): Added PopupClient method to provide information about the items in the menu list.
        (WebCore::RenderMenuList::itemIsEnabled): ditto.
        (WebCore::RenderMenuList::itemStyle): ditto.
        (WebCore::RenderMenuList::clientStyle): ditto.
        (WebCore::RenderMenuList::clientDocument): ditto.
        (WebCore::RenderMenuList::clientPaddingLeft): ditto.
        (WebCore::RenderMenuList::clientPaddingRight): ditto.
        (WebCore::RenderMenuList::listSize): ditto.
        (WebCore::RenderMenuList::selectedIndex): ditto.
        (WebCore::RenderMenuList::itemIsSeparator): ditto.
        (WebCore::RenderMenuList::itemIsLabel): ditto.
        (WebCore::RenderMenuList::itemIsSelected): ditto.
        (WebCore::RenderMenuList::setTextFromItem): ditto.

2006-12-14  Geoffrey Garen  <ggaren@apple.com>

        Fixed <rdar://problem/4882713> GMAIL (REGRESSION): Can't apply font style, 
        foreground or background to selected text
        
        Also <rdar://problem/4883751> REGRESSION: Caret fails to insert itself 
        automatically in a new note window
        
        I'm rolling out my change to move focus to the page level because it caused
        too many unexpected and bizarre regressions. Our code relies on focus
        being per-document so that it can make focus changes that are effectively
        no-ops, and so that it can conflate focus and selection in some cases (a bad 
        idea, since they're not the same).
        
        Hopefully we can revisit this, along with hover and active, in the future.

        * dom/Document.cpp:
        (WebCore::widgetForNode):
        (WebCore::relinquishesEditingFocus):
        (WebCore::acceptsEditingFocus):
        (WebCore::clearSelectionIfNeeded):
        (WebCore::Document::removedLastRef):
        (WebCore::Document::detach):
        (WebCore::Document::focusedNodeDetached):
        (WebCore::Document::setFocusedNode):
        * dom/Document.h:
        (WebCore::Document::focusedNode):
        * page/FocusController.cpp:
        * page/FocusController.h:

2006-12-14  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Geoff.

        - fix failing drag & drop layout tests

        * platform/mac/KURLMac.mm:
        (WebCore::KURL::getNSURL): Turn empty KURL into empty NSURL, but null KURL into
        nil.

2006-12-14  Steve Falkenburg  <sfalken@apple.com>

        Build fix.

        * loader/MainResourceLoader.h:

2006-12-14  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by John.

        Convert a bunch of NSErrors to ResourceError.
        
        Make the ResourceError accessor functions const.
        
        * WebCore.exp:
        * WebCore.xcodeproj/project.pbxproj:
        * loader/FrameLoader.h:
        * loader/FrameLoaderClient.h:
        * loader/MainResourceLoader.h:
        * loader/NetscapePlugInStreamLoader.h:
        * loader/ResourceLoader.h:
        * loader/SubresourceLoader.h:
        * loader/mac/FrameLoaderMac.mm:
        (WebCore::FrameLoader::didFailToLoad):
        (WebCore::FrameLoader::receivedMainResourceError):
        (WebCore::FrameLoader::interruptionForPolicyChangeError):
        * loader/mac/MainResourceLoaderMac.mm:
        (WebCore::MainResourceLoader::receivedError):
        (WebCore::MainResourceLoader::didCancel):
        (WebCore::MainResourceLoader::interruptionForPolicyChangeError):
        (WebCore::MainResourceLoader::didFail):
        * loader/mac/NetscapePlugInStreamLoaderMac.mm:
        (WebCore::NetscapePlugInStreamLoader::didFail):
        (WebCore::NetscapePlugInStreamLoader::didCancel):
        * loader/mac/ResourceLoaderMac.mm:
        (WebCore::ResourceLoader::didFail):
        (WebCore::ResourceLoader::didCancel):
        * loader/mac/SubresourceLoaderMac.mm:
        (WebCore::SubresourceLoader::didFail):
        (WebCore::SubresourceLoader::didCancel):
        * platform/network/ResourceError.h:
        (WebCore::ResourceError::domain):
        (WebCore::ResourceError::errorCode):
        (WebCore::ResourceError::failingURL):
        (WebCore::ResourceError::localizedDescription):
        (WebCore::ResourceError::unpackPlatformErrorIfNeeded):

2006-12-14  George Staikos  <staikos@kde.org>

        Link, after the last loader changes.  Please update this directory with stubs when modifying the loader.

        * loader/qt/FrameLoaderQt.cpp:
        (WebCore::FrameLoader::loadResourceSynchronously):

2006-12-14  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by harrison

        <rdar://problem/4866671>
        CrashTracer: 1 crashes in Mail after deleting a list item at WebCore::DeleteSelectionCommand::doApply()
        
        Don't allow VisiblePositions inside -webkit-user-select:none regions.
        Renamed inRenderedContent to isCandidate.

        * dom/Document.cpp:
        (WebCore::Document::updateSelection):
        * dom/Position.cpp:
        (WebCore::Position::previousCharacterPosition):
        (WebCore::Position::nextCharacterPosition):
        (WebCore::nodeIsUserSelectNone):
        (WebCore::Position::isCandidate):
        (WebCore::Position::rendersInDifferentPosition):
        * dom/Position.h:
        * editing/InsertParagraphSeparatorCommand.cpp:
        (WebCore::InsertParagraphSeparatorCommand::doApply):
        * editing/InsertTextCommand.cpp:
        (WebCore::InsertTextCommand::input):
        * editing/VisiblePosition.cpp:
        (WebCore::VisiblePosition::canonicalPosition):
        * editing/htmlediting.cpp:
        (WebCore::nextCandidate):
        (WebCore::nextVisuallyDistinctCandidate):
        (WebCore::previousCandidate):
        (WebCore::previousVisuallyDistinctCandidate):
        * editing/visible_units.cpp:
        (WebCore::previousLinePosition):
        (WebCore::nextLinePosition):
        (WebCore::startOfParagraph):
        * page/Frame.cpp:
        (WebCore::Frame::styleForSelectionStart):

2006-12-14  David Hyatt  <hyatt@apple.com>

        Get rid of the containsStart check and just rely on the selectionState
        bits.  This allows selection gap filling to behave properly in the presence
        of inline blocks and inline tables on lines when the selection originates
        inside the inline block.

        Reviewed by ggaren

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::fillInlineSelectionGaps):

2006-12-14  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by John.
        
        General loader cleanup, convert NSURLResponse to ResourceResponse in some places.
        
        * loader/DocumentLoader.h:
        * loader/SubresourceLoader.h:
        * loader/mac/DocumentLoaderMac.mm:
        (WebCore::DocumentLoader::addResponse):
        * loader/mac/FrameLoaderMac.mm:
        (WebCore::FrameLoader::opened):
        * loader/mac/SubresourceLoaderMac.mm:
        (WebCore::SubresourceLoader::create):

2006-12-14  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Darin.

        Add loadResourceSynchronously to ResourceHandle and have FrameLoader use it instead of
        calling NSURLConnection directly.

        Add an isNull flag to ResourceError so we can convert correctly between nil NSErrors and ResourceErrors.

        Get rid of ServeSynchronousRequest and use the loader instead.
        
        * WebCore.exp:
        * dom/XMLTokenizer.cpp:
        (WebCore::openFunc):
        * loader/FrameLoader.h:
        * loader/LoaderFunctions.h:
        * loader/mac/FrameLoaderMac.mm:
        (WebCore::FrameLoader::canLoad):
        (WebCore::FrameLoader::loadResourceSynchronously):
        * loader/mac/LoaderFunctionsMac.mm:
        * platform/network/ResourceError.h:
        (WebCore::ResourceError::ResourceError):
        (WebCore::ResourceError::isNull):
        * platform/network/ResourceHandle.h:
        * platform/network/ResourceRequest.cpp:
        (WebCore::ResourceRequest::isConditional):
        * platform/network/ResourceRequest.h:
        * platform/network/mac/ResourceErrorMac.mm:
        (-[NSError WebCore]):
        * platform/network/mac/ResourceHandleMac.mm:
        (WebCore::ResourceHandle::loadResourceSynchronously):
        * xml/XSLTProcessor.cpp:
        (WebCore::docLoaderFunc):
        * xml/xmlhttprequest.cpp:
        (WebCore::XMLHttpRequest::send):

2006-12-14  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Darin.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=11830

        Fix fundamental problems with JS SVG POD types.
        (currently: FloatPoint/FloatRect/AffineTransform)

        This doesn't affect any testcase, but when I wrote my SVGLength* -> SVGLength
        the problem got visible (aka. baseVal-animVal-equality.svg broke and more)
        With that patch applied first, none breaks - so SVG POD JS wrappers do work now.

        In detail:
        - Fix setBaseValue() confusion. ONLY use the hash map in SVGDocumentExtension
          when we're animating a property. Add "start##Property" / "stop##Property" methods
          which take care, of moving "animVal" -> "baseVal" hash, and back after animation stopped.

          These new methods are not yet used anywhere, but finally the "animated property" system is complete.

        - Offer a new JSSVGPODTypeWrapper class, wrapping around non-pointer POD types like FloatPoint etc.
          to be used in the generated JS bindings. Currently if you modified ie the "x" property of a SVGPoint
          from JS, you only actually modified the "m_x" object stored in the JSSVGPoint wrapper.

          If you take SVGLength as example (more frequently used in the JS SVG bindings, that's why I'm using it)
          "document.rootElement.width.baseVal.value = 100;" only modified the "SVGLength m_impl" object stored in
          JSSVGLength, but the "SVGSVGElement" didn't notice it width got changed. The new commitChanges() logic
          fixes these problems.

        It's quite hard too describe the actual changes, if one is not familiar with the code. This is the result
        of endless discussions with Eric Seidel, and we hope this is a decent solution adressing all issues.

        * WebCore.xcodeproj/project.pbxproj:
        * bindings/js/JSSVGMatrixCustom.cpp:
        (WebCore::JSSVGMatrix::inverse):
        (WebCore::JSSVGMatrix::rotateFromVector):
        * bindings/js/JSSVGPODTypeWrapper.h: Added.
        (WebCore::JSSVGPODTypeWrapper::JSSVGPODTypeWrapper):
        (WebCore::JSSVGPODTypeWrapper::~JSSVGPODTypeWrapper):
        (WebCore::JSSVGPODTypeWrapper::operator PODType&):
        (WebCore::JSSVGPODTypeWrapper::commitChange):
        (WebCore::JSSVGPODTypeWrapperCreator::JSSVGPODTypeWrapperCreator):
        (WebCore::JSSVGPODTypeWrapperCreator::~JSSVGPODTypeWrapperCreator):
        (WebCore::JSSVGPODTypeWrapperCreator::commitChange):
        * bindings/scripts/CodeGeneratorJS.pm:
        * ksvg2/misc/SVGDocumentExtensions.h:
        (WebCore::SVGDocumentExtensions::removeBaseValue):
        * ksvg2/svg/SVGElement.h:

2006-12-14  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin.

        http://bugs.webkit.org/show_bug.cgi?id=11828
        Fix a leak of NSURLRequest on each update - RetainPtr retains the object itself.

        * platform/network/mac/ResourceRequestMac.mm:
        (WebCore::ResourceRequest::doUpdatePlatformRequest):

2006-12-14  Simon Hausmann  <hausmann@kde.org>

        Reviewed by Zack Rusin.

        * WebCore.pro: Clean up the xpath grammar generation rule.

2006-12-14  Zack Rusin  <zack@kde.org>

        Make it link with temporary stubs.

        * loader/qt/DocumentLoaderQt.cpp:
        (WebCore::DocumentLoader::originalRequest):
        (WebCore::DocumentLoader::originalRequestCopy):
        (WebCore::DocumentLoader::request):
        (WebCore::DocumentLoader::initialRequest):
        (WebCore::DocumentLoader::actualRequest):
        (WebCore::DocumentLoader::URL):

2006-12-14  Zack Rusin  <zack@kde.org>

        Compilation fixes for the Qt port after last nights
        changes.

        * loader/qt/DocumentLoaderQt.cpp:
        (WebCore::DocumentLoader::URL):
        (WebCore::DocumentLoader::unreachableURL):
        * loader/qt/FrameLoaderQt.cpp:
        (WebCore::PolicyCheck::call):
        * platform/network/ResourceRequest.h:
        (WebCore::ResourceRequest::setHTTPReferrer):

2006-12-14  Rob Buis  <buis@kde.org>

        Reviewed by Oliver.

        http://bugs.webkit.org/show_bug.cgi?id=11726
        SVG Image do not take into account clip/overflow when hit testing

        Take into account the overflowRect when hit-testing <svg> container.

        * rendering/RenderSVGContainer.cpp:
        (WebCore::RenderSVGContainer::viewportTransform):
        (WebCore::RenderSVGContainer::nodeAtPoint):
        * rendering/RenderSVGContainer.h:

2006-12-13  David Hyatt  <hyatt@apple.com>

        Fix for bug 11825, dragging elements via -khtml-user-drag is broken (affects Dashboard).  Make sure
        to clear the paintingRoot properly when recurring into children.  It would be nice to find a design
        that prevented this mistake from being made and didn't require explicit clearing of the root.

        Reviewed by olliej

        * rendering/InlineFlowBox.cpp:
        (WebCore::InlineFlowBox::paint):
        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::paintChildren):
        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::paint):
        * rendering/RenderTable.cpp:
        (WebCore::RenderTable::paint):

2006-12-13  Anders Carlsson  <acarlsson@apple.com>

        * loader/FrameLoader.h:
        id is mac-only.
        
2006-12-13  Brady Eidson  <beidson@apple.com>

        Implicitly reviewed by Darin, Hyatt, Maciej, and others!

        Fixes a document tear down crash.
        Changes a few long standing assertions to our new style

        * dom/Document.cpp:
        (WebCore::Document::~Document):
        (WebCore::Document::topDocument):

2006-12-13  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Anders.

        - converted many places to use ResourceRequest instead of NSURLRequest

        * WebCore.exp:
        * loader/DocumentLoader.h:
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::stopPolicyCheck):
        * loader/FrameLoader.h:
        (WebCore::PolicyCheck::request):
        * loader/FrameLoaderClient.h:
        * loader/MainResourceLoader.h:
        * loader/mac/DocumentLoaderMac.mm:
        (WebCore::DocumentLoader::DocumentLoader):
        (WebCore::DocumentLoader::originalRequest):
        (WebCore::DocumentLoader::originalRequestCopy):
        (WebCore::DocumentLoader::request):
        (WebCore::DocumentLoader::initialRequest):
        (WebCore::DocumentLoader::actualRequest):
        (WebCore::DocumentLoader::URL):
        (WebCore::DocumentLoader::unreachableURL):
        (WebCore::DocumentLoader::replaceRequestURLForAnchorScroll):
        (WebCore::DocumentLoader::setRequest):
        (WebCore::DocumentLoader::stopLoading):
        (WebCore::DocumentLoader::setLastCheckedRequest):
        (WebCore::DocumentLoader::lastCheckedRequest):
        (WebCore::DocumentLoader::URLForHistory):
        * loader/mac/FrameLoaderMac.mm:
        (WebCore::FrameLoader::load):
        (WebCore::FrameLoader::startLoadingMainResource):
        (WebCore::FrameLoader::applyUserAgent):
        (WebCore::FrameLoader::originalRequest):
        (WebCore::FrameLoader::receivedMainResourceError):
        (WebCore::FrameLoader::callContinueFragmentScrollAfterNavigationPolicy):
        (WebCore::FrameLoader::continueFragmentScrollAfterNavigationPolicy):
        (WebCore::FrameLoader::commitProvisionalLoad):
        (WebCore::FrameLoader::initialRequest):
        (WebCore::FrameLoader::setRequest):
        (WebCore::FrameLoader::checkNavigationPolicy):
        (WebCore::FrameLoader::shouldReloadToHandleUnreachableURL):
        (WebCore::FrameLoader::reloadAllowingStaleData):
        (WebCore::FrameLoader::reload):
        (WebCore::FrameLoader::checkNewWindowPolicy):
        (WebCore::FrameLoader::continueAfterNewWindowPolicy):
        (WebCore::FrameLoader::continueAfterNavigationPolicy):
        (WebCore::FrameLoader::callContinueLoadAfterNavigationPolicy):
        (WebCore::FrameLoader::continueLoadAfterNavigationPolicy):
        (WebCore::FrameLoader::checkLoadCompleteForThisFrame):
        (WebCore::FrameLoader::callContinueLoadAfterNewWindowPolicy):
        (WebCore::FrameLoader::continueLoadAfterNewWindowPolicy):
        (WebCore::FrameLoader::post):
        (WebCore::FrameLoader::addExtraFieldsToRequest):
        (WebCore::FrameLoader::isReloading):
        (WebCore::FrameLoader::referrer):
        (WebCore::FrameLoader::loadEmptyDocumentSynchronously):
        (WebCore::FrameLoader::loadResourceSynchronously):
        (WebCore::FrameLoader::originalRequestURL):
        (WebCore::PolicyCheck::set):
        (WebCore::PolicyCheck::call):
        (WebCore::PolicyCheck::clearRequest):
        * loader/mac/MainResourceLoaderMac.mm:
        (WebCore::MainResourceLoader::callContinueAfterNavigationPolicy):
        (WebCore::MainResourceLoader::continueAfterNavigationPolicy):
        (WebCore::MainResourceLoader::isPostOrRedirectAfterPost):
        * loader/mac/SubresourceLoaderMac.mm:
        (WebCore::SubresourceLoader::create):
        * loader/mac/WebDataProtocol.h:
        * loader/mac/WebDataProtocol.mm:
        * platform/KURL.cpp:
        (WebCore::operator!=):
        * platform/KURL.h:
        * platform/mac/KURLMac.mm:
        (WebCore::KURL::getNSURL):
        * platform/network/FormData.h:
        (WebCore::operator==):
        (WebCore::operator!=):
        * platform/network/ResourceRequest.cpp:
        (WebCore::operator==):
        * platform/network/ResourceRequest.h:
        * platform/network/mac/ResourceRequestMac.mm:
        (WebCore::ResourceRequest::doUpdatePlatformRequest):

2006-12-13  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Darin Adler, Dave Hyatt.
        
        Beefed up FocusController to handle frame focus. Changed implementors to
        use FocusController, rather than the widget hierarchy, to focus frames.

        (WebCore::FocusController::focusedNode): Made a minor change to focus a frame
        before focusing the element inside of it. This matches FF.
        (WebCore::FocusController::focusedFrame):
        * platform/Widget.h:

2006-12-13  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by adele

        <rdar://problem/4818145>
        Cannot setSelectedDOMRange to non-editable island unless it has editable content on both sides
        
        There are editable positions before/after a "non-editable island" if its 
        a table, but the code in canonicalPosition was not using 
        editableRootForPosition to find root editable elements.
        
        * editing/VisiblePosition.cpp:
        (WebCore::VisiblePosition::canonicalPosition): Use editableRootForPosition
        to fix the table case.

2006-12-13  Steve Falkenburg  <sfalken@apple.com>

        Reviewed by Adam.

        Added missing forwarding headers.        

        * ForwardingHeaders/kjs/value.h: Added.
        * ForwardingHeaders/wtf/HashTable.h: Added.

2006-12-13  Lars Knoll <lars@trolltech.com>

        Reviewed by Maciej, Zack.

        Make the Qt cbuild compile again.

        * WebCore.pro:
        * loader/qt/ResourceLoaderQt.cpp:
        * platform/network/qt/ResourceHandleQt.cpp:
        (WebCore::ResourceHandle::start):
        (WebCore::ResourceHandle::loadsBlocked):
        * platform/qt/FrameQtClient.cpp:
        (WebCore::FrameQtClient::openURL):
        (WebCore::FrameQtClient::submitForm):

2006-12-12  Adam Roben  <aroben@apple.com>

        Reviewed by Anders.

        Changed #import to #include to match the rest of our ForwardingHeaders.

        * ForwardingHeaders/wtf/StringExtras.h:

2006-12-12  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by harrison
        
        <rdar://problem/4757667>
        GoogleDocs: Style menu does not open

        * bindings/js/kjs_window.cpp:
        (KJS::Selection::getValueProperty): Added rangeCount.
        * bindings/js/kjs_window.h:
        (KJS::Selection::):
        * editing/SelectionController.h:
        (WebCore::SelectionController::rangeCount): Added.

2006-12-12  Alice Liu  <alice.liu@apple.com>

        Reviewed by Oliver.

        * bindings/js/JSSVGMatrixCustom.cpp:
        added #ifdef SVG_SUPPORT

2006-12-12  Anders Carlsson  <acarlsson@apple.com>

        Suggested by Darin.

        * loader/ResourceLoader.cpp:
        Move down include of ResourceHandle.h.

2006-12-12  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Adam Roben, Dave Hyatt, Darin Adler.
        
        Factored focus control into a FocusController class. I inted to use this
        class for handling window active state and the focused frame, as well.

        Layout tests pass.

        * WebCore.xcodeproj/project.pbxproj:
        * dom/Document.cpp:
        (WebCore::Document::view):
        (WebCore::Document::page): New helper function.
        * dom/Document.h: Moved setters before getters.
        (WebCore::Document::hoverNode):
        (WebCore::Document::activeNode):
        * dom/Node.cpp:
        (WebCore::Node::detach): Use the FocusController.
        * page/FocusController.cpp: Added.
        (WebCore::shouldFocus): renamed and refactored this helper function.
        (WebCore::shouldUnfocus): ditto.
        * page/FocusController.h: Added.

2006-12-12  Anders Carlsson  <acarlsson@apple.com>

        Rubber Stamped by Geoff.

        * platform/Base64.cpp:
        * platform/Base64.h:
        Put functions inside of the WebCore namespace.

2006-12-12  Anders Carlsson  <acarlsson@apple.com>

        Try fixing the non-Mac builds.
        
        * loader/ResourceLoader.cpp:
        (WebCore::ResourceLoader::willSendRequest):
        (WebCore::ResourceLoader::didReceiveResponse):
        (WebCore::ResourceLoader::didReceiveData):
        (WebCore::ResourceLoader::didFinishLoading):
        (WebCore::ResourceLoader::didFail):
        * loader/SubresourceLoader.cpp:
        (WebCore::SubresourceLoader::create):
        * loader/SubresourceLoader.h:

2006-12-12  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Darin.

        Turn ResourceLoader into a ResourceHandleClient and stop using NSURLConnection in the loader.

        * WebCore.exp:
        Add new methods needed by WebKit.
        
        * WebCore.xcodeproj/project.pbxproj:
        Make ResourceHandle.h a private header.
        
        * loader/FrameLoaderClient.h:
        Change the download method to take a ResourceHandle instead of an NSURLConnection.
        
        * loader/MainResourceLoader.h:
        Get rid of the proxy instance variable, that's handled by ResourceHandlw now.
        
        * loader/ResourceLoader.h:
        (WebCore::ResourceLoader::didReceiveAuthenticationChallenge):
        (WebCore::ResourceLoader::didCancelAuthenticationChallenge):
        (WebCore::ResourceLoader::willStopBufferingData):
        (WebCore::ResourceLoader::willCacheResponse):
        (WebCore::ResourceLoader::receivedCredential):
        (WebCore::ResourceLoader::receivedRequestToContinueWithoutCredential):
        (WebCore::ResourceLoader::receivedCancellation):
        (WebCore::ResourceLoader::handle):
        * loader/SubresourceLoader.h:
        Make ResourceLoader a ResourceHandleClient, moving the methods from SubresourceLoader.
        
        * loader/mac/MainResourceLoaderMac.mm:
        (WebCore::MainResourceLoader::MainResourceLoader):
        (WebCore::MainResourceLoader::continueAfterContentPolicy):
        (WebCore::MainResourceLoader::loadNow):
        (WebCore::MainResourceLoader::load):
        Use a ResourceHandle instead of an NSURLConnection.
        
        * loader/mac/ResourceLoaderMac.mm:
        (WebCore::ResourceLoader::~ResourceLoader):
        (WebCore::ResourceLoader::releaseResources):
        (WebCore::ResourceLoader::load):
        (WebCore::ResourceLoader::setDefersLoading):
        (WebCore::ResourceLoader::resourceData):
        (WebCore::ResourceLoader::didReceiveAuthenticationChallenge):
        (WebCore::ResourceLoader::didCancel):
        (WebCore::ResourceLoader::willSendRequest):
        (WebCore::ResourceLoader::didReceiveResponse):
        (WebCore::ResourceLoader::didReceiveData):
        (WebCore::ResourceLoader::didFinishLoading):
        (WebCore::ResourceLoader::didFail):
        Remove the WebCoreResourceLoaderAsDelegate class, use a ResourceHandle instead of an NSURLConnection.
        
        * loader/mac/SubresourceLoaderMac.mm:
        Remove ResourceHandleClient methods.
        
        * platform/network/ResourceHandle.cpp:
        (WebCore::ResourceHandle::ResourceHandle):
        (WebCore::ResourceHandle::create):
        * platform/network/ResourceHandle.h:
        * platform/network/ResourceHandleInternal.h:
        (WebCore::ResourceHandleInternal::ResourceHandleInternal):
        Add an extra argument denoting whether this ResourceHandle can possibly be "converted" into one used for downloads.
        
        * platform/network/mac/ResourceHandleMac.mm:
        (WebCore::ResourceHandle::~ResourceHandle):
        (WebCore::ResourceHandle::start):
        (WebCore::ResourceHandle::releaseProxy):
        (WebCore::ResourceHandle::connection):
        New methods for creating a NSURLConnectionDelegateProxy which is used when creating a NSURLDownload from an existing
        connection.

2006-12-12  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Geoff.

        * loader/mac/SubresourceLoaderMac.mm:
        (WebCore::SubresourceLoader::load):
        * platform/network/mac/ResourceHandleMac.mm:
        (WebCore::ResourceHandle::start):
        Move the didTellBridgeAboutLoad call to SubresourceLoader in preparation for getting rid of
        the DocLoader parameter to ResourceHandle::create.

2006-12-12  George Staikos  <staikos@kde.org>

        Make the last checkin compile.

        * WebCore.pro:
        * ksvg2/svg/SVGTransform.cpp:

2006-12-12  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Sam Weinig & Rob Buis.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=11797

        Remove SVGMatrix, replace it by AffineTransform usage everywhere.
        Changed AffineTransform API to be able to be used within generation
        (m11() -> a(), m12() -> b(), ...). Add some methods needed for SVG.

        The actual SVGMatrix -> AffineTransformation patch has been created
        by Rob - I just adapted it to the autogenerated POD style.

        * WebCore.xcodeproj/project.pbxproj:
        * bindings/js/JSSVGMatrixCustom.cpp: Added.
        (WebCore::JSSVGMatrix::inverse):
        (WebCore::JSSVGMatrix::rotateFromVector):
        * bindings/objc/DOMInternal.h:
        * bindings/scripts/CodeGeneratorJS.pm:
        * bindings/scripts/CodeGeneratorObjC.pm:
        * ksvg2/misc/KSVGTimeScheduler.cpp:
        * ksvg2/misc/SVGImageLoader.cpp:
        * ksvg2/svg/SVGAnimateTransformElement.cpp:
        (WebCore::SVGAnimateTransformElement::handleTimerEvent):
        (WebCore::SVGAnimateTransformElement::calculateRotationFromMatrix):
        (WebCore::SVGAnimateTransformElement::initialMatrix):
        (WebCore::SVGAnimateTransformElement::transformMatrix):
        * ksvg2/svg/SVGAnimateTransformElement.h:
        * ksvg2/svg/SVGClipPathElement.cpp:
        (WebCore::SVGClipPathElement::canvasResource):
        * ksvg2/svg/SVGFitToViewBox.cpp:
        (WebCore::SVGFitToViewBox::viewBoxToViewTransform):
        * ksvg2/svg/SVGFitToViewBox.h:
        * ksvg2/svg/SVGLengthList.cpp:
        * ksvg2/svg/SVGLinearGradientElement.cpp:
        (WebCore::SVGLinearGradientElement::buildGradient):
        * ksvg2/svg/SVGLocatable.cpp:
        (WebCore::SVGLocatable::getCTM):
        (WebCore::SVGLocatable::getScreenCTM):
        (WebCore::SVGLocatable::getTransformToElement):
        * ksvg2/svg/SVGLocatable.h:
        * ksvg2/svg/SVGMarkerElement.cpp:
        * ksvg2/svg/SVGMatrix.cpp: Removed.
        * ksvg2/svg/SVGMatrix.h: Removed.
        * ksvg2/svg/SVGMatrix.idl:
        * ksvg2/svg/SVGNumberList.cpp:
        * ksvg2/svg/SVGPatternElement.cpp:
        (WebCore::SVGPatternElement::notifyAttributeChange):
        (WebCore::SVGPatternElement::getCTM):
        * ksvg2/svg/SVGPatternElement.h:
        * ksvg2/svg/SVGPoint.idl:
        * ksvg2/svg/SVGPreserveAspectRatio.cpp:
        (WebCore::SVGPreserveAspectRatio::getCTM):
        * ksvg2/svg/SVGPreserveAspectRatio.h:
        * ksvg2/svg/SVGRadialGradientElement.cpp:
        (WebCore::SVGRadialGradientElement::buildGradient):
        * ksvg2/svg/SVGSVGElement.cpp:
        (WebCore::SVGSVGElement::viewport):
        (WebCore::SVGSVGElement::createSVGMatrix):
        (WebCore::SVGSVGElement::createSVGTransformFromMatrix):
        (WebCore::SVGSVGElement::getCTM):
        (WebCore::SVGSVGElement::getScreenCTM):
        * ksvg2/svg/SVGSVGElement.h:
        * ksvg2/svg/SVGStyledElement.cpp:
        * ksvg2/svg/SVGStyledLocatableElement.cpp:
        (WebCore::SVGStyledLocatableElement::getCTM):
        (WebCore::SVGStyledLocatableElement::getScreenCTM):
        * ksvg2/svg/SVGStyledLocatableElement.h:
        * ksvg2/svg/SVGStyledTransformableElement.cpp:
        (WebCore::SVGStyledTransformableElement::localMatrix):
        (WebCore::SVGStyledTransformableElement::getCTM):
        (WebCore::SVGStyledTransformableElement::getScreenCTM):
        (WebCore::SVGStyledTransformableElement::updateLocalTransform):
        (WebCore::SVGStyledTransformableElement::attach):
        * ksvg2/svg/SVGStyledTransformableElement.h:
        * ksvg2/svg/SVGTextElement.cpp:
        (WebCore::SVGTextElement::localMatrix):
        (WebCore::SVGTextElement::updateLocalTransform):
        (WebCore::SVGTextElement::attach):
        (WebCore::SVGTextElement::getScreenCTM):
        (WebCore::SVGTextElement::getCTM):
        * ksvg2/svg/SVGTextElement.h:
        * ksvg2/svg/SVGTransform.cpp:
        (SVGTransform::SVGTransform):
        (SVGTransform::matrix):
        (SVGTransform::setMatrix):
        (SVGTransform::setTranslate):
        (SVGTransform::setScale):
        (SVGTransform::setRotate):
        (SVGTransform::setSkewX):
        (SVGTransform::setSkewY):
        * ksvg2/svg/SVGTransform.h:
        * ksvg2/svg/SVGTransformList.cpp:
        (SVGTransformList::createSVGTransformFromMatrix):
        (SVGTransformList::concatenate):
        * ksvg2/svg/SVGTransformList.h:
        * ksvg2/svg/SVGTransformable.cpp:
        (WebCore::SVGTransformable::getCTM):
        (WebCore::SVGTransformable::getScreenCTM):
        (WebCore::SVGTransformable::parseTransformAttribute):
        * ksvg2/svg/SVGTransformable.h:
        * platform/graphics/AffineTransform.cpp:
        (WebCore::AffineTransform::multiply):
        (WebCore::AffineTransform::scale):
        (WebCore::AffineTransform::scaleNonUniform):
        (WebCore::AffineTransform::rotateFromVector):
        (WebCore::AffineTransform::flipX):
        (WebCore::AffineTransform::flipY):
        (WebCore::AffineTransform::skewX):
        (WebCore::AffineTransform::skewY):
        * platform/graphics/AffineTransform.h:
        * platform/graphics/cairo/AffineTransformCairo.cpp:
        (WebCore::AffineTransform::a):
        (WebCore::AffineTransform::setA):
        (WebCore::AffineTransform::b):
        (WebCore::AffineTransform::setB):
        (WebCore::AffineTransform::c):
        (WebCore::AffineTransform::setC):
        (WebCore::AffineTransform::d):
        (WebCore::AffineTransform::setD):
        (WebCore::AffineTransform::e):
        (WebCore::AffineTransform::setE):
        (WebCore::AffineTransform::f):
        (WebCore::AffineTransform::setF):
        (WebCore::AffineTransform::inverse):
        * platform/graphics/cg/AffineTransformCG.cpp:
        (WebCore::AffineTransform::a):
        (WebCore::AffineTransform::setA):
        (WebCore::AffineTransform::b):
        (WebCore::AffineTransform::setB):
        (WebCore::AffineTransform::c):
        (WebCore::AffineTransform::setC):
        (WebCore::AffineTransform::d):
        (WebCore::AffineTransform::setD):
        (WebCore::AffineTransform::e):
        (WebCore::AffineTransform::setE):
        (WebCore::AffineTransform::f):
        (WebCore::AffineTransform::setF):
        (WebCore::AffineTransform::inverse):
        * platform/graphics/qt/AffineTransformQt.cpp:
        (WebCore::AffineTransform::a):
        (WebCore::AffineTransform::setA):
        (WebCore::AffineTransform::b):
        (WebCore::AffineTransform::setB):
        (WebCore::AffineTransform::c):
        (WebCore::AffineTransform::setC):
        (WebCore::AffineTransform::d):
        (WebCore::AffineTransform::setD):
        (WebCore::AffineTransform::e):
        (WebCore::AffineTransform::setE):
        (WebCore::AffineTransform::f):
        (WebCore::AffineTransform::setF):
        (WebCore::AffineTransform::inverse):
        * rendering/RenderForeignObject.cpp:
        (WebCore::RenderForeignObject::paint):
        (WebCore::RenderForeignObject::nodeAtPoint):
        * rendering/RenderPath.cpp:
        (WebCore::RenderPath::mapAbsolutePointToLocal):
        * rendering/RenderSVGImage.cpp:
        (WebCore::RenderSVGImage::paint):
        (WebCore::RenderSVGImage::nodeAtPoint):
        * rendering/RenderSVGText.cpp:
        (WebCore::RenderSVGText::computeAbsoluteRepaintRect):
        (WebCore::RenderSVGText::nodeAtPoint):
        (WebCore::RenderSVGText::paint):
        * rendering/SVGInlineFlowBox.cpp:
        (WebCore::paintSVGInlineFlow):
        * rendering/SVGRenderTreeAsText.cpp:
        (WebCore::operator<<):

2006-12-12  George Staikos  <staikos@kde.org>

        Reviewed by Alexey.

        Fix the Qt build again.

        * WebCore.pro:
        * loader/qt/FrameLoaderQt.cpp:
        (WebCore::FrameLoader::createFrame):
        (WebCore::FrameLoader::load):
        * platform/qt/PasteboardQt.cpp:
        (WebCore::Pasteboard::writeSelection):
        (WebCore::Pasteboard::writeURL):
        (WebCore::Pasteboard::clear):

2006-12-12  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Beth Dakin.
        
        Moved focus control to the page level. Fixed a minor bug where a node
        would retain keyboard focus even when removed from the document.
        
        We should probably move this, along with hover and active, into a separate
        FocusController. But I'm too tired right now.

        * dom/Document.cpp: Migrated code to Page
        (WebCore::Document::removedLastRef):
        (WebCore::Document::detach):
        (WebCore::Document::setFocusedNode):
        (WebCore::Document::focusedNode):
        * dom/Document.h:
        * dom/Node.cpp:
        (WebCore::Node::detach): Clear ourselves from keyboard focus. This fixes
        the minor bug and was also necessary to prevent regressions caused by hanging
        on to a focused node after the document was replaced.
        * dom/Node.h:
        (WebCore::Node::inDetach):
        * page/Page.cpp: Migrated code from Document
        (WebCore::shouldAcquireEditingFocus):
        (WebCore::shouldRelinquishEditingFocus):
        (WebCore::clearSelectionIfNeeded):
        (WebCore::widgetForNode):
        (WebCore::Page::setFocusedNode):
        * page/Page.h:
        (WebCore::Page::focusedNode):

2006-12-11  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin.

        http://bugs.webkit.org/show_bug.cgi?id=11053
        XMLHttpRequest should be an EventTarget

        Test: http/tests/xmlhttprequest/event-target.html

        * bindings/js/JSXMLHttpRequest.cpp:
        (KJS::JSXMLHttpRequest::mark):
        (KJS::JSXMLHttpRequest::~JSXMLHttpRequest):
        (KJS::JSXMLHttpRequestProtoFunc::callAsFunction):
        * bindings/js/JSXMLHttpRequest.h:
        (KJS::JSXMLHttpRequest::):
        * xml/xmlhttprequest.cpp:
        (WebCore::XMLHttpRequest::addEventListener):
        (WebCore::XMLHttpRequest::removeEventListener):
        (WebCore::XMLHttpRequest::dispatchEvent):
        (WebCore::XMLHttpRequest::callReadyStateChangeListener):
        * xml/xmlhttprequest.h:
        (WebCore::XMLHttpRequest::eventListeners):
        Implement EventTarget methods (except for NS variations, which Firefox doesn't have either).

2006-12-11  Darin Adler  <darin@apple.com>

        Reviewed by Geoff.

        - fix http://bugs.webkit.org/show_bug.cgi?id=11809
          fast/dom/gc-8.html crash in alternate-thread marking code in ScriptInterpreter

        DocumentType objects were getting filed under the wrong document in the
        DOM objects structure.

        * bindings/js/kjs_binding.h: Added a destructor for debugging purposes only.
        * bindings/js/kjs_binding.cpp:
        (KJS::wrapperSet): Added. Set of outstanding wrappers for debugging.
        (KJS::addWrapper): Added.
        (KJS::removeWrapper): Added.
        (KJS::removeWrappers): Added.
        (KJS::DOMObject::~DOMObject): Added. Asserts that there is no outstanding reference
        to this wrapper since it's being destroyed.
        (KJS::ScriptInterpreter::putDOMObject): Added a call to ADD_WRAPPER.
        (KJS::ScriptInterpreter::forgetDOMObject): Added a call to REMOVE_WRAPPER.
        (KJS::ScriptInterpreter::forgetDOMNodeForDocument): Added a call to REMOVE_WRAPPER.
        (KJS::ScriptInterpreter::putDOMNodeForDocument): Added a call to ADD_WRAPPER.
        (KJS::ScriptInterpreter::forgetAllDOMNodesForDocument): Added a call to REMOVE_WRAPPERS.
        (KJS::ScriptInterpreter::updateDOMNodeDocument): Added calls to REMOVE_WRAPPER and
        ADD_WRAPPER so the out-of-order transaction doesn't upset the assertions in the functions
        we're calling. Another solution would be to reorder the two, but I think that would
        create a race where another thread could garbage collect after the forget but before the put.
        (KJS::ScriptInterpreter::wasRunByUserGesture): Tweaked formatting.

        * dom/Document.cpp: (WebCore::Document::adoptNode): Removed call to updateDOMNodeDocument
        since setDocument now takes care of that.
        * dom/Node.cpp:
        (WebCore::Node::setDocument): Added call to updateDOMNodeDocument here.
        (WebCore::Node::checkAddChild): Removed call to updateDOMNodeDocument since setDocument
        now takes care of that.

2006-12-11  Alexey Proskuryakov  <ap@nypop.com>

        Reviewed by Darin.

        http://bugs.webkit.org/show_bug.cgi?id=9673
        Add support for window.atob() and window.btoa()

        * WebCore.xcodeproj/project.pbxproj: Added Base64.{h,cpp}
        * bindings/js/kjs_window.cpp:
        (KJS::WindowFunc::callAsFunction):
        * bindings/js/kjs_window.h:
        (KJS::Window::):
        * platform/Base64.cpp: Added.
        (base64Encode):
        (base64Decode):
        * platform/Base64.h: Added.
        * ForwardingHeaders/wtf/StringExtras.h: Added.
        * platform/DeprecatedString.cpp: Use strncasecmp from StringExtras.

2006-12-11  Darin Adler  <darin@apple.com>

        Reviewed by Brady.

        - did some of the Mac-specific file moves mentioned in my recent mail to the WebKit list

        * WebCore.xcodeproj/project.pbxproj: Updated project for file moves.

        * bridge/mac/FrameMac.h: Moved to page/mac.
        * bridge/mac/FrameMac.mm: Ditto.
        * bridge/mac/WebCoreFrameBridge.h: Ditto.
        * bridge/mac/WebCoreFrameBridge.mm: Ditto.
        * bridge/mac/WebCoreFrameView.h: Ditto.
        * bridge/mac/WebCoreViewFactory.h: Ditto.
        * bridge/mac/WebCoreViewFactory.m: Ditto.
        * bridge/mac/WebDashboardRegion.h: Ditto.
        * bridge/mac/WebDashboardRegion.m: Ditto.

        * bridge/mac/WebCoreKeyboardAccess.h: Moved to page/mac,
        renamed WebCoreKeyboardUIMode.h, and made a C++ header.

        * page/EventHandler.h: Updated for change to WebCoreKeyboardAccess.
        * page/mac/EventHandlerMac.mm:
        (WebCore::EventHandler::tabsToLinks): Ditto.
        (WebCore::EventHandler::tabsToAllControls): Ditto.
        (WebCore::EventHandler::keyboardUIMode): Ditto.

2006-12-11  Beth Dakin  <bdakin@apple.com>

        Reviewed by Adam.

        Primarily, this patch implements/hooks-up actions for the sub-menu
        items in WebCore context menus. I fixed a few other things along
        the way too:
                -Made BUILDING_ON_TIGER ifdef work within C++ as well as
                 Obj-C
                -Fixed bug where we would throw and Obj-C exception and
                 fail to pop up menus with more than one separator item.
                -Re-named some of the spelling/grammar tags since Tiger and
                 Leopard share more of the actions than initially
                 anticipated.

        * WebCorePrefix.h: Make BUILDING_ON_TIGER available to C++
        * bridge/EditorClient.h: New functions to toggle
        spelling/grammar checking.
        * editing/Editor.cpp:
        (WebCore::Editor::toggleContinuousSpellChecking): Call into client.
        (WebCore::Editor::toggleGrammarChecking): Same.
        (WebCore::Editor::toggleBold): call execToggleBold()
        (WebCore::Editor::toggleUnderline): Create appropriate underline
        style and apply to selection.
        (WebCore::Editor::setBaseWritingDirection): Create appropriate
        writing direction and apply to selection.
        * editing/Editor.h:
        * editing/mac/EditorMac.mm: New functions to show spelling guesses,
        fonts, styles, and color panels.
        * page/ContextMenuClient.h: New functions for the speech sub-menu.
        * page/ContextMenuController.cpp:
        (WebCore::ContextMenuController::contextMenuItemSelected): Fill in
        editing sub-menu actions.
        * platform/ContextMenu.cpp:
        (WebCore::separatorItem): Helper function to create a separator 
        item.
        (WebCore::createFontSubMenu): Put very mac-specific things within a
        platform ifdef.
        (WebCore::createSpellingAndGrammarSubMenu): Re-named some of the
        spelling sub-menu tags.
        (WebCore::createSpellingSubMenu): Same.
        (WebCore::ContextMenu::populate): We can't share the separator
        item. When we do, menus with more than one separator throw and obj-
        c exception and fail to pop-up.
        * platform/ContextMenuItem.h:
        (WebCore::): Re-named some of the spelling sub-menu tags.

2006-12-11  Alice Liu  <alice.liu@apple.com>

        Reviewed by Geoff, Adam.

        Switch to use the Editor for copying URLs.  Also some Pasteboard and PlatformMouseEvent cleanup.

        All layout tests pass as they would without this patch. 

        * WebCore.exp:
        added Editor::copyURL to be called from WebKit
        
        * editing/Editor.cpp:
        (WebCore::Editor::tryDHTMLCopy):
        (WebCore::Editor::tryDHTMLCut):
        Pasteboard::clearTypes() changed to clear()

        (WebCore::Editor::writeSelectionToPasteboard):        
        (WebCore::Editor::cut):
        (WebCore::Editor::copy):
        Changed signature of writeSelection to take raw pointer instead of PassRefPtr

        (WebCore::Editor::copyURL):
        * editing/Editor.h:
        Added copyURL.
        
        * page/ContextMenuClient.h:
        * page/ContextMenuController.cpp:
        (WebCore::ContextMenuController::contextMenuItemSelected):
        Removed copyLinkToClipboard
        
        * platform/KURL.cpp:
        (WebCore::KURL::lastPathComponent):
        * platform/KURL.h:
        Added lastPathComponent. 
        
        * platform/Pasteboard.h:
        Changed some function names.
        Moved some functions out of class to static.
        
        * platform/PlatformMouseEvent.h:
        (WebCore::):
        Removed MouseEventType enum, added NoButton to MouseButton without disturbing other button values.
        
        * platform/mac/PasteboardMac.mm:
        Added writeURL, and moved some things around
        
        * platform/mac/WebCoreSystemInterface.h:
        * platform/mac/WebCoreSystemInterface.mm:
        Add some calls necessary for Pasteboard::writeURL to work

2006-12-11  Darin Adler  <darin@apple.com>

        Reviewed by Brady.

        - http://bugs.webkit.org/show_bug.cgi?id=11794
          fix lifetime problems affecting Frame's ownerElement pointer

        * CMakeLists.txt:
        * WebCore.vcproj/WebCore/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * WebCoreSources.bkl:
        Updated for new source files.

        * WebCore.exp: Updated for changes to entry point names.

        * bridge/mac/FrameMac.h:
        * bridge/mac/FrameMac.mm: (WebCore::FrameMac::FrameMac):
        * bridge/win/FrameWin.h:
        * bridge/win/FrameWin.cpp: (WebCore::FrameWin::FrameWin):
        * platform/qt/FrameQt.h:
        * platform/qt/FrameQt.cpp: (WebCore::FrameQt::FrameQt):
        Updated owner element type to HTMLFrameOwnerElement.

        * bridge/mac/WebCoreFrameBridge.h: Removed non-C++ case since we don't
        use that any more. Updated owner element type to HTMLFrameOwnerElement.

        * dom/Document.cpp: Added include so that the ownerElement function can
        compile (since it downcasts an HTMLFrameOwnerElement to an Element).

        * html/HTMLFrameElement.cpp:
        (WebCore::containingFrameSetElement): Moved this function in here; it
        doesn't need to be a member function.
        (WebCore::HTMLFrameElement::attach): Updated to call this.

        * html/HTMLFrameElementBase.h:
        * html/HTMLFrameElementBase.cpp:
        (WebCore::HTMLFrameElementBase::HTMLFrameElementBase): Inherit from
        HTMLFrameOwnerElement. Removed contentFrame, contentDocument, and
        containingFrameSetElement. Removed friend classes.

        * html/HTMLFrameOwnerElement.h: Added.
        * html/HTMLFrameOwnerElement.cpp: Added.

        * html/HTMLEmbedElement.h:
        * html/HTMLEmbedElement.cpp:
        * html/HTMLObjectElement.h:
        * html/HTMLObjectElement.cpp:
        Remove now-unneeded contentDocument functions.

        * html/HTMLPlugInElement.h:
        * html/HTMLPlugInElement.cpp:
        (WebCore::HTMLPlugInElement::HTMLPlugInElement): Inherit from
        HTMLFrameOwnerElement.

        * loader/FormState.h:
        * loader/FormState.cpp: Use HTMLFormElement instead of just Element.

        * loader/FrameLoader.h:
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::requestFrame): Use HTMLFormElement.
        (WebCore::FrameLoader::loadSubframe): Ditto.
        (WebCore::FrameLoader::requestObject): Don't pass an element parameter
        to shouldUsePlugin, and remove now-unneeded type casts.
        (WebCore::FrameLoader::shouldUsePlugin): Removed unneeded element parameter.
        (WebCore::FrameLoader::handleFallbackContent): Use HTMLFrameOwnerElement.
        (WebCore::FrameLoader::updateBaseURLForEmptyDocument): Ditto.
        (WebCore::FrameLoader::isHostedByObjectElement): Ditto.
        * loader/mac/FrameLoaderMac.mm:
        (WebCore::FrameLoader::load): Use HTMLFormElement.
        (WebCore::FrameLoader::post): Ditto.
        (WebCore::FrameLoader::createFrame): Use HTMLFrameOwnerElement.

        * page/Frame.h:
        * page/FramePrivate.h:
        * page/Frame.cpp:
        (WebCore::parentFromOwnerElement): Use HTMLFrameOwnerElement.
        (WebCore::Frame::Frame): Ditto. Also set m_contentFrame on the owner element.
        (WebCore::Frame::ownerElement): Ditto.
        (WebCore::Frame::ownerRenderer): Ditto.
        (WebCore::Frame::disconnectOwnerElement): Clear m_contentFrame on the owner
        element before disconnecting it.
        (WebCore::FramePrivate::FramePrivate): Use HTMLFrameOwnerElement.

        * page/mac/EventHandlerMac.mm: Include HTMLFrameOwnerElement.h so that
        the code here will compile (no code changes needed).

        * rendering/RenderFrame.cpp: (WebCore::RenderFrame::viewCleared):
        Updated so that RenderFrame doesn't need to be a friend of HTMLFrameElementBase.

        * rendering/RenderPart.h:
        * rendering/RenderPart.cpp: (WebCore::RenderPart::RenderPart):
        Use HTMLFrameOwnerElement.

        * rendering/RenderPartObject.h:
        * rendering/RenderPartObject.cpp:
        (WebCore::RenderPartObject::RenderPartObject): Use HTMLFrameOwnerElement.
        (WebCore::RenderPartObject::viewCleared): Updated so that RenderFrame doesn't
        need to be a friend of HTMLFrameElementBase.

        - other changes

        * platform/network/ResourceHandleInternal.h: Added Noncopyable and
        fixed indentation.

2006-12-11  David Hyatt  <hyatt@apple.com>

        Fix failing layout test.  Remove WTF::Unicode::isSpace and just revert
        the caller to the old behavior.

        Reviewed by darin

        * platform/StringImpl.cpp:
        (WebCore::isSpace):

2006-12-11  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Adam.

        http://bugs.webkit.org/show_bug.cgi?id=11807
        Merge EventHandler::m_bMousePressed and EventHandler::m_mousePressed

        * page/EventHandler.cpp:
        (WebCore::EventHandler::EventHandler):
        (WebCore::EventHandler::handleMousePressEvent):
        (WebCore::EventHandler::handleMouseMoveEvent):
        (WebCore::EventHandler::handleMouseReleaseEvent):
        (WebCore::EventHandler::autoscrollTimerFired):
        * page/EventHandler.h:
        * page/mac/EventHandlerMac.mm:
        (WebCore::EventHandler::handleDrag):
        (WebCore::EventHandler::mouseMoved):
        Merge EventHandler::m_bMousePressed and EventHandler::m_mousePressed

        (WebCore::EventHandler::lastEventIsMouseUp):
        Check that the "new" event is newer than the "old" one - that's not always the case 
        when running in DRT, as [NSApp currentEvent] isn't updated by eventSender.

2006-12-11  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Sam Weinig.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=11801

        Autogenerate POD types for ObjC/JS.

        This removes the need for the hand-written JSSVG*, DOMSVG* wrappers
        in bindings/js, bindings/objc. Makes it much easier to convert more
        SVG types to POD types (ie. SVGMatrix* -> AffineTransform etc.)

        Affected test: svg/custom/SVGPoint-matrixTransform.svg

        It's failing with this patch, as the SVGPoint matrixTransform() function
        got disabled, until the SVGMatrix -> AffineTransform transition patch
        is landed. Otherwhise we'd need to add special cases to both CodeGeneratorJS/ObjC.pm
        which would be a waste of time, as SVGMatrix is about to die.

        Temporarily updating layout test result, as suggested by John Sullivan, so
        no-one notices that SVGPoint-matrixTransform.svg actually fails right now.

        Expect that to be fixed again in the next hour(s).

        * DerivedSources.make:
        * WebCore.xcodeproj/project.pbxproj:
        * bindings/js/JSSVGNumber.cpp: Removed.
        * bindings/js/JSSVGNumber.h: Removed.
        * bindings/js/JSSVGPoint.cpp: Removed.
        * bindings/js/JSSVGPoint.h: Removed.
        * bindings/js/JSSVGRect.cpp: Removed.
        * bindings/js/JSSVGRect.h: Removed.
        * bindings/objc/DOMSVGNumber.mm: Removed.
        * bindings/objc/DOMSVGPoint.mm: Removed.
        * bindings/objc/DOMSVGRect.mm: Removed.
        * bindings/scripts/CodeGeneratorJS.pm:
        * bindings/scripts/CodeGeneratorObjC.pm:
        * ksvg2/svg/SVGNumber.idl:
        * ksvg2/svg/SVGPoint.idl:
        * ksvg2/svg/SVGRect.idl:

2006-12-10  Lars Knoll <lars@trolltech.com>

        Reviewed by Zack

        Fix another issue with frame loading

        * platform/network/qt/ResourceHandleManagerQt.cpp:
        (WebCore::ResourceHandleManager::cancel):
        (WebCore::ResourceHandleManager::receivedData):
        (WebCore::ResourceHandleManager::receivedFinished):
        (WebCore::FileLoader::request):
        * platform/qt/FrameQtClient.cpp:
        (WebCore::FrameQtClient::openURL):

2006-12-10  George Staikos  <staikos@kde.org>

        Reviewed by Zack.

        Make the xpath grammar hack more specific (and work on OS X) until
        it's cleaned up.

        * WebCore.pro:

2006-12-10  Zack Rusin  <zack@kde.org>

        Set the widgetclient correctly. This code
        should be platform independent!

        * platform/qt/WidgetQt.cpp:
        (WebCore::WidgetPrivate::WidgetPrivate):
        (WebCore::Widget::setClient):
        (WebCore::Widget::client):
        (WebCore::Widget::focusPolicy):

2006-12-11  Lars Knoll <lars@trolltech.com>

        Reviewed by Zack

        Fix loading of local files.

        * platform/network/qt/ResourceHandleManagerQt.cpp:
        (WebCore::FileLoader::request):

2006-12-10  Zack Rusin  <zack@kde.org>

       Don't use my QTransform magic, affine QMatrix is fine for
       SVG so use setMatrix.

        * platform/graphics/svg/qt/SVGPaintServerLinearGradientQt.cpp:
        (WebCore::SVGPaintServerLinearGradient::setup):
        * platform/graphics/svg/qt/SVGPaintServerRadialGradientQt.cpp:
        (WebCore::setup):

2006-12-10  Lars Knoll <lars@trolltech.com>

        Reviewed by Zack

        Make sure we call checkCompleted() on the FrameLoader
        to get the regression tests running.

        * WebCore.pro:
        * loader/qt/FrameLoaderQt.cpp:
        (WebCore::FrameLoader::checkLoadCompleteForThisFrame):
        (WebCore::FrameLoader::saveDocumentState):
        * page/qt/EventHandlerQt.cpp:
        (WebCore::EventHandler::handleDrag):
        * platform/qt/FrameQtClient.cpp:
        (WebCore::FrameQtClient::openURL):
        (WebCore::FrameQtClient::didReceiveResponse):
        (WebCore::FrameQtClient::didFinishLoading):
        (WebCore::FrameQtClient::didFail):
        * platform/qt/FrameQtClient.h:

2006-12-10  Zack Rusin  <zack@kde.org>

        Enable the SVG build by default and make it build.

        * WebCore.pro:
        * loader/qt/FrameLoaderQt.cpp: Output the method name

2006-12-10  Zack Rusin  <zack@kde.org>

        Move the client classes to WebKitQt/WebCoreSupport.

        * WebCore.pro:
        * loader/qt/FrameLoaderClientQt.cpp: Removed.
        * loader/qt/FrameLoaderClientQt.h: Removed.
        * platform/qt/ChromeClientQt.cpp: Removed.
        * platform/qt/ChromeClientQt.h: Removed.
        * platform/qt/ContextMenuClientQt.cpp: Removed.
        * platform/qt/ContextMenuClientQt.h: Removed.
        * platform/qt/EditorClientQt.cpp: Removed.
        * platform/qt/EditorClientQt.h: Removed.

2006-12-10  Lars Knoll <lars@trolltech.com>

        Reviewed by Zack.

        Add some stubs required to link.

        * platform/qt/FrameQt.cpp:
        (WebCore::FrameQt::runJavaScriptAlert):
        (WebCore::FrameQt::runJavaScriptConfirm):
        (WebCore::FrameQt::runJavaScriptPrompt):
        (WebCore::FrameQt::bindingRootObject):

2006-12-10  Rob Buis  <buis@kde.org>

        Reviewed by Darin.

        http://bugs.webkit.org/show_bug.cgi?id=10996
        WebKit needs (possibly private) XML/SVG innerText support (for DumpRenderTree)

        Create an internal method to create innerText functionality for non-HTML
        nodes. When called from DRT this omits CDATA nodes.

        * dom/Element.cpp:
        (WebCore::Element::innerText):
        (WebCore::Element::outerText):
        * dom/Element.h:
        * dom/Element.idl:
        * html/HTMLElement.cpp:
        * html/HTMLElement.h:

2006-12-10  MorganL  <morganl.webkit@yahoo.com>

        Reviewed by Maciej.

        Fixes http://bugs.webkit.org/show_bug.cgi?id=11790
        No way to initialize ResourceResponse::m_httpHeaderFields

        * platform/network/ResourceResponse.cpp: impl setHTTPHeaderField
        (WebCore::ResourceResponse::setHTTPHeaderField):
        * platform/network/ResourceResponse.h: decl setHTTPHeaderField

2006-12-10  Zack Rusin  <zack@kde.org>

        Cleaning up the code after removals.

        * platform/qt/FrameQt.cpp:
        * platform/qt/FrameQt.h: Remove virtual methods
        which have been moved to different objects

2006-12-10  Zack Rusin  <zack@kde.org>

        Cleanup the FrameQtClient a little bit more. Remove
        unused methods.

        * platform/qt/FrameQtClient.cpp:
        * platform/qt/FrameQtClient.h:

2006-12-09  Adam Roben  <aroben@apple.com>

        Build fix.

        * xml/XPathParser.cpp:
        (WebCore::XPath::charCat): Use C++ unsigned instead of uint.

2006-12-09  George Staikos  <staikos@kde.org>

        Reviewed by Zack.

        Make it not crash, and make it set the title on Qt platform.

        * loader/qt/FrameLoaderClientQt.cpp:
        (WebCore::FrameLoaderClientQt::hasWebView):
        (WebCore::FrameLoaderClientQt::hasFrameView):
        (WebCore::FrameLoaderClientQt::didChangeTitle):
        * loader/qt/FrameLoaderQt.cpp:
        (WebCore::FrameLoader::setTitle):
        (WebCore::FrameLoader::checkLoadCompleteForThisFrame):

2006-12-10  Zack Rusin  <zack@kde.org>

        Renaming FrameQtClientDefault to FrameQtClient.
        Removing FrameQtClient. Adding FrameLoaderClient
        as an argument. Clenaing up the code a bit.

        * platform/qt/FrameQt.cpp:
        (WebCore::FrameQt::FrameQt):
        * platform/qt/FrameQt.h:
        * platform/qt/FrameQtClient.cpp:
        (WebCore::FrameQtClient::FrameQtClient):
        (WebCore::FrameQtClient::~FrameQtClient):
        (WebCore::FrameQtClient::setFrame):
        (WebCore::FrameQtClient::openURL):
        (WebCore::FrameQtClient::submitForm):
        (WebCore::FrameQtClient::checkLoaded):
        (WebCore::FrameQtClient::runJavaScriptAlert):
        (WebCore::FrameQtClient::runJavaScriptConfirm):
        (WebCore::FrameQtClient::runJavaScriptPrompt):
        (WebCore::FrameQtClient::menubarVisible):
        (WebCore::FrameQtClient::toolbarVisible):
        (WebCore::FrameQtClient::statusbarVisible):
        (WebCore::FrameQtClient::personalbarVisible):
        (WebCore::FrameQtClient::locationbarVisible):
        (WebCore::FrameQtClient::loadFinished):
        (WebCore::FrameQtClient::didReceiveResponse):
        (WebCore::FrameQtClient::didFinishLoading):
        (WebCore::FrameQtClient::didFail):
        (WebCore::FrameQtClient::didReceiveData):
        (WebCore::FrameQtClient::traverseNextFrameStayWithin):
        (WebCore::FrameQtClient::numPendingOrLoadingRequests):
        (WebCore::FrameQtClient::receivedAllData):
        (WebCore::FrameQtClient::setTitle):
        * platform/qt/FrameQtClient.h:

2006-12-10  Zack Rusin  <zack@kde.org>

        Fixes compilation after the last removals.

        * WebCore.pro:

2006-12-10  Lars Knoll <lars@trolltech.com>

        Reviewed by Zack.

        Implement a decent network loader using QHttp.

        * loader/qt/FrameLoaderQt.cpp:
        (WebCore::FrameLoader::load):
        * platform/network/ResourceHandle.cpp:
        (WebCore::ResourceHandle::request):
        * platform/network/ResourceHandle.h:
        * platform/network/ResourceHandleInternal.h:
        * platform/network/qt/ResourceHandleManager.cpp: Removed.
        * platform/network/qt/ResourceHandleManager.h: Removed.
        * platform/network/qt/ResourceHandleManagerKDE.cpp: Added.
        (WebCore::ResourceHandleManager::self):
        (WebCore::ResourceHandleManager::ResourceHandleManager):
        (WebCore::ResourceHandleManager::~ResourceHandleManager):
        (WebCore::ResourceHandleManager::slotData):
        (WebCore::ResourceHandleManager::slotMimetype):
        (WebCore::ResourceHandleManager::slotResult):
        (WebCore::ResourceHandleManager::remove):
        (WebCore::ResourceHandleManager::add):
        (WebCore::ResourceHandleManager::cancel):
        * platform/network/qt/ResourceHandleManagerKDE.h: Added.
        * platform/network/qt/ResourceHandleManagerQt.cpp: Added.
        (WebCore::ResourceHandleManager::ResourceHandleManager):
        (WebCore::ResourceHandleManager::~ResourceHandleManager):
        (WebCore::ResourceHandleManager::self):
        (WebCore::RequestQt::RequestQt):
        (WebCore::ResourceHandleManager::add):
        (WebCore::ResourceHandleManager::cancel):
        (WebCore::ResourceHandleManager::receivedResponse):
        (WebCore::ResourceHandleManager::receivedData):
        (WebCore::ResourceHandleManager::receivedFinished):
        (WebCore::LoaderThread::LoaderThread):
        (WebCore::LoaderThread::run):
        (WebCore::FileLoader::FileLoader):
        (WebCore::FileLoader::request):
        (WebCore::FileLoader::cancel):
        (WebCore::WebCoreHttp::WebCoreHttp):
        (WebCore::WebCoreHttp::~WebCoreHttp):
        (WebCore::WebCoreHttp::request):
        (WebCore::WebCoreHttp::scheduleNextRequest):
        (WebCore::WebCoreHttp::getConnection):
        (WebCore::WebCoreHttp::onResponseHeaderReceived):
        (WebCore::WebCoreHttp::onReadyRead):
        (WebCore::WebCoreHttp::onRequestFinished):
        (WebCore::WebCoreHttp::onStateChanged):
        (WebCore::WebCoreHttp::cancel):
        (WebCore::qHash):
        (WebCore::operator==):
        (WebCore::HostInfo::HostInfo):
        (WebCore::NetworkLoader::NetworkLoader):
        (WebCore::NetworkLoader::~NetworkLoader):
        (WebCore::NetworkLoader::request):
        (WebCore::NetworkLoader::connectionClosed):
        (WebCore::NetworkLoader::cancel):
        * platform/network/qt/ResourceHandleManagerQt.h: Added.
        (WebCore::LoaderThread::):
        (WebCore::LoaderThread::waitForSetup):
        * platform/network/qt/ResourceHandleQt.cpp:
        (WebCore::ResourceHandle::start):
        * platform/qt/FrameQt.cpp:
        (WebCore::FrameQt::FrameQt):
        (WebCore::FrameQt::keyEvent):
        * platform/qt/FrameQt.h:
        * platform/qt/FrameQtClient.cpp:
        (WebCore::FrameQtClientDefault::FrameQtClientDefault):
        (WebCore::FrameQtClientDefault::openURL):
        (WebCore::FrameQtClientDefault::submitForm):
        (WebCore::FrameQtClientDefault::didReceiveResponse):
        (WebCore::FrameQtClientDefault::didFinishLoading):
        (WebCore::FrameQtClientDefault::didFail):
        (WebCore::FrameQtClientDefault::didReceiveData):
        (WebCore::FrameQtClientDefault::receivedAllData):
        (WebCore::FrameQtClientDefault::setTitle):
        * platform/qt/FrameQtClient.h:

2006-12-09  George Staikos  <staikos@kde.org>

        Reviewed by Zack.

        Fix bison again on qmake build.

        * WebCore.pro:

2006-12-09  Zack Rusin  <zack@kde.org>

        Reviewed by Zack.

        Use the correct filename.

        * WebCore.pro: it's PasteboardQt.cpp

2006-12-09  Zack Rusin  <zack@kde.org>

        Reviewed by Lars.

        Correctly set the font on widgets.

        * platform/qt/WidgetQt.cpp:
        (WebCore::Widget::setFont):

2006-12-09  Adam Treat  <treat@kde.org>

        Reviewed by Zack

        No more nil renderer warnings

        * platform/qt/ScrollViewCanvasQt.cpp:
        (WebCore::ScrollViewCanvasQt::paintEvent):

2006-12-09  Friedemann Kleint  <fkleint@trolltech.com>

        Reviewed by Zack

        Removed compiler warnings about rounding issues

        * platform/qt/FontPlatformDataQt.cpp:
        (WebCore::FontPlatformData::FontPlatformData):
        * platform/qt/FontQt.cpp:
        (WebCore::Font::drawComplexText):

2006-12-09  George Staikos  <staikos@kde.org>

        Reviewed by Zack.

        Qt 4.1 (especially Qtopia) build fixes

        * platform/qt/FrameQtClient.cpp:
        * platform/qt/GraphicsContextQt.cpp:
        * platform/qt/PlatformKeyboardEventQt.cpp:
        * platform/qt/CursorQt.cpp:
        * platform/qt/WidgetQt.cpp:
        * platform/Cursor.h:
        * platform/Arena.h:

2006-12-09  Lars Knoll <lars@trolltech.com>

        Reviewed by Zack

        Make it possible to build WebKit with qmake.

        * WebCore.pro: Added.
        * platform/graphics/qt/GraphicsContextQt.cpp:

2006-12-10  Lars Knoll <lars@trolltech.com>

        Reviewed by Zack.

        Compile after latest WebKit changes and don't depend
        on deprecated methods in Qt.

        * platform/network/qt/ResourceHandleManager.cpp:
        (WebCore::ResourceHandleManager::remove):
        (WebCore::ResourceHandleManager::deliverJobData):
        * platform/network/qt/ResourceHandleQt.cpp:
        (WebCore::ResourceHandle::extractCharsetFromHeaders):
        * platform/qt/PlatformKeyboardEventQt.cpp:
        (WebCore::windowsKeyCodeForKeyEvent):

2006-12-10  Lars Knoll <lars@trolltech.com>

        Reviewed by Zack.

        Use the Qt image loading framework.

        * CMakeLists.txt:
        * platform/graphics/ImageSource.h:
        * platform/graphics/qt/GraphicsContextQt.cpp:
        * platform/graphics/qt/ImageDecoderQt.cpp: Added.
        (WebCore::ImageDecoderQt::ImageData::ImageData):
        (WebCore::ImageDecoderQt::ReadContext::):
        (WebCore::ImageDecoderQt::ReadContext::ReadContext):
        (WebCore::ImageDecoderQt::ReadContext::read):
        (WebCore::ImageDecoderQt::ReadContext::readImageLines):
        (WebCore::ImageDecoderQt::ImageDecoderQt):
        (WebCore::ImageDecoderQt::~ImageDecoderQt):
        (WebCore::ImageDecoderQt::hasFirstImageHeader):
        (WebCore::ImageDecoderQt::reset):
        (WebCore::ImageDecoderQt::setData):
        (WebCore::ImageDecoderQt::isSizeAvailable):
        (WebCore::ImageDecoderQt::frameCount):
        (WebCore::ImageDecoderQt::repetitionCount):
        (WebCore::ImageDecoderQt::ImageDecoderQt::supportsAlpha):
        (WebCore::ImageDecoderQt::duration):
        (WebCore::ImageDecoderQt::frameBufferAtIndex):
        (WebCore::ImageDecoderQt::imageAtIndex):
        * platform/graphics/qt/ImageDecoderQt.h: Added.
        (WebCore::ImageDecoderQt::):
        * platform/graphics/qt/ImageSourceQt.cpp:
        (WebCore::):
        (WebCore::detectImageFormat):
        (WebCore::createDecoder):
        (WebCore::ImageSource::setData):
        (WebCore::ImageSource::createFrameAtIndex):
        (WebCore::ImageSource::frameDurationAtIndex):
        (WebCore::ImageSource::frameHasAlphaAtIndex):

2006-12-09  Lars Knoll  <lars@trolltech.com>

        Reviewed by Maciej.

        Remove an explicit ICU dependency.

        * xml/XPathParser.cpp:
        (WebCore::XPath::charCat):

2006-12-09  Zack Rusin  <zack@kde.org>

        Adjusting the build after the icu changes.

        * CMakeLists.txt:

2006-12-09  Adam Roben  <aroben@apple.com>

        Reviewed by Darin.

        Changed all ForwardingHeaders to use #include instead of #import.

        * ForwardingHeaders/kjs/JSLock.h:
        * ForwardingHeaders/kjs/SavedBuiltins.h:
        * ForwardingHeaders/kjs/collector.h:
        * ForwardingHeaders/kjs/dtoa.h:
        * ForwardingHeaders/kjs/internal.h:
        * ForwardingHeaders/kjs/interpreter.h:
        * ForwardingHeaders/kjs/lookup.h:
        * ForwardingHeaders/kjs/object.h:
        * ForwardingHeaders/kjs/property_map.h:
        * ForwardingHeaders/kjs/protect.h:
        * ForwardingHeaders/wtf/AlwaysInline.h:
        * ForwardingHeaders/wtf/Assertions.h:
        * ForwardingHeaders/wtf/FastMalloc.h:
        * ForwardingHeaders/wtf/GetPtr.h:
        * ForwardingHeaders/wtf/HashCountedSet.h:
        * ForwardingHeaders/wtf/HashMap.h:
        * ForwardingHeaders/wtf/HashSet.h:
        * ForwardingHeaders/wtf/HashTraits.h:
        * ForwardingHeaders/wtf/MathExtras.h:
        * ForwardingHeaders/wtf/Noncopyable.h:
        * ForwardingHeaders/wtf/OwnArrayPtr.h:
        * ForwardingHeaders/wtf/OwnPtr.h:
        * ForwardingHeaders/wtf/PassRefPtr.h:
        * ForwardingHeaders/wtf/Platform.h:
        * ForwardingHeaders/wtf/RefPtr.h:
        * ForwardingHeaders/wtf/Vector.h:

2006-12-09  Rob Buis  <buis@kde.org>

        Reviewed by Darin.

        http://bugs.webkit.org/show_bug.cgi?id=11625
        Investigate possibility to share code between HTMLStyleElement and SVGStyleElement

        Add a class shared by both HTMLStyleElement and SVGStyleElement that
        encapsulates the common logic.

        * CMakeLists.txt:
        * WebCore.xcodeproj/project.pbxproj:
        * dom/Document.cpp:
        (WebCore::Document::recalcStyleSelector):
        Generalize stylesheet processing of svg and html.

        * dom/StyleElement.cpp: Added.
        (WebCore::StyleElement::StyleElement):
        (WebCore::StyleElement::sheet):
        (WebCore::StyleElement::insertedIntoDocument):
        (WebCore::StyleElement::removedFromDocument):
        (WebCore::StyleElement::childrenChanged):
        * dom/StyleElement.h: Added.
        (WebCore::StyleElement::~StyleElement):
        (WebCore::StyleElement::isLoading):
        Common base class for SVGStyleElement and HTMLStyleElement.

        * html/HTMLStyleElement.cpp:
        (WebCore::HTMLStyleElement::HTMLStyleElement):
        (WebCore::HTMLStyleElement::parseMappedAttribute):
        (WebCore::HTMLStyleElement::insertedIntoDocument):
        (WebCore::HTMLStyleElement::removedFromDocument):
        (WebCore::HTMLStyleElement::childrenChanged):
        (WebCore::HTMLStyleElement::media):
        (WebCore::HTMLStyleElement::setMedia):
        (WebCore::HTMLStyleElement::type):
        (WebCore::HTMLStyleElement::setType):
        * html/HTMLStyleElement.h:
        Use new common class.

        * ksvg2/svg/SVGElement.cpp:
        * ksvg2/svg/SVGElement.h:
        * ksvg2/svg/SVGSVGElement.cpp:
        (WebCore::SVGSVGElement::contentScriptType):
        (WebCore::SVGSVGElement::contentStyleType):
        * ksvg2/svg/SVGSVGElement.h:
        Do not use tryGetAttribute(NS) anymore.

        * ksvg2/svg/SVGStyleElement.cpp:
        (WebCore::SVGStyleElement::SVGStyleElement):
        (WebCore::SVGStyleElement::xmlspace):
        (WebCore::SVGStyleElement::type):
        (WebCore::SVGStyleElement::media):
        (WebCore::SVGStyleElement::title):
        (WebCore::SVGStyleElement::insertedIntoDocument):
        (WebCore::SVGStyleElement::removedFromDocument):
        (WebCore::SVGStyleElement::childrenChanged):
        * ksvg2/svg/SVGStyleElement.h:
        Use new common class.

2006-12-08  David Hyatt  <hyatt@apple.com>

        Land the new ICU abstraction layer (WTF::Unicode).  Patch
        by Lars with a couple of fixes thrown in by me.

        Reviewed by hyatt

        * ForwardingHeaders/wtf/icu/UnicodeIcu.h: Added.
        * ForwardingHeaders/wtf/unicode/Unicode.h: Added.
        * WebCore.xcodeproj/project.pbxproj:
        * css/cssparser.cpp:
        (WebCore::ParseString::lower):
        * dom/Document.cpp:
        (WebCore::isValidNameStart):
        (WebCore::isValidNamePart):
        * editing/TextIterator.cpp:
        (WebCore::CircularSearchBuffer::append):
        * html/HTMLFontElement.cpp:
        (WebCore::parseFontSizeNumber):
        * html/HTMLInputElement.cpp:
        (WebCore::numGraphemeClusters):
        (WebCore::numCharactersInGraphemeClusters):
        * html/HTMLSelectElement.cpp:
        (WebCore::stripLeadingWhiteSpace):
        * page/Frame.h:
        * platform/DeprecatedString.h:
        (WebCore::DeprecatedChar::isSpace):
        (WebCore::DeprecatedChar::lower):
        (WebCore::DeprecatedChar::upper):
        * platform/Font.cpp:
        (WebCore::WidthIterator::advance):
        (WebCore::WidthIterator::normalizeVoicingMarks):
        * platform/FontCache.h:
        * platform/FontData.h:
        * platform/GlyphMap.cpp:
        * platform/GlyphMap.h:
        * platform/GlyphWidthMap.h:
        * platform/KURL.cpp:
        (WebCore::encodeHostname):
        * platform/StringHash.h:
        (WTF::):
        * platform/StringImpl.cpp:
        (WebCore::isSpace):
        (WebCore::parseLength):
        (WebCore::StringImpl::isLower):
        (WebCore::StringImpl::lower):
        (WebCore::StringImpl::upper):
        (WebCore::StringImpl::secure):
        (WebCore::StringImpl::foldCase):
        (WebCore::StringImpl::capitalize):
        (WebCore::StringImpl::toInt):
        (WebCore::equalIgnoringCase):
        (WebCore::StringImpl::find):
        * platform/StringImpl.h:
        * platform/TextBoundaries.h:
        * platform/TextBreakIterator.h: Added.
        (WebCore::):
        * platform/TextBreakIteratorICU.cpp: Added.
        (WebCore::wordBreakIterator):
        (WebCore::characterBreakIterator):
        (WebCore::textBreakFirst):
        (WebCore::textBreakNext):
        (WebCore::textBreakPreceding):
        (WebCore::textBreakFollowing):
        (WebCore::textBreakCurrent):
        * platform/TextCodec.h:
        * platform/TextCodecLatin1.cpp:
        * platform/TextEncoding.cpp:
        (WebCore::TextEncoding::encode):
        * platform/TextEncoding.h:
        * platform/TextEncodingRegistry.cpp:
        (WebCore::buildTextEncodingNameMap):
        (WebCore::buildTextCodecMap):
        * platform/TextEncodingRegistry.h:
        * platform/UChar.h: Removed.
        * platform/graphics/GraphicsContext.h:
        * platform/qt/GlyphMapQt.cpp:
        * platform/qt/TextBreakIteratorQt.cpp: Added.
        (WebCore::TextBreakIterator::following):
        (WebCore::TextBreakIterator::preceding):
        (WebCore::WordBreakIteratorQt::first):
        (WebCore::WordBreakIteratorQt::next):
        (WebCore::WordBreakIteratorQt::previous):
        (WebCore::CharBreakIteratorQt::first):
        (WebCore::CharBreakIteratorQt::next):
        (WebCore::CharBreakIteratorQt::previous):
        (WebCore::wordBreakIterator):
        (WebCore::characterBreakIterator):
        (WebCore::textBreakFirst):
        (WebCore::textBreakNext):
        (WebCore::textBreakPreceding):
        (WebCore::textBreakFollowing):
        (WebCore::textBreakCurrent):
        * platform/qt/TextCodecQt.cpp: Added.
        (WebCore::getAtomicName):
        (WebCore::TextCodecQt::registerEncodingNames):
        (WebCore::newTextCodecQt):
        (WebCore::TextCodecQt::registerCodecs):
        (WebCore::TextCodecQt::TextCodecQt):
        (WebCore::TextCodecQt::~TextCodecQt):
        (WebCore::TextCodecQt::decode):
        (WebCore::TextCodecQt::encode):
        * platform/qt/TextCodecQt.h: Added.
        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::updateFirstLetter):
        * rendering/RenderText.cpp:
        (WebCore::RenderText::previousOffset):
        (WebCore::RenderText::nextOffset):
        (WebCore::RenderText::widthFromCache):
        * rendering/RenderText.h:
        * rendering/bidi.cpp:
        (WebCore::BidiState::BidiState):
        (WebCore::BidiContext::BidiContext):
        (WebCore::bidiNext):
        (WebCore::bidiFirst):
        (WebCore::BidiIterator::direction):
        (WebCore::appendRun):
        (WebCore::embed):
        (WebCore::RenderBlock::computeHorizontalPositionsForLine):
        (WebCore::RenderBlock::bidiReorderLine):
        (WebCore::RenderBlock::layoutInlineChildren):
        * rendering/bidi.h:
        (WebCore::BidiStatus::BidiStatus):
        (WebCore::BidiContext::dir):
        (WebCore::BidiContext::basicDir):
        (WebCore::BidiRun::BidiRun):
        * rendering/break_lines.h:

2006-12-08  Adam Roben  <aroben@apple.com>

        Rolling out r17865 because it caused a performance regression.

        * loader/TextResourceDecoder.cpp:
        (WebCore::findXMLEncoding):
        * platform/CString.cpp:
        (WebCore::CString::data):
        * platform/CString.h:
        * platform/TextStream.cpp:
        (WebCore::TextStream::operator<<):
        * platform/TextStream.h:

2006-12-08  Zack Rusin  <zack@kde.org>

        Reviewed by Maciej.

        Fix the Qt/KDE build after all the API changes.

        * CMakeLists.txt:
        * editing/qt/EditorQt.cpp: Added.
        (WebCore::Editor::newGeneralClipboard):
        (WebCore::Editor::ignoreSpelling):
        (WebCore::Editor::learnSpelling):
        (WebCore::Editor::advanceToNextMisspelling):
        (WebCore::Editor::isSelectionMisspelled):
        (WebCore::Editor::isSelectionUngrammatical):
        (WebCore::Editor::guessesForUngrammaticalSelection):
        (WebCore::Editor::guessesForMisspelledSelection):
        (WebCore::Editor::markMisspellingsInAdjacentWords):
        (WebCore::Editor::markMisspellings):
        * loader/NavigationAction.h:
        * loader/qt/FrameLoaderClientQt.cpp:
        (WebCore::FrameLoaderClientQt::frameLoaderDestroyed):
        (WebCore::FrameLoaderClientQt::canHandleRequest):
        * loader/qt/FrameLoaderClientQt.h:
        * loader/qt/FrameLoaderQt.cpp:
        (WebCore::FrameLoader::checkLoadCompleteForThisFrame):
        (WebCore::FrameLoader::load):
        * loader/qt/ResourceLoaderQt.cpp:
        * platform/ContextMenu.h:
        * platform/graphics/qt/GraphicsContextQt.cpp:
        * platform/graphics/qt/PathQt.cpp:
        (WebCore::Path::addArc):
        * platform/graphics/svg/qt/SVGPaintServerLinearGradientQt.cpp:
        (WebCore::SVGPaintServerLinearGradient::setup):
        * platform/graphics/svg/qt/SVGPaintServerRadialGradientQt.cpp:
        (WebCore::setup):
        * platform/network/ResourceHandle.h:
        (WebCore::ResourceHandle::getInternal):
        * platform/network/ResourceHandleInternal.h:
        * platform/network/qt/ResourceHandleManager.cpp:
        (WebCore::ResourceHandleManager::slotData):
        (WebCore::ResourceHandleManager::remove):
        * platform/network/qt/ResourceHandleQt.cpp:
        (WebCore::ResourceHandle::~ResourceHandle):
        (WebCore::ResourceHandle::start):
        * platform/qt/ChromeClientQt.cpp:
        (WebCore::ChromeClientQt::addMessageToConsole):
        (WebCore::ChromeClientQt::chromeDestroyed):
        * platform/qt/ChromeClientQt.h:
        * platform/qt/ContextMenuClientQt.cpp:
        (WebCore::ContextMenuClientQt::copyLinkToClipboard):
        (WebCore::ContextMenuClientQt::downloadURL):
        (WebCore::ContextMenuClientQt::copyImageToClipboard):
        (WebCore::ContextMenuClientQt::contextMenuDestroyed):
        (WebCore::ContextMenuClientQt::contextMenuItemSelected):
        * platform/qt/ContextMenuClientQt.h:
        * platform/qt/ContextMenuItemQt.cpp: Added.
        (WebCore::ContextMenuItem::ContextMenuItem):
        (WebCore::ContextMenuItem::~ContextMenuItem):
        (WebCore::ContextMenuItem::platformDescription):
        (WebCore::ContextMenuItem::action):
        (WebCore::ContextMenuItem::title):
        (WebCore::ContextMenuItem::setAction):
        (WebCore::ContextMenuItem::setTitle):
        (WebCore::ContextMenuItem::setSubMenu):
        * platform/qt/ContextMenuQt.cpp:
        (WebCore::ContextMenu::ContextMenu):
        (WebCore::ContextMenu::~ContextMenu):
        (WebCore::ContextMenu::appendItem):
        (WebCore::ContextMenu::itemCount):
        (WebCore::ContextMenu::insertItem):
        (WebCore::ContextMenu::setPlatformDescription):
        * platform/qt/CursorQt.cpp:
        (WebCore::copyCursor):
        * platform/qt/EditorClientQt.cpp:
        (WebCore::EditorClientQt::shouldInsertNode):
        (WebCore::WebCore::EditorClientQt::pageDestroyed):
        (WebCore::EditorClientQt::smartInsertDeleteEnabled):
        * platform/qt/EditorClientQt.h:
        * platform/qt/FrameQt.cpp:
        (WebCore::FrameQt::FrameQt):
        (WebCore::FrameQt::keyEvent):
        * platform/qt/FrameQt.h:
        * platform/qt/FrameQtClient.cpp:
        (WebCore::FrameQtClientDefault::openURL):
        (WebCore::FrameQtClientDefault::submitForm):
        * platform/qt/LoaderFunctionsQt.cpp:
        * platform/qt/PasteboardQt.cpp: Added.
        (WebCore::Pasteboard::Pasteboard):
        (WebCore::Pasteboard::generalPasteboard):
        (WebCore::Pasteboard::clearTypes):
        (WebCore::Pasteboard::writeSelection):
        (WebCore::Pasteboard::canSmartReplace):
        (WebCore::Pasteboard::plainText):
        (WebCore::Pasteboard::documentFragment):

=== Safari-521.32 ===

2006-12-08  Rob Buis  <buis@kde.org>

        Reviewed by Maciej.

        http://bugs.webkit.org/show_bug.cgi?id=10188
        Form elements added via appendChild() are not accessible via form.element

        Make sure looking up form elements works when the form is not appended
        to the document.

        * html/HTMLFormElement.cpp:
        (WebCore::HTMLFormElement::registerFormElement):

2006-12-08  Rob Buis  <buis@kde.org>

        Reviewed by Adele.

        http://bugs.webkit.org/show_bug.cgi?id=11765
        REGRESSION: Clicking on a select with size other than 1 and no children results in a crash

        Make sure returned value is -1 for selects without children.

        * rendering/RenderListBox.cpp:
        (WebCore::RenderListBox::listIndexAtOffset):

2006-12-08  Adam Roben  <aroben@apple.com>

        Reviewed by Anders.

        This is a mo' better fix for ensuring we don't use macro definitions
        of min/max.

        * config.h:

2006-12-08  Don Gibson  <dgibson77@gmail.com>

        Reviewed and landed by Alexey.

        http://bugs.webkit.org/show_bug.cgi?id=11759:
        Windows build bustage

        * WebCore.vcproj/WebCore/WebCore.vcproj:
        * bridge/win/ContextMenuClientWin.h:
        * bridge/win/FrameWin.h:
        * loader/win/FrameLoaderWin.cpp:
        (WebCore::FrameLoader::submitForm):
        * platform/network/win/ResourceHandleWin.cpp:
        (WebCore::ResourceHandle::onRequestComplete):
        (WebCore::ResourceHandle::fileLoadTimer):
        (WebCore::ResourceHandle::cancel):
        * platform/win/MouseEventWin.cpp:
        (WebCore::PlatformMouseEvent::PlatformMouseEvent):
        * platform/win/TemporaryLinkStubs.cpp:
        (WebCore::fileButtonChooseFileLabel):
        (WebCore::inputElementAltText):
        (WebCore::copyCursor):
        (WebCore::resetButtonDefaultLabel):
        (WebCore::ContextMenuClientWin::contextMenuItemSelected):
        (WebCore::ContextMenuClientWin::copyLinkToClipboard):
        (WebCore::ContextMenuClientWin::downloadURL):
        (WebCore::ContextMenuClientWin::copyImageToClipboard):
        (WebCore::Editor::ignoreSpelling):
        (WebCore::Editor::learnSpelling):
        (WebCore::Editor::isSelectionUngrammatical):
        (WebCore::Editor::isSelectionMisspelled):
        (WebCore::Editor::guessesForMisspelledSelection):
        (WebCore::Editor::guessesForUngrammaticalSelection):
        (WebCore::Editor::markMisspellingsInAdjacentWords):
        (WebCore::FrameLoader::load):
        (WebCore::FrameWin::scheduleClose):
        (WebCore::FrameWin::respondToChangedSelection):

2006-12-08  Sam Weinig  <sam@webkit.org>

        Reviewed by Geoff.

        Fix for http://bugs.webkit.org/show_bug.cgi?id=11777
        Crash when using XMLSerializer.serializeToString() on
        documentless, DocumentType nodes.

        Test: fast/dom/XMLSerializer-doctype.html
        Test: fast/dom/XMLSerializer-doctype2.html

        * dom/DOMImplementation.cpp:
        (WebCore::DOMImplementation::createDocument): set the document of the 
        DocumentType node to the new document.
        * xml/XMLSerializer.cpp: Cleanup.
        (WebCore::XMLSerializer::serializeToString): now throws an exception
        for documentless nodes. 
        * xml/XMLSerializer.h: cleanup
        * xml/XMLSerializer.idl: add exception

2006-12-07  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by john

        <rdar://problem/4836287>
        Cannot expand selection out of editable element when containing element is non-editable.

        * editing/Selection.cpp:
        (WebCore::Selection::adjustForEditableContent): Restrict the selection endpoints
        to the same *highest* editable root.  This bug only happened when creating selections
        based in an editable region and extending into a higher editable root, so this change 
        doesn't expose any new kinds of deletions, but we should start thinking about how
        those deletions should behave.
        * editing/SelectionController.cpp:
        (WebCore::SelectionController::selectAll): Ditto.

2006-12-08  Beth Dakin  <bdakin@apple.com>

        Reviewed by Maciej.

        Add a new member variable to ContextMenuItem to hold on to the sub-
        menu. The new member variable is an OwnPtr<ContextMenu>

        * platform/ContextMenu.cpp: Because of the OwnPtr in
        ContextMenuItem, we have to separate the declaration of
        ContextMenuItems away from the calls to appendItem(). Not doing so
        causes a build failure because OwnPtr inherits from Noncopyable.
        (WebCore::createFontSubMenu): Same.
        (WebCore::createSpellingAndGrammarSubMenu): Same.
        (WebCore::createSpellingSubMenu): Same.
        (WebCore::createSpeechSubMenu): Same.
        (WebCore::createWritingDirectionSubMenu): Same.
        (WebCore::ContextMenu::populate): Same.
        * platform/ContextMenuItem.h:  New member variable m_subMenu.
        * platform/mac/ContextMenuItemMac.mm: Take care of setting
        m_subMenu in addition to setting the submenu of the NSMenuItem when
        we have a sub-menu.
        (WebCore::menuToArray):
        (WebCore::ContextMenuItem::ContextMenuItem): Same.
        (WebCore::ContextMenuItem::platformSubMenu): Same.
        (WebCore::ContextMenuItem::setSubMenu): Same.

2006-12-08  MorganL  <morganl.webkit@yahoo.com>

        Reviewed by Darin.

        http://bugs.webkit.org/show_bug.cgi?id=11778
        CString::data() should be documented as returning a null terminated char array

        * platform/CString.h:
        Add some basic documentation to CString.h

2006-12-08  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Geoff.

        http://bugs.webkit.org/show_bug.cgi?id=11718
        REGRESSION: When I mouse up after dragging a selection outside of a iframe, the iframe
        continues to scroll automatically.

        Test: manual-tests/autoscroll.html

        * manual-tests/autoscroll.html: Added.

        * page/EventHandler.cpp:
        (WebCore::EventHandler::handleMousePressEvent):
        Assign to m_mousePressNode earlier, so that it is available in the superframe as well.
        Reset m_mouseDownWasInSubframe to false when starting to handle a mousedown - previously, its value
        was only defined if the event was passed down to a widget or a subframe.

        (WebCore::EventHandler::stopAutoscrollTimer):
        If the mouse down event was in a subframe, stop the subframe's timer.

2006-12-08  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Geoff.

        http://bugs.webkit.org/show_bug.cgi?id=6275
        XMLHttpRequest.getResponseHeader should return a null string for non-existent headers

        * bindings/js/JSXMLHttpRequest.cpp:
        (KJS::JSXMLHttpRequestProtoFunc::callAsFunction):
        Convert null getResponseHeader strings to JS null, rather than undefined.

2006-12-08  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin.

        http://bugs.webkit.org/show_bug.cgi?id=9854
        HTTP Refresh header with quotes is parsed incorrectly

        Test: http/tests/misc/redirect-with-quotes.php

        * WebCore.xcodeproj/project.pbxproj:
        Added HTTPParsers.{h,cpp}. I intend to move Content-Type parsing here, as well.

        * dom/Document.cpp:
        (WebCore::Document::processHttpEquiv):
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::receivedFirstData):
        Use the new implementation in HTTPHeaders.

        * platform/network/HTTPParsers.cpp: Added.
        (WebCore::skipWhiteSpace):
        (WebCore::parseHTTPRefresh):
        * platform/network/HTTPParsers.h: Added.
        Merged and rewrote existing implementations for better Firefox compatibility.

2006-12-08  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Tim H.

        http://bugs.webkit.org/show_bug.cgi?id=11772
        REGRESSION: XMLSerializer.serializeToString incorrect value for CDATA nodes

        Test: fast/dom/serialize-cdata.html

        * editing/markup.cpp:
        (WebCore::startMarkup): Dump CDATA sections, too.

2006-12-08  Mitz Pettel  <mitz@webkit.org>

        Reviewed by hyatt.

        Deleted misplaced comment.

        * rendering/RenderWidget.cpp:

2006-12-08  Rob Buis  <buis@kde.org>

        Reviewed by Darin.

        http://bugs.webkit.org/show_bug.cgi?id=6074
        WebKit+SVG and FireFox disagree on invalid "transform" handling

        Test for parsing failure on transform attribute and clear the transform
        list upon failure to match FF behaviour.

        * ksvg2/svg/SVGGradientElement.cpp:
        (WebCore::SVGGradientElement::parseMappedAttribute):
        * ksvg2/svg/SVGPatternElement.cpp:
        (WebCore::SVGPatternElement::parseMappedAttribute):
        * ksvg2/svg/SVGStyledTransformableElement.cpp:
        (WebCore::SVGStyledTransformableElement::parseMappedAttribute):
        * ksvg2/svg/SVGTextElement.cpp:
        (WebCore::SVGTextElement::parseMappedAttribute):
        * ksvg2/svg/SVGTransformable.cpp:
        (WebCore::SVGTransformable::parseTransformAttribute):
        * ksvg2/svg/SVGTransformable.h:

2006-12-07  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Beth Dakin.

        Fixed <rdar://problem/4870551> 9A320: <input type="text"> no longer 
        dispatches onchange event in response to enter key
        
        To match our old behavior and FF, we need to dispatch onchange in response to the
        ENTER key. The strategy here is just to dispatch a blur event, since that's how
        the search field always worked, and the DOM spec says onchange only fires
        as a precursor to blur.

        * ChangeLog:
        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::defaultEventHandler):

2006-12-07  Adam Roben  <aroben@apple.com>

        Reviewed by Oliver.

        Some small context menu-related fixes.

        * html/HTMLFrameSetElement.cpp:
        (WebCore::HTMLFrameSetElement::defaultEventHandler): Don't try to
        resize on a contextmenuEvent.
        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::defaultEventHandler): Only pass the event
        off to HTMLGenericFormElement if we haven't handled it.

2006-12-07  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Darin.

        <rdar://problem/4838778>
        Title: DashboardClient crashing in WebCore::SubresourceLoader::didFail
        
        * loader/SubresourceLoader.cpp:
        (WebCore::SubresourceLoader::stopLoading):
        * loader/SubresourceLoader.h:
        Add stopLoading method which currently just clears the client. This isn't the ideal fix,
        since it doesn't actually stop the load.
        
        * loader/mac/SubresourceLoaderMac.mm:
        (WebCore::SubresourceLoader::willSendRequest):
        (WebCore::SubresourceLoader::didReceiveResponse):
        (WebCore::SubresourceLoader::didReceiveData):
        (WebCore::SubresourceLoader::didFinishLoading):
        (WebCore::SubresourceLoader::didFail):
        (WebCore::SubresourceLoader::didCancel):
        Add null-checks.
        
        * xml/xmlhttprequest.cpp:
        (WebCore::XMLHttpRequest::abort):
        Call stopLoading.

2006-12-07  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Geof.

        - added the ability to set the auto repeating variable to force a keyPressed
        event from a keyDown event.

        * platform/PlatformKeyboardEvent.h:
        (WebCore::PlatformKeyboardEvent::setIsAutoRepeat):

2006-12-07  Don Gibson  <dgibson77@gmail.com>

        Reviewed by Darin.

        http://bugs.webkit.org/show_bug.cgi?id=11749
        Don't call updateThumbProportion() unnecessarily.

        * platform/ScrollBar.cpp:
        (WebCore::Scrollbar::setProportion):

2006-12-07  Beth Dakin  <bdakin@apple.com>

        Reviewed by Brady.

        Fixes "Open in new Window" item in WebCore ContextMenus. It wasn't 
        doing anything before, and now it works! Also some formatting 
        changes, etc.

        * page/ContextMenuClient.h: Several of the parameters to several of 
        the functions here should be const or const references. And now 
        they are!
        * page/ContextMenuController.cpp:
        (WebCore::openNewWindow): Moved the open new window functionality 
        into a helper function since it is used by several menu item tags. 
        Now after calling chrome()->createWindow() we call chrome()->show() 
        on the new window, and so it appears!
        (WebCore::ContextMenuController::contextMenuItemSelected): Call new 
        openNewWindow function to do the right thing. Shift some 
        formatting, use local variable for HitTestResult. Implement action 
        for ContextMenuItemTagOpenLink.

2006-12-06  Kevin McCullough  <KMcCullough@apple.com>

        Reviewed by.

        - Removed a conflict marker

        * ChangeLog:

2006-12-06  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by darin
        
        <rdar://problem/4818134>
        Crash in WebCore::selectRange when invoking WebView:insertNewLine in any empty content editable DIV.

        * WebCore.vcproj/WebCore/WebCore.vcproj: Removed RebalanceWhitespaceCommand.*.
        * editing/visible_units.cpp:
        (WebCore::startOfLine): There are VisiblePositions at offset 0 in blocks without
        RootInlineBoxes, like empty editable blocks and bordered blocks.
        (WebCore::endOfLine): Ditto.
        
2006-12-06  Kevin McCullough  <KMcCullough@apple.com>

        Reviewed by.

        - Removed a conflict marker

        * ChangeLog:

2006-12-06  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by john
        
        <rdar://problem/4854869>
        Inserting a new line in a contenteditable=true SPAN whose parent is a DIV asserts

        * editing/htmlediting.cpp:
        (WebCore::enclosingBlock): Use enclosingNodeWithType to prevent escape
        from editable content.
        * editing/markup.cpp:
        (WebCore::createMarkup): A null commonAncestorBlock will happen
        if commonAncestor is inside an inline editable root that doesn't
        contain any blocks.  Removed an early return for this case: the 
        code below the early return can and must handle it.

2006-12-06  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Mark Rowe.

        <rdar://problem/4843505> Fix cross-library ivar use for 64-bit Objective-C

        Adds a new WebCore.LP64.exp file that gets appended to the normal export file.
        This new file will have 64-bit only symbols we need to export.

        * WebCore.LP64.exp: Added.
        * WebCore.xcodeproj/project.pbxproj:

2006-12-06  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Maciej.
        
        Change SubresourceLoader to use a ResourceHandle, and change ResourceHandle to use a NSURLConnection.
        
        * loader/ResourceLoader.h:
        * loader/SubresourceLoader.cpp:
        (WebCore::SubresourceLoader::create):
        (WebCore::SubresourceLoader::didReceiveData):
        (WebCore::SubresourceLoader::didFinishLoading):
        (WebCore::SubresourceLoader::didFail):
        * loader/SubresourceLoader.h:
        (WebCore::SubresourceLoader::didReceiveAuthenticationChallenge):
        (WebCore::SubresourceLoader::didCancelAuthenticationChallenge):
        (WebCore::SubresourceLoader::willStopBufferingData):
        (WebCore::SubresourceLoader::willCacheResponse):
        (WebCore::SubresourceLoader::receivedCredential):
        (WebCore::SubresourceLoader::receivedRequestToContinueWithoutCredential):
        (WebCore::SubresourceLoader::receivedCancellation):
        * loader/SubresourceLoaderClient.h:
        (WebCore::SubresourceLoaderClient::didFail):
        * loader/icon/IconLoader.cpp:
        (WebCore::IconLoader::didFail):
        * loader/icon/IconLoader.h:
        * loader/loader.cpp:
        (WebCore::Loader::didFail):
        * loader/loader.h:
        * loader/mac/ResourceLoaderMac.mm:
        (WebCore::ResourceLoader::ResourceLoader):
        (WebCore::ResourceLoader::addData):
        (WebCore::ResourceLoader::resourceData):
        * loader/mac/SubresourceLoaderMac.mm:
        (WebCore::SubresourceLoader::SubresourceLoader):
        (WebCore::SubresourceLoader::setDefersLoading):
        (WebCore::SubresourceLoader::resourceData):
        (WebCore::SubresourceLoader::load):
        (WebCore::SubresourceLoader::create):
        (WebCore::SubresourceLoader::willSendRequest):
        (WebCore::SubresourceLoader::didReceiveResponse):
        (WebCore::SubresourceLoader::didReceiveData):
        (WebCore::SubresourceLoader::didFinishLoading):
        (WebCore::SubresourceLoader::didFail):
        (WebCore::SubresourceLoader::didCancel):
        * platform/network/ResourceHandle.cpp:
        (WebCore::ResourceHandle::ResourceHandle):
        (WebCore::ResourceHandle::create):
        * platform/network/ResourceHandle.h:
        * platform/network/ResourceHandleClient.h:
        (WebCore::ResourceHandleClient::didReceiveData):
        (WebCore::ResourceHandleClient::didFail):
        (WebCore::ResourceHandleClient::didReceiveAuthenticationChallenge):
        (WebCore::ResourceHandleClient::didCancelAuthenticationChallenge):
        (WebCore::ResourceHandleClient::willStopBufferingData):
        (WebCore::ResourceHandleClient::willCacheResponse):
        (WebCore::ResourceHandleClient::receivedCredential):
        (WebCore::ResourceHandleClient::receivedRequestToContinueWithoutCredential):
        (WebCore::ResourceHandleClient::receivedCancellation):
        * platform/network/ResourceHandleInternal.h:
        (WebCore::ResourceHandleInternal::ResourceHandleInternal):
        * platform/network/mac/ResourceHandleMac.mm:
        (WebCore::ResourceHandle::~ResourceHandle):
        (WebCore::ResourceHandle::start):
        (WebCore::ResourceHandle::cancel):
        (WebCore::ResourceHandle::setDefersLoading):
        (WebCore::ResourceHandle::delegate):
        (WebCore::ResourceHandle::releaseDelegate):
        (WebCore::ResourceHandle::supportsBufferedData):
        (WebCore::ResourceHandle::bufferedData):
        (-[WebCoreResourceHandleAsDelegate initWithHandle:]):
        (-[WebCoreResourceHandleAsDelegate detachHandle]):
        (-[WebCoreResourceHandleAsDelegate connection:willSendRequest:redirectResponse:]):
        (-[WebCoreResourceHandleAsDelegate connection:didReceiveAuthenticationChallenge:]):
        (-[WebCoreResourceHandleAsDelegate connection:didCancelAuthenticationChallenge:]):
        (-[WebCoreResourceHandleAsDelegate connection:didReceiveResponse:]):
        (-[WebCoreResourceHandleAsDelegate connection:didReceiveData:lengthReceived:]):
        (-[WebCoreResourceHandleAsDelegate connection:willStopBufferingData:]):
        (-[WebCoreResourceHandleAsDelegate connectionDidFinishLoading:]):
        (-[WebCoreResourceHandleAsDelegate connection:didFailWithError:]):
        (-[WebCoreResourceHandleAsDelegate connection:willCacheResponse:]):
        (-[WebCoreResourceHandleAsDelegate useCredential:forAuthenticationChallenge:]):
        (-[WebCoreResourceHandleAsDelegate continueWithoutCredentialForAuthenticationChallenge:]):
        (-[WebCoreResourceHandleAsDelegate cancelAuthenticationChallenge:]):
        * xml/xmlhttprequest.cpp:
        (WebCore::XMLHttpRequest::didFail):
        * xml/xmlhttprequest.h:

2006-12-06  Beth Dakin  <bdakin@apple.com>

        Reviewed by Adam.

        There are two bugs with WebCore ContextMenus due to the static 
        ContextMenuItems. One bug is that we often crashed in 
        NSAutoreleasePool upon quitting the browser. The other bug is that 
        we were adding static NSMenuItems to multiple NSMenus, which is 
        disallowed. To fix these bugs, the MenuItems are no longer static. 
        This is in line with the current design in WebKit anyway. I made 
        some re-arrangements in the code because I also removed the macro 
        that was used to create the menu items since it was a bit 
        confusing.

        * platform/ContextMenu.cpp:
        (WebCore::createFontSubMenu):
        (WebCore::createSpellingAndGrammarSubMenu):
        (WebCore::createSpellingSubMenu):
        (WebCore::createSpeechSubMenu):
        (WebCore::createWritingDirectionSubMenu):
        (WebCore::ContextMenu::populate):
        * platform/ContextMenuItem.h:
        * platform/mac/ContextMenuItemMac.mm:
        (WebCore::ContextMenuItem::ContextMenuItem): Use the NSMenuItem 
        global separator item if we have SeparatorType.
        * platform/mac/ContextMenuMac.mm:
        (WebCore::setMenuItemTarget):  Change name of getNSMenuItem since 
        that is no longer accurate.
        (WebCore::ContextMenu::appendItem): Above name change.
        (WebCore::ContextMenu::insertItem): Same.

2006-12-06  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Geof.

        - Returned the semantic meaning of the mask to be the actual repeat count,
        and changed auto_repeat to correctly differnetiate between keypressed and keydown.

        * platform/win/KeyEventWin.cpp:
        (WebCore::PlatformKeyboardEvent::PlatformKeyboardEvent):

2006-12-06  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by harrison
        
        <rdar://problem/4753545>
        REGRESSION: Edited whitespace sequences are all nbsps (10636)

        * WebCore.xcodeproj/project.pbxproj: Removed RebalanceWhitespaceCommand.* from the project.
        * editing/CompositeEditCommand.cpp:
        (WebCore::isWhitespace): Moved from htmlediting.
        (WebCore::CompositeEditCommand::rebalanceWhitespaceAt): Moved the work that was
        once done in its own command here.  
        (WebCore::CompositeEditCommand::prepareWhitespaceAtPositionForSplit): Prevents
        whitespace around a position from collapsing when it's pushed apart during Paste.
        This function can eventually be deployed to eliminate the need for leading/trailing 
        whitespace handling in InsertParagraphSeparator, InsertLineBreak, Delete, and BreakBlockquote.
        (WebCore::CompositeEditCommand::rebalanceWhitespace): Cleaned up.
        * editing/CompositeEditCommand.h:
        * editing/DeleteSelectionCommand.cpp:
        (WebCore::DeleteSelectionCommand::doApply): Do rebalanceWhitespaceAt *before*
        saving the typing style, because whitespace rebalancing is no longer it's own
        command that claims to preserve the typing style.
        * editing/RebalanceWhitespaceCommand.cpp: Removed.
        * editing/RebalanceWhitespaceCommand.h: Removed.
        * editing/ReplaceSelectionCommand.cpp:
        (WebCore::ReplaceSelectionCommand::doApply): Moved the code to prepare whitespace
        arond a position for being pushed aparat to its own method.
        * editing/htmlediting.cpp:
        (WebCore::stringWithRebalancedWhitespace): Added.  Returns a rebalanced string.
        Takes in whether or not the beginning of that string will be at the start of
        a paragraph, because a space at such a position must have be nbsp, even if
        that doesn't follow the nbsp/space pattern used.  Similar stuff for the end 
        of a paragraph.
        * editing/htmlediting.h:
        * editing/markup.cpp:
        (WebCore::fillContainerFromString): Call stringWithRelabacedWhitespace.  Pass 
        it the startOfParagraph/endOfParagraph bools.

2006-12-05  John Sullivan  <sullivan@apple.com>

        Reviewed by Beth

        Moved spelling and grammar code from Frame to Editor

        * WebCore.exp:
        updated for these changes

        * page/Frame.h:
        removed declarations of spelling and grammar functions

        * bridge/mac/FrameMac.h:
        removed declarations of spelling and grammar functions

        * bridge/mac/FrameMac.mm:
        moved implementation of spelling and grammar functions from here
        (WebCore::FrameMac::respondToChangedSelection):
        updated for moved functions

        * editing/Editor.h:
        moved declarations of spelling and grammar functions to here

        * editing/mac/EditorMac.mm:
        moved implementation of spelling and grammar functions to here; changed
        only to make it compile (e.g. removing "editor()->" and adding "frame()->"
        where appropraite.
        (WebCore::findFirstMisspellingInRange):
        (WebCore::paragraphAlignedRangeForRange):
        (WebCore::findFirstGrammarDetailInRange):
        (WebCore::findFirstBadGrammarInRange):
        (WebCore::Editor::advanceToNextMisspelling):
        (WebCore::Editor::isSelectionMisspelled):
        (WebCore::isRangeUngrammatical):
        (WebCore::Editor::isSelectionUngrammatical):
        (WebCore::Editor::guessesForUngrammaticalSelection):
        (WebCore::core):
        (WebCore::Editor::guessesForMisspelledSelection):
        (WebCore::Editor::markMisspellingsInAdjacentWords):
        (WebCore::markAllMisspellingsInRange):
        (WebCore::markAllBadGrammarInRange):
        (WebCore::Editor::markMisspellings):

        * platform/ContextMenu.cpp:
        (WebCore::ContextMenu::populate):
        updated for moved functions

        * editing/TypingCommand.cpp:
        (WebCore::TypingCommand::markMisspellingsAfterTyping):
        updated for moved functions

2006-12-05  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Maciej.

        General cleanup, get rid of PlatformResponse (we have ResourceResponse now)
        and remove a couple of functions that were unused.

        * loader/CachedResource.h:
        * loader/LoaderFunctions.h:
        * loader/mac/LoaderFunctionsMac.mm:
        * platform/network/ResourceHandle.h:
        * platform/network/ResourceHandleClient.h:
        * platform/network/mac/ResourceHandleMac.mm:
        (WebCore::ResourceHandle::~ResourceHandle):

2006-12-05  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by John.

        - keydown is now a keydown event instead of a keypress event.
          Fixes some form submission oddities.

        * platform/win/KeyEventWin.cpp:

2006-12-05  John Sullivan  <sullivan@apple.com>

        Tiger build fix

        * editing/mac/EditorMac.mm:
        declare -[NSSpellChecker learnWord:], on Tiger only (it's API on Leopard)

2006-12-05  John Sullivan  <sullivan@apple.com>

        Reviewed by Geoff Garen

        * page/Frame.h:
        remove declarations of ignoreSpelling() and learnSpelling()

        * bridge/mac/FrameMac.h:
        remove declarations of ignoreSpelling() and learnSpelling()
        * bridge/mac/FrameMac.mm:
        moved implementations of ignoreSpelling() and learnSpelling() from here

        * editing/Editor.h:
        added declarations of ignoreSpelling() and learnSpelling()

        * editing/mac/EditorMac.mm:
        (WebCore::Editor::ignoreSpelling):
        moved here from FrameMac.mm
        (WebCore::Editor::learnSpelling):
        ditto

        * page/ContextMenuController.cpp:
        (WebCore::ContextMenuController::contextMenuItemSelected):
        updated callers to use frame()->editor() rather than frame()

2006-12-05  John Sullivan  <sullivan@apple.com>

        Reviewed by Adam

        New context-menu mechanism fix for:
        <rdar://problem/4864351> Should leave out "No Guesses Found" from context menu for bad grammar

        * platform/ContextMenu.cpp:
        (WebCore::ContextMenu::populate):
        Leave out "No Guesses Found" and separator for grammar-checking case.

2006-12-05  Rob Buis  <buis@kde.org>

        Reviewed by Mitz.

        http://bugs.webkit.org/show_bug.cgi?id=11686
        WebKit draws Carto.net tabgroup example completely incorrectly (ff does fine)

        Make sure the SVG render objects are laid out before measuring their 
        dimensions using relativeBBox.

        * ksvg2/svg/SVGLocatable.cpp:
        (WebCore::SVGLocatable::getBBox):

2006-12-05  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin

        Grammar/Spelling code re-homing, baby step one: put isGrammarCheckingEnabled in Editor
        since that's where isContinousSpellCheckingEnabled lives.

        * editing/Editor.h:
        * editing/Editor.cpp:
        (WebCore::Editor::isGrammarCheckingEnabled):
        new method, calls through to client a la isContinuousSpellCheckingEnabled

        * bridge/mac/FrameMac.mm:
        (WebCore::FrameMac::advanceToNextMisspelling):
        call editor() rather than editor()->client()
        (WebCore::FrameMac::markMisspellings):
        ditto

        * platform/ContextMenu.cpp:
        (WebCore::ContextMenu::populate):
        ditto

2006-12-05  Darin Adler  <darin@apple.com>

        Reviewed by Geoff.

        - a little cleanup

        * html/HTMLInputElement.h: Removed unneeded includes of RenderObject.h
        and RenderStyle.h.
        * html/HTMLSelectElement.h: Removed unneeded include of RenderStyle.h.
        * ksvg2/svg/SVGStyledElement.h: Removed unneeded include of RenderStyle.h.

        * ksvg2/svg/SVGSVGElement.h: Remove unneeded parameter to createSVGPoint.
        * ksvg2/svg/SVGSVGElement.cpp: (WebCore::SVGSVGElement::createSVGPoint):
        Ditto.

        * ksvg2/scripts/generateJSBindings.pl: Removed unused script.

2006-12-05  Darin Adler  <darin@apple.com>

        * doc: Removed empty directory. It's not clear this is a good place for
        documentation, so lets add it back later if we actually start using it.

2006-12-05  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Brady, Darin.

        * loader/loader.cpp:
        (WebCore::Loader::receivedAllData):
        Remove ref() call that was left around by mistake.

2006-12-05  Sam Weinig  <sam@webkit.org>

        Reviewed by Tim H.

        Fix for http://bugs.webkit.org/show_bug.cgi?id=11758
        Don't compile custom SVG and XSLT bindings in non-svg build

        * bindings/js/JSSVGNumber.cpp:
        * bindings/js/JSSVGNumber.h:
        * bindings/js/JSSVGPoint.cpp:
        * bindings/js/JSSVGPoint.h:
        * bindings/js/JSSVGRect.cpp:
        * bindings/js/JSSVGRect.h:
        * bindings/js/JSXSLTProcessor.cpp:
        * bindings/js/JSXSLTProcessor.h:

2006-12-04  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin

        WebCore part of fix for:
        <rdar://problem/4817188> Context menu for bad grammar should include suggestions and "Ignore Grammar"

        The context menu mechanism is currently in flux; the old mechanism is still in place, but an
        up-and-coming new mechanism is waiting in the wings. I updated both of them, but couldn't
        test the new mechanism because it doesn't work well enough yet. Also, some of this code 
        should move from Frame to Editor, but that will wait for another checkin.

        * page/Frame.h:
        added pure virtual function declarations for isSelectionUngrammatical() and guessesForUngrammaticalSelection()

        * bridge/mac/FrameMac.h:
        added virtual functions declarations for isSelectionUngrammatical() and guessesForUngrammaticalSelection()

        * bridge/mac/FrameMac.mm:
        (WebCore::FrameMac::isSelectionMisspelled):
        now updates spelling panel (whether or not it's showing), since this is now needed to make -[NSSSpellChecker
        ignoreWord:inSpellDocumentWithTag:] work correctly
        (WebCore::isRangeUngrammatical):
        new function, helper used by both isSelectionUngrammatical() and guessesForUngrammaticalSelection()
        (WebCore::FrameMac::isSelectionUngrammatical):
        new function, calls isRangeUngrammatical
        (WebCore::FrameMac::guessesForUngrammaticalSelection):
        ditto

        * platform/ContextMenu.cpp:
        (WebCore::ContextMenu::populate):
        now considers bad grammar as well as misspellings
        
        * platform/ContextMenuItem.h:
        added ContextMenuItemTagIgnoreGrammar
        
2006-12-05  Kirby White  <KWhiteRight@gmail.com>

        Reviewed, tweaked and landed by Alexey.

        <http://bugs.webkit.org/show_bug.cgi?id=11639> Form buttons don't look different when clicked

        * rendering/RenderThemeWin.cpp:
        (WebCore::RenderThemeWin::determineState): Moved test for active 
        state before test for hover state, since active should override hover 
        when both are true.

        * platform/gdk/RenderThemeGdk.cpp: 
        (WebCore::RenderThemeGdk::determineState): Same fix.

2006-12-05  Kirby White  <KWhiteRight@gmail.com>

        Reviewed and landed by Alexey.

        http://bugs.webkit.org/show_bug.cgi?id=11681
        Don't select the first option when resetting a listbox-style form 
        control (i.e., a multi-select control or one with size > 1) that
        has no default selection.

        Test: fast/dom/HTMLSelectElement/listbox-select-reset.html

        * html/HTMLSelectElement.cpp:
        (WebCore::HTMLSelectElement::reset):

2006-12-05  Lars Naesbye Christensen  <lars@naesbye.dk>

        Reviewed and landed by Alexey.

        http://bugs.webkit.org/show_bug.cgi?id=11752
        [CSS 3] missing support for cursor selector 'copy'

        * Resources/copyCursor.png: Added.
        * WebCore.xcodeproj/project.pbxproj:
        * css/CSSComputedStyleDeclaration.cpp:
        (WebCore::CSSComputedStyleDeclaration::getPropertyCSSValue):
        * css/CSSValueKeywords.in:
        * manual-tests/cursor.html:
        * page/EventHandler.cpp:
        (WebCore::selectCursor):
        * platform/Cursor.h:
        * platform/mac/CursorMac.mm:
        (WebCore::copyCursor):
        * rendering/RenderStyle.h:
        (WebCore::):

2006-12-04  Beth Dakin  <bdakin@apple.com>

        Reviewed by Geoff.

        Fix from last check-in. This line was badbad.

        * platform/mac/ContextMenuMac.mm:
        (WebCore::ContextMenu::~ContextMenu):

2006-12-04  Beth Dakin  <bdakin@apple.com>

        Reviewed by Geoff.

        With the new changes to ContextMenuItems, WebCore context menus 
        stopped appearing at all. And then when I got them to appear, they 
        crashed. This fixes both of these problems.

        * platform/mac/ContextMenuItemMac.mm:
        (WebCore::ContextMenuItem::ContextMenuItem): keyEquivalent cannot 
        be nil. This was causing Obj-C to throw an exception preventing the 
        menus from popping up at all. 
        * platform/mac/ContextMenuMac.mm:
        (+[WebCoreMenuTarget sharedMenuTarget]): Re-name our static 
        MenuTarget so that it is more clear that it is a static and shared 
        WebCoreMenuTarget.
        (WebCore::ContextMenu::ContextMenu): Initialize the 
        WebCoreMenuTarget's controller in the ContextMenu constructor 
        instead of in getNSMenuItem since the controller will only possibly 
        change when a new ContextMenu has been created.
        (WebCore::ContextMenu::~ContextMenu): Set the target's controller 
        to 0.
        (WebCore::getNSMenuItem): A lot of this work is being done other 
        places now. Call new class method on WebCoreMenuTarget to get the 
        shared target.
        (WebCore::ContextMenu::appendItem): We should not be releasing the 
        menuItem here! This caused the crashes I saw.
        (WebCore::ContextMenu::insertItem): Same.

2006-12-04  Anders Carlsson  <acarlsson@apple.com>

        Fix the build.
        
        * loader/mac/SubresourceLoaderMac.mm:
        (WebCore::SubresourceLoader::~SubresourceLoader):
        Add back the destructor.

2006-12-04  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Darin.
        
        Change all ResourceHandleClients to be SubresourceLoaderClients instead. Also,
        make SubresourceLoader a ResourceHandleClient. This is a first step towards turning ResourceHandle into a 
        standalone class which doesn't need to know about SubresourceLoader.

        * WebCore.xcodeproj/project.pbxproj:
        * loader/ResourceLoader.cpp:
        (WebCore::ResourceLoader::~ResourceLoader):
        (WebCore::ResourceLoader::ResourceLoader):
        (WebCore::ResourceLoader::setDefersLoading):
        * loader/SubresourceLoader.cpp:
        (WebCore::SubresourceLoader::SubresourceLoader):
        (WebCore::SubresourceLoader::~SubresourceLoader):
        (WebCore::SubresourceLoader::create):
        (WebCore::SubresourceLoader::willSendRequest):
        (WebCore::SubresourceLoader::didReceiveResponse):
        (WebCore::SubresourceLoader::didReceiveData):
        (WebCore::SubresourceLoader::didFinishLoading):
        (WebCore::SubresourceLoader::didFailWithError):
        (WebCore::SubresourceLoader::receivedAllData):
        * loader/SubresourceLoader.h:
        (WebCore::SubresourceLoader::loaderAsResourceHandleClient):
        (WebCore::SubresourceLoader::handle):
        * loader/SubresourceLoaderClient.h: Added.
        (WebCore::SubresourceLoaderClient::~SubresourceLoaderClient):
        (WebCore::SubresourceLoaderClient::willSendRequest):
        (WebCore::SubresourceLoaderClient::didReceiveResponse):
        (WebCore::SubresourceLoaderClient::didReceiveData):
        (WebCore::SubresourceLoaderClient::didFinishLoading):
        (WebCore::SubresourceLoaderClient::didFailWithError):
        (WebCore::SubresourceLoaderClient::receivedAllData):
        * loader/icon/IconLoader.cpp:
        (WebCore::IconLoader::startLoading):
        (WebCore::IconLoader::stopLoading):
        (WebCore::IconLoader::didReceiveResponse):
        (WebCore::IconLoader::didReceiveData):
        (WebCore::IconLoader::didFailWithError):
        (WebCore::IconLoader::didFinishLoading):
        (WebCore::IconLoader::clearLoadingState):
        * loader/icon/IconLoader.h:
        * loader/loader.cpp:
        (WebCore::Loader::servePendingRequests):
        (WebCore::Loader::receivedAllData):
        (WebCore::Loader::didFailWithError):
        (WebCore::Loader::didReceiveResponse):
        (WebCore::Loader::didReceiveData):
        (WebCore::Loader::cancelRequests):
        * loader/loader.h:
        * loader/mac/SubresourceLoaderMac.mm:
        (WebCore::SubresourceLoader::SubresourceLoader):
        (WebCore::SubresourceLoader::create):
        (WebCore::SubresourceLoader::willSendRequest):
        (WebCore::SubresourceLoader::didReceiveResponse):
        (WebCore::SubresourceLoader::didReceiveData):
        (WebCore::SubresourceLoader::didFinishLoading):
        (WebCore::SubresourceLoader::didFail):
        (WebCore::SubresourceLoader::didCancel):
        * platform/network/ResourceHandle.cpp:
        (WebCore::ResourceHandle::ResourceHandle):
        (WebCore::ResourceHandle::create):
        * platform/network/ResourceHandle.h:
        * platform/network/ResourceHandleClient.h:
        * platform/network/ResourceHandleInternal.h:
        (WebCore::ResourceHandleInternal::ResourceHandleInternal):
        * platform/network/mac/ResourceHandleMac.mm:
        (WebCore::ResourceHandle::start):
        (WebCore::ResourceHandle::finishJobAndHandle):
        (WebCore::ResourceHandle::loader):
        * xml/xmlhttprequest.cpp:
        (WebCore::XMLHttpRequest::send):
        (WebCore::XMLHttpRequest::didFailWithError):
        (WebCore::XMLHttpRequest::didFinishLoading):
        (WebCore::XMLHttpRequest::willSendRequest):
        (WebCore::XMLHttpRequest::didReceiveResponse):
        (WebCore::XMLHttpRequest::didReceiveData):
        * xml/xmlhttprequest.h:

2006-12-04  Darin Adler  <darin@apple.com>

        Reviewed by Adele.

        - fix another part of http://bugs.webkit.org/show_bug.cgi?id=11628
          REGRESSION (r17597): Command-return in text fields doesn't open a new tab or window

        This fixes command-return when the focus is on a link.
        Despite the title of the bug, Mitz wanted me to fix both, and I will not
        say no to him!

        Test: fast/events/simulated-key-state.html

        * dom/EventTargetNode.cpp:
        (WebCore::EventTargetNode::dispatchSimulatedMouseEvent): Instead of always passing
        false for all the key state in simulated mouse events, pass the state from the
        first underlying event in the chain that has key state; in the case in the bug,
        the keyboard event will be the underlying event itself and we'll propagate the
        alt key modifier to the mouse event, resulting in the effect we want. It's nice
        that JavaScript also gets to see the proper modifiers in the mouse event.

        * html/HTMLAnchorElement.cpp: (WebCore::HTMLAnchorElement::defaultEventHandler):
        Added code to pass in an underlying event to dispatchSimulatedClick. After looking
        at all the other callers, this seems to be the only one that needs to pass an
        event that is currently passing 0. Also removed the code that only simulated a
        click when the event has a PlatformKeyboardEvent -- no reason for that and it
        prevented me from writing a layout test for the fix. 

        * dom/UIEventWithKeyState.h: Added findEventWithKeyState function that walks the
        underlyingEvent chain to find the first event that has key state. This already
        existed in WebKit, but I wanted to use it in dispatchSimulatedMouseEvent.
        * dom/UIEventWithKeyState.cpp: Added.

        * CMakeLists.txt: Added UIEventWithKeyState.cpp.
        * WebCore.vcproj/WebCore/WebCore.vcproj: Added UIEventWithKeyState.cpp.
        * WebCore.xcodeproj/project.pbxproj: Added UIEventWithKeyState.cpp.
        * WebCoreSources.bkl: Added UIEventWithKeyState.cpp.

        * WebCore.exp: Added findEventWithKeyState, used by WebKit.

2006-12-04  Kevin McCullough  <KMcCullough@apple.com>

        Reviewed by Darin.

        - rdar://problem/4833935
        - removed the guards for the "multiple forms submission" issue, which may not be
          an issue anymore and the guards prevent perfectly legitimate websites from
          working correctly.

        * bridge/mac/FrameMac.mm:
        (WebCore::FrameMac::setView):
        * bridge/mac/WebCoreAXObject.mm:
        (-[WebCoreAXObject accessibilityPerformAction:]):
        * bridge/win/FrameWin.cpp:
        (WebCore::FrameWin::keyPress):
        * config.h:
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::submitForm):
        * loader/FrameLoader.h:
        * loader/mac/FrameLoaderMac.mm:
        (WebCore::FrameLoader::receivedMainResourceError):
        * loader/qt/FrameLoaderQt.cpp:
        (WebCore::FrameLoader::submitForm):
        * page/Frame.cpp:
        (WebCore::Frame::setView):
        * page/mac/EventHandlerMac.mm:
        (WebCore::EventHandler::keyEvent):
        (WebCore::EventHandler::mouseDown):
        * platform/qt/FrameQt.cpp:
        (WebCore::FrameQt::keyEvent):

2006-12-02  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Darin Adler.
        
        Added support for Dashboard backward compatibility mode.
        
        * html/CanvasRenderingContext2D.cpp:
        (WebCore::CanvasRenderingContext2D::stroke): Added support for old behavior
        of automatically clearing the stroke path buffer after a call to stroke().
        * html/HTMLCanvasElement.cpp: Added supoprt for old behavior of the canvas
        tag being self-closing.
        (WebCore::HTMLCanvasElement::endTagRequirement):
        (WebCore::HTMLCanvasElement::tagPriority):
        * html/HTMLCanvasElement.h:
        * html/HTMLParser.cpp: Ditto.
        (WebCore::HTMLParser::canvasCreateErrorCheck):
        * xml/xmlhttprequest.cpp: Added support for old behavior of silently ignoring
        a call to setRequestHeader() if it preceded a call to open() or followed a call
        to send().
        (WebCore::XMLHttpRequest::setRequestHeader):

2006-12-04  Darin Adler  <darin@apple.com>

        Reviewed by Alice.

        * bridge/EditorClient.h: Removed "_web_" prefix from
        C++ userVisibleString member function. Alice will probably change
        this so it's not on the editor client any more later.

        * editing/Editor.h: Removed "_web_" prefix from
        C++ userVisibleString member function.
        * editing/Editor.cpp: Tweaked formatting a bit. Removed Mac-specific
        code from this file.

        * editing/mac/EditorMac.mm:
        (WebCore::Editor::newGeneralClipboard): Removed unnneded local variable.
        (WebCore::Editor::userVisibleString): Moved this function here.

        * platform/Pasteboard.h: Added some FIXMEs. Removed unneeded includes.
        Made Pasteboard noncopyable. Removed use of "protected" where we should
        be using "private". Removed s_generalPasteboard.
        * platform/mac/PasteboardMac.mm: Added some FIXMEs. Removed the
        s_generalPasteboard global. Removed the unused destructor. Updated call
        to userVisibleString for name change. Tweaked formatting.

2006-12-04  Alice Liu  <alice.liu@apple.com>

        Reviewed by Oliver.

        Moved some constants from EventHandlerMac.mm to EventHandler.cpp
        Added some platform-specific data members and functions.

        * page/EventHandler.cpp:
        * page/EventHandler.h:
        * page/mac/EventHandlerMac.mm:
        * platform/PlatformMouseEvent.h:
        (WebCore::):
        (WebCore::PlatformMouseEvent::timestamp):
        (WebCore::PlatformMouseEvent::activatedWebView):
        (WebCore::PlatformMouseEvent::type):

2006-12-04  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Darin, Geoff.

        Get rid of ResourceHandle::kill(), all it did was to balance out a ref() in ResourceHandle::start().
        We use RefPtrs to ResourceHandle instead.

        * loader/icon/IconLoader.cpp:
        (WebCore::IconLoader::~IconLoader):
        (WebCore::IconLoader::stopLoading):
        (WebCore::IconLoader::didReceiveResponse):
        * loader/loader.cpp:
        (WebCore::Loader::servePendingRequests):
        (WebCore::Loader::cancelRequests):
        (WebCore::Loader::jobForRequest):
        * loader/loader.h:
        * platform/network/ResourceHandle.cpp:
        * platform/network/ResourceHandle.h:
        * platform/network/mac/ResourceHandleMac.mm:
        (WebCore::ResourceHandle::start):
        (WebCore::ResourceHandle::finishJobAndHandle):
        (WebCore::ResourceHandle::reportError):
        * xml/xmlhttprequest.cpp:
        (WebCore::XMLHttpRequest::abort):
        (WebCore::XMLHttpRequest::didFinishLoading):

